﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using Clash_Library;

namespace Client_Packets
{
    #region Common Packets

    public struct Disconnect : Packet
    {
        public void Read(BinaryReader BReader)
        {
        }
        public void WriteTo(BinaryWriter BWriter)
        {
        }
    }
    public struct KAlive : Packet
    {
        public void Read(BinaryReader BReader)
        {
        }
        public void WriteTo(BinaryWriter BWriter)
        {
        }
    }

    #endregion
    #region Intro Packets

    public struct Login : Packet
    {
        public string AccountName;
        public string Password;
        public Login(string N, string P)
        {
            AccountName = N;
            Password = P;
        }
        public void Read(BinaryReader BReader)
        {
            AccountName = BReader.ReadString();
            Password = BReader.ReadString();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write(AccountName);
            BWriter.Write(Password);

        }
    }
    public struct NewAccount : Packet
    {
        public string AccountID;
        public string Password;
        public string Name;
        public string DateOfBirth;
        public string Question1;
        public string Answer1;
        public string Question2;
        public string Answer2;
        public string Phone;
        public string Mobile;
        public string Email;
        public NewAccount(string[] AI)
        {
            AccountID = AI[0];
            Password = AI[1];
            Name = AI[2];
            DateOfBirth = AI[3];
            Question1 = AI[4];
            Answer1 = AI[5];
            Question2 = AI[6];
            Answer2 = AI[7];
            Answer2 = AI[8];
            Phone = AI[9];
            Mobile = AI[10];
            Email = AI[11];
        }
        public void Read(BinaryReader BReader)
        {
            AccountID = BReader.ReadString();
            Password = BReader.ReadString();
            Name = BReader.ReadString();
            DateOfBirth = BReader.ReadString();
            Question1 = BReader.ReadString();
            Answer1 = BReader.ReadString();
            Question2 = BReader.ReadString();
            Answer2 = BReader.ReadString();
            Phone = BReader.ReadString();
            Mobile = BReader.ReadString();
            Email = BReader.ReadString();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            if (AccountID != null) BWriter.Write(AccountID);
            else BWriter.Write("");
            if (Password != null) BWriter.Write(Password);
            else BWriter.Write("");
            if (Name != null) BWriter.Write(Name);
            else BWriter.Write("");
            if (DateOfBirth != null) BWriter.Write(DateOfBirth);
            else BWriter.Write("");
            if (Question1 != null) BWriter.Write(Question1);
            else BWriter.Write("");
            if (Answer1 != null) BWriter.Write(Answer1);
            else BWriter.Write("");
            if (Question2 != null) BWriter.Write(Question2);
            else BWriter.Write("");
            if (Answer2 != null) BWriter.Write(Answer2);
            else BWriter.Write("");
            if (Phone != null) BWriter.Write(Phone);
            else BWriter.Write("");
            if (Mobile != null) BWriter.Write(Mobile);
            else BWriter.Write("");
            if (Email != null) BWriter.Write(Email);
            else BWriter.Write("");
        }
    }
    public struct ChangePass : Packet
    {
        public string AccountID;
        public string CPassword;
        public string NPassword;
        public ChangePass(string[] CPI)
        {
            AccountID = CPI[0];
            CPassword = CPI[1];
            NPassword = CPI[2];
        }
        public void Read(BinaryReader BReader)
        {
            AccountID = BReader.ReadString();
            CPassword = BReader.ReadString();
            NPassword = BReader.ReadString();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            if (AccountID != null) BWriter.Write(AccountID);
            else BWriter.Write("");
            if (CPassword != null) BWriter.Write(CPassword);
            else BWriter.Write("");
            if (NPassword != null) BWriter.Write(NPassword);
            else BWriter.Write("");
        }
    }
    public struct NewCharacter : Packet
    {
        public string Name;
        public Class Job;
        public Gender Sex;
        public NewCharacter(string N, Class C, Gender G)
        {
            Name = N;
            Job = C;
            Sex = G;
        }
        public void Read(BinaryReader BReader)
        {
            Name = BReader.ReadString();
            Job = (Class)BReader.ReadByte();
            Sex = (Gender)BReader.ReadByte();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write(Name);
            BWriter.Write((byte)Job);
            BWriter.Write((byte)Sex);
        }
    }
    public struct DeleteCharacter : Packet
    {
        public int CharID;
        public DeleteCharacter(int ID)
        {
            CharID = ID;
        }
        public void Read(BinaryReader BReader)
        {
            CharID = BReader.ReadInt32();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write(CharID);
        }
    }
    public struct Logout : Packet
    {
        public void Read(BinaryReader BReader)
        {
        }
        public void WriteTo(BinaryWriter BWriter)
        {
        }
    }
    public struct StartGame : Packet
    {
        public int CharID;
        public StartGame(int ID)
        {
            CharID = ID;
        }
        public void Read(BinaryReader BReader)
        {
            CharID = BReader.ReadInt32();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write(CharID);
        }
    }

    #endregion
    #region MirAction Packets

    public struct Turn : Packet
    {
        public Direction Dir;
        public Turn(Direction D)
        {
            Dir = D;
        }
        public void Read(BinaryReader BReader)
        {
            Dir = (Direction)BReader.ReadByte();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write((byte)Dir);
        }
    }
    public struct Walk : Packet
    {
        public Direction Dir;
        public Walk(Direction D)
        {
            Dir = D;
        }
        public void Read(BinaryReader BReader)
        {
            Dir = (Direction)BReader.ReadByte();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write((byte)Dir);
        }
    }
    public struct Run : Packet
    {
        public Direction Dir;
        public Run(Direction D)
        {
            Dir = D;
        }
        public void Read(BinaryReader BReader)
        {
            Dir = (Direction)BReader.ReadByte();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write((byte)Dir);
        }
    }
    public struct Harvest : Packet
    {
        public Direction Dir;
        public Harvest(Direction D)
        {
            Dir = D;
        }
        public void Read(BinaryReader BReader)
        {
            Dir = (Direction)BReader.ReadByte();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write((byte)Dir);
        }
    }
    public struct Attack : Packet
    {
        public Direction Dir;
        public Attack(Direction D)
        {
            Dir = D;
        }
        public void Read(BinaryReader BReader)
        {
            Dir = (Direction)BReader.ReadByte();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write((byte)Dir);
        }
    }
    public struct Spell : Packet
    {
        public void Read(BinaryReader BReader)
        {
        }
        public void WriteTo(BinaryWriter BWriter)
        {
        }
    }
    public struct Revive : Packet
    {
        public void Read(BinaryReader BReader)
        {
        }
        public void WriteTo(BinaryWriter BWriter)
        {
        }
    }
    #endregion
    #region Item Packets

    public struct ChangeBagSlot : Packet
    {
        public byte OldIndex, NewIndex;
        public ChangeBagSlot(byte O, byte N)
        {
            OldIndex = O;
            NewIndex = N;
        }
        public void Read(BinaryReader BReader)
        {
            OldIndex = BReader.ReadByte();
            NewIndex = BReader.ReadByte();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write(OldIndex);
            BWriter.Write(NewIndex);
        }
    }
    public struct EquipItem : Packet
    {
        public ItemLocation Loc;
        public int ItemID;
        public EquipItem(ItemLocation loc, int itemID)
        {
            Loc = loc;
            ItemID = itemID;
        }
        public void Read(BinaryReader BReader)
        {
            Loc = (ItemLocation)BReader.ReadByte();
            ItemID = BReader.ReadInt32();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write((byte)Loc);
            BWriter.Write(ItemID);
        }
    }
    public struct UnEquipItem : Packet
    {
        public int ItemID;
        public UnEquipItem(int itemID)
        {
            ItemID = itemID;
        }
        public void Read(BinaryReader BReader)
        {
            ItemID = BReader.ReadInt32();
        }
        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write(ItemID);
        }
    }
    //Pick Up
    //Drop
    //Store
    //Get from Store
    //Trade

    #endregion

    public struct Chat : Packet
    {
        public string Text;

        public Chat(string T)
        {
            Text = T;
        }

        public void Read(BinaryReader BReader)
        {
            Text = BReader.ReadString();
        }

        public void WriteTo(BinaryWriter BWriter)
        {
            BWriter.Write(Text);
        }
    }

}
