﻿using System.Collections.Generic;
using System.Drawing;

namespace Clash_Client
{
    class BackGround
    {
        public int Image;
        public bool Visible;
        public DefaultDelegate DrawAfter;
        public List<Button> ButtonList = new List<Button>();

        #region Constructor
        public BackGround(int I, bool V)
        {
            Image = I;
            Visible = V;
        }
        #endregion
        #region Methods
        public void Draw()
        {
            if (Visible)
            {
                CLib.Interface.Draw(Image, Point.Empty, false);
                DrawChildControls();
                if (DrawAfter != null) DrawAfter.Invoke();
            }
        }
        private void DrawChildControls()
        {
            foreach (Button B in ButtonList)
                B.Draw();
        }
        public void MouseDown(Point P)
        {
            foreach (Button B in ButtonList)
                if (B.MouseDown(P)) return;

        }
        public void MouseUp()
        {
            foreach (Button B in ButtonList)
                B.MouseUp();
        }

        public void Click(Point P)
        {
            foreach (Button B in ButtonList)
                if (B.Click(P)) return;

        }
        public void DoubleClick(Point P)
        {
            foreach (Button B in ButtonList)
                if (B.Click(P)) return;

        }
        public void MouseMove(Point P)
        {
            foreach (Button B in ButtonList)
                if (B.MouseMove(P)) return;

        }

        #endregion
    }
}
