﻿using System;
using System.Collections.Generic;
using System.Drawing;
using Clash_Library;

namespace Clash_Client
{
    class ItemGrid
    {
        #region Static Region
        public static Size HintSize;
        public static Item[] PItemArray;
        public static Item PItem, HItem;
        public static int PIndex;
        public static void DrawHint()
        {
            if (HItem == null) return;
            List<TextList> DrawList = new List<TextList>();
            string S;
            int A;
            Color Col = Color.White;
            Item I = HItem;
            bool Spacer = false;


            int X = 0, Y = 0, MaxX = 0, MaxY = 16;

            #region Line 1
            if (string.IsNullOrEmpty(I.CustomName))
                S = I.IInfo.Name;
            else
                S = I.CustomName;

            DrawList.Add(new TextList(S, ref X, Y, Color.White));
            if (X > MaxX) MaxX = X;

            Y += 16;
            MaxY += 16;
            X = 0;
            #endregion
            #region Line 2

            switch (I.IInfo.Type)
            {
                case ItemType.Armor:
                case ItemType.Weapon:
                case ItemType.Ring:
                case ItemType.Belt:
                case ItemType.Boots:
                case ItemType.Bracelet:
                case ItemType.Helmet:
                case ItemType.Necklace:
                case ItemType.Candle:
                    if ((I.IInfo.Effect & SpecialEffect.Indestructable) == 0)
                    {
                        S = "Durability:   ";
                        DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                        if (I.CurrentDura <= 0)
                            Col = Color.Red;
                        else
                            if (I.CurrentDura / 1000 <= 1)
                                Col = Color.Orange;

                        S = string.Format("{0}/{1}", I.CurrentDura / 1000, I.MaxDura / 1000);

                        DrawList.Add(new TextList(S, ref X, Y, Col));
                        if (X > MaxX) MaxX = X;

                        if (I.MaxDura / 1000 != I.IInfo.Durability / 1000)
                        {
                            if (I.MaxDura > I.IInfo.Durability)
                            {
                                S = string.Format(" (+{0})", I.MaxDura / 1000 - I.IInfo.Durability / 1000);
                                Col = Color.Green;
                            }
                            else if (I.MaxDura < I.IInfo.Durability)
                            {
                                S = string.Format(" ({0})", I.MaxDura / 1000 - I.IInfo.Durability / 1000);
                                Col = Color.Red;
                            }
                            else
                                Col = Color.White;
                            DrawList.Add(new TextList(S, ref X, Y, Col));
                            if (X > MaxX) MaxX = X;
                        }
                        S = "   ";
                        X += 16; //No Point Drawing Space
                        if (X > MaxX) MaxX = X;
                    }
                    break;
                case ItemType.Meat:
                case ItemType.Ore:
                    if ((I.IInfo.Effect & SpecialEffect.Indestructable) == 0)
                    {
                        S = "Quality: ";
                        DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                        S = string.Format("{0}/{1}   ", I.CurrentDura / 1000, I.MaxDura / 1000);
                        DrawList.Add(new TextList(S, ref X, Y, Color.White));
                    }
                    break;
                case ItemType.Amulet:
                case ItemType.Poison:
                    if ((I.IInfo.Effect & SpecialEffect.Indestructable) == 0)
                    {
                        S = "Useage: ";
                        DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                        S = string.Format("{0}/{1}   ", I.CurrentDura, I.MaxDura);
                        DrawList.Add(new TextList(S, ref X, Y, Color.White));
                    }
                    break;
            }

            if ((I.IInfo.Effect & SpecialEffect.Indestructable) != 0)
            {
                S = "Indestructable   ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Cyan)); if (X > MaxX) MaxX = X;
            }

            S = "Weight: ";
            DrawList.Add(new TextList(S, ref X, Y, Color.Gold));
            if (X > MaxX) MaxX = X;

            S = I.IInfo.Weight.ToString();
            DrawList.Add(new TextList(S, ref X, Y, Color.White));
            if (X > MaxX) MaxX = X;

            Y += 6;
            MaxY += 6;
            #endregion

            #region Basic Stats

            #region AC Stat
            if (I.TotalStats.Basic.AC != 0 || I.TotalStats.Basic.AC2 != 0 || I.AddedStats.Basic.AC != 0 || I.AddedStats.Basic.AC2 != 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                S = "AC: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Basic.AC != 0 || I.AddedStats.Basic.AC2 != 0) Col = Color.Cyan;
                else Col = Color.White;

                S = I.TotalStats.Basic.AC.ToString();
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                DrawList.Add(new TextList(" ~ ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                S = I.TotalStats.Basic.AC2.ToString();
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Basic.AC != 0 || I.AddedStats.Basic.AC2 != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    S = "";
                    if ((A = I.AddedStats.Basic.AC) != 0)
                        if (A > 0)
                        {
                            S = "+";
                            Col = Color.Green;
                        }
                        else
                            Col = Color.Red;
                    else
                        Col = Color.White;

                    S += A.ToString();
                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = " ~ ";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    S = "";
                    if ((A = I.AddedStats.Basic.AC2) != 0)
                        if (A > 0)
                        {
                            S = "+";
                            Col = Color.Green;
                        }
                        else
                            Col = Color.Red;
                    else
                        Col = Color.White;

                    S += A.ToString();
                    DrawList.Add(new TextList(S, ref X, Y, Col));
                    if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
            }
            #endregion
            #region MAC Stat
            if (I.TotalStats.Basic.MAC != 0 || I.TotalStats.Basic.MAC2 != 0 || I.AddedStats.Basic.MAC != 0 || I.AddedStats.Basic.MAC2 != 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                S = "MAC: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Basic.MAC != 0 || I.AddedStats.Basic.MAC2 != 0) Col = Color.Cyan;
                else Col = Color.White;

                S = I.TotalStats.Basic.MAC.ToString();
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                DrawList.Add(new TextList(" ~ ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                S = I.TotalStats.Basic.MAC2.ToString();
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Basic.MAC != 0 || I.AddedStats.Basic.MAC2 != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    S = "";
                    if ((A = I.AddedStats.Basic.MAC) != 0)
                        if (A > 0)
                        {
                            S = "+";
                            Col = Color.Green;
                        }
                        else
                            Col = Color.Red;
                    else
                        Col = Color.White;

                    S += A.ToString();
                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = " ~ ";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    S = "";
                    if ((A = I.AddedStats.Basic.MAC2) != 0)
                        if (A > 0)
                        {
                            S = "+";
                            Col = Color.Green;
                        }
                        else
                            Col = Color.Red;
                    else
                        Col = Color.White;

                    S += A.ToString();
                    DrawList.Add(new TextList(S, ref X, Y, Col));
                    if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
            }
            #endregion

            #region DC Stat
            if (I.TotalStats.Basic.DC != 0 || I.TotalStats.Basic.DC2 != 0 || I.AddedStats.Basic.DC != 0 || I.AddedStats.Basic.DC2 != 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                S = "DC: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Basic.DC != 0 || I.AddedStats.Basic.DC2 != 0) Col = Color.Cyan;
                else Col = Color.White;

                S = I.TotalStats.Basic.DC.ToString();
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                DrawList.Add(new TextList(" ~ ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                S = I.TotalStats.Basic.DC2.ToString();
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Basic.DC != 0 || I.AddedStats.Basic.DC2 != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    S = "";
                    if ((A = I.AddedStats.Basic.DC) != 0)
                        if (A > 0)
                        {
                            S = "+";
                            Col = Color.Green;
                        }
                        else
                            Col = Color.Red;
                    else
                        Col = Color.White;

                    S += A.ToString();
                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = " ~ ";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    S = "";
                    if ((A = I.AddedStats.Basic.DC2) != 0)
                        if (A > 0)
                        {
                            S = "+";
                            Col = Color.Green;
                        }
                        else
                            Col = Color.Red;
                    else
                        Col = Color.White;

                    S += A.ToString();
                    DrawList.Add(new TextList(S, ref X, Y, Col));
                    if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
            }
            #endregion
            #region MC Stat
            if (I.TotalStats.Basic.MC != 0 || I.TotalStats.Basic.MC2 != 0 || I.AddedStats.Basic.MC != 0 || I.AddedStats.Basic.MC2 != 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                S = "MC: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Basic.MC != 0 || I.AddedStats.Basic.MC2 != 0) Col = Color.Cyan;
                else Col = Color.White;

                S = I.TotalStats.Basic.MC.ToString();
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                DrawList.Add(new TextList(" ~ ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                S = I.TotalStats.Basic.MC2.ToString();
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Basic.MC != 0 || I.AddedStats.Basic.MC2 != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    S = "";
                    if ((A = I.AddedStats.Basic.MC) != 0)
                        if (A > 0)
                        {
                            S = "+";
                            Col = Color.Green;
                        }
                        else
                            Col = Color.Red;
                    else
                        Col = Color.White;

                    S += A.ToString();
                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = " ~ ";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    S = "";
                    if ((A = I.AddedStats.Basic.MC2) != 0)
                        if (A > 0)
                        {
                            S = "+";
                            Col = Color.Green;
                        }
                        else
                            Col = Color.Red;
                    else
                        Col = Color.White;

                    S += A.ToString();
                    DrawList.Add(new TextList(S, ref X, Y, Col));
                    if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
            }
            #endregion
            #region SC Stat
            if (I.TotalStats.Basic.SC != 0 || I.TotalStats.Basic.SC2 != 0 || I.AddedStats.Basic.SC != 0 || I.AddedStats.Basic.SC2 != 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                S = "SC: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Basic.SC != 0 || I.AddedStats.Basic.SC2 != 0) Col = Color.Cyan;
                else Col = Color.White;

                S = I.TotalStats.Basic.SC.ToString();
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                DrawList.Add(new TextList(" ~ ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                S = I.TotalStats.Basic.SC2.ToString();
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Basic.SC != 0 || I.AddedStats.Basic.SC2 != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    S = "";
                    if ((A = I.AddedStats.Basic.SC) != 0)
                        if (A > 0)
                        {
                            S = "+";
                            Col = Color.Green;
                        }
                        else
                            Col = Color.Red;
                    else
                        Col = Color.White;

                    S += A.ToString();
                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = " ~ ";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    S = "";
                    if ((A = I.AddedStats.Basic.SC2) != 0)
                        if (A > 0)
                        {
                            S = "+";
                            Col = Color.Green;
                        }
                        else
                            Col = Color.Red;
                    else
                        Col = Color.White;

                    S += A.ToString();
                    DrawList.Add(new TextList(S, ref X, Y, Col));
                    if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
            }
            #endregion

            if (I.TotalStats.Basic.Accuracy != 0 || I.AddedStats.Basic.Accuracy != 0 ||
                I.TotalStats.Basic.Agility != 0 || I.AddedStats.Basic.Agility != 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
            }
            #region Accuracy Stat
            if (I.TotalStats.Basic.Accuracy != 0 || I.AddedStats.Basic.Accuracy != 0)
            {
                S = "Accuracy: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Basic.Accuracy != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Basic.Accuracy > 0)
                    S = "+" + I.TotalStats.Basic.Accuracy.ToString();
                else
                    S = I.TotalStats.Basic.Accuracy.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Basic.Accuracy != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Basic.Accuracy > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Basic.Accuracy > 0) S = "+" + I.AddedStats.Basic.Accuracy.ToString();
                    else S = I.AddedStats.Basic.Accuracy.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                DrawList.Add(new TextList("   ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
            }
            #endregion
            #region Agility Stat
            if (I.TotalStats.Basic.Agility != 0 || I.AddedStats.Basic.Agility != 0)
            {
                S = "Agility: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Basic.Agility != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Basic.Agility > 0)
                    S = "+" + I.TotalStats.Basic.Agility.ToString();
                else
                    S = I.TotalStats.Basic.Agility.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Basic.Agility != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    if (I.AddedStats.Basic.Agility > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Basic.Agility > 0) S = "+" + I.AddedStats.Basic.Agility.ToString();
                    else S = I.AddedStats.Basic.Agility.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
            }
            #endregion

            if (I.TotalStats.Basic.HP != 0 || I.AddedStats.Basic.HP != 0 ||
                I.TotalStats.Basic.MP != 0 || I.AddedStats.Basic.MP != 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
            }
            #region HP Stat
            if (I.TotalStats.Basic.HP != 0 || I.AddedStats.Basic.HP != 0)
            {
                S = "HP: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Basic.HP != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Basic.HP > 0)
                    S = "+" + I.TotalStats.Basic.HP.ToString();
                else
                    S = I.TotalStats.Basic.HP.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Basic.HP != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Basic.HP > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Basic.HP > 0) S = "+" + I.AddedStats.Basic.HP.ToString();
                    else S = I.AddedStats.Basic.HP.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                DrawList.Add(new TextList("   ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
            }
            #endregion
            #region MP Stat
            if (I.TotalStats.Basic.MP != 0 || I.AddedStats.Basic.MP != 0)
            {
                S = "MP: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Basic.MP != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Basic.MP > 0)
                    S = "+" + I.TotalStats.Basic.MP.ToString();
                else
                    S = I.TotalStats.Basic.MP.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Basic.MP != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                    if (I.AddedStats.Basic.MP > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Basic.MP > 0) S = "+" + I.AddedStats.Basic.MP.ToString();
                    else S = I.AddedStats.Basic.MP.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
            }
            #endregion

            #endregion

            Spacer = true;
            #region Advanced Stats
            if (I.AddedStats.Advanced.MR != 0 || I.AddedStats.Advanced.MR != 0 || I.AddedStats.Advanced.MR != 0 ||
                I.TotalStats.Advanced.MR != 0 || I.TotalStats.Advanced.MR != 0 || I.TotalStats.Advanced.MR != 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                if (Spacer)
                {
                    Spacer = false;
                    Y += 10;
                    MaxY += 10;
                }
            }
            #region Poison Resist
            if (I.TotalStats.Advanced.PR != 0 || I.AddedStats.Advanced.PR != 0)
            {
                S = "P.Resist: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Advanced.PR != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Advanced.PR > 0)
                    S = "+" + I.TotalStats.Advanced.PR.ToString() + "%";
                else
                    S = I.TotalStats.Advanced.PR.ToString() + "%";

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Advanced.PR != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Advanced.PR > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Advanced.PR > 0) S = "+" + I.AddedStats.Advanced.PR.ToString() + "%";
                    else S = I.AddedStats.Advanced.PR.ToString() + "%";

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                DrawList.Add(new TextList("   ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
            }
            #endregion
            #region Cripple Resist
            if (I.TotalStats.Advanced.CR != 0 || I.AddedStats.Advanced.CR != 0)
            {
                S = "C.Resist: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Advanced.CR != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Advanced.CR > 0)
                    S = "+" + I.TotalStats.Advanced.CR.ToString() + "%";
                else
                    S = I.TotalStats.Advanced.CR.ToString() + "%";

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Advanced.CR != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Advanced.CR > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Advanced.CR > 0) S = "+" + I.AddedStats.Advanced.CR.ToString() + "%";
                    else S = I.AddedStats.Advanced.CR.ToString() + "%";

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                DrawList.Add(new TextList("   ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
            }
            #endregion
            #region Magic Resist
            if (I.TotalStats.Advanced.MR != 0 || I.AddedStats.Advanced.MR != 0)
            {
                S = "M.Resist: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Advanced.MR != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Advanced.MR > 0)
                    S = "+" + I.TotalStats.Advanced.MR.ToString() + "%";
                else
                    S = I.TotalStats.Advanced.MR.ToString() + "%";

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Advanced.MR != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Advanced.MR > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Advanced.MR > 0) S = "+" + I.AddedStats.Advanced.MR.ToString() + "%";
                    else S = I.AddedStats.Advanced.MR.ToString() + "%";

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                DrawList.Add(new TextList("   ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
            }
            #endregion

            if (I.AddedStats.Advanced.ASpeed != 0 || I.AddedStats.Advanced.CA != 0 || I.AddedStats.Advanced.PA != 0 ||
                I.TotalStats.Advanced.ASpeed != 0 || I.TotalStats.Advanced.CA != 0 || I.TotalStats.Advanced.PA != 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                if (Spacer)
                {
                    Spacer = false;
                    Y += 10;
                    MaxY += 10;
                }
            }
            #region Attack Speed
            if (I.TotalStats.Advanced.ASpeed != 0 || I.AddedStats.Advanced.ASpeed != 0)
            {
                S = "A.Speed: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Advanced.ASpeed != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Advanced.ASpeed > 0)
                    S = "+" + (I.TotalStats.Advanced.ASpeed / 10).ToString() + "%";
                else
                    S = (I.TotalStats.Advanced.ASpeed / 10).ToString() + "%";

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Advanced.MR != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Advanced.ASpeed > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Advanced.MR > 0) S = "+" + (I.AddedStats.Advanced.ASpeed / 10).ToString() + "%";
                    else S = (I.AddedStats.Advanced.ASpeed / 10).ToString() + "%";

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                DrawList.Add(new TextList("   ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
            }
            #endregion
            #region Cripple Attack
            if (I.TotalStats.Advanced.CA != 0 || I.AddedStats.Advanced.CA != 0)
            {
                S = "C.Attack: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Advanced.CA != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Advanced.CA > 0)
                    S = "+" + I.TotalStats.Advanced.CA.ToString();
                else
                    S = I.TotalStats.Advanced.CA.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Advanced.CA != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Advanced.CA > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Advanced.CA > 0) S = "+" + I.AddedStats.Advanced.CA.ToString();
                    else S = I.AddedStats.Advanced.CA.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                DrawList.Add(new TextList("   ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
            }
            #endregion
            #region Poison Attack
            if (I.TotalStats.Advanced.PA != 0 || I.AddedStats.Advanced.PA != 0)
            {
                S = "P.Attack: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Advanced.PA != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Advanced.PA > 0)
                    S = "+" + I.TotalStats.Advanced.PA.ToString();
                else
                    S = I.TotalStats.Advanced.PA.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Advanced.PA != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Advanced.PA > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Advanced.PA > 0) S = "+" + I.AddedStats.Advanced.PA.ToString();
                    else S = I.AddedStats.Advanced.PA.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
            }
            #endregion

            if (I.IInfo.HandWeight != 0 || I.IInfo.BodyWeight != 0 || I.IInfo.BagWeight != 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                if (Spacer)
                {
                    Spacer = false;
                    Y += 10;
                    MaxY += 10;
                }
            }
            #region Hand Weight
            if (I.IInfo.HandWeight != 0)
            {
                S = "H. Weight: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                if (I.IInfo.HandWeight > 0)
                    S = "+" + I.IInfo.HandWeight.ToString();
                else
                    S = I.IInfo.HandWeight.ToString();

                DrawList.Add(new TextList(S + "   ", ref X, Y, Col)); if (X > MaxX) MaxX = X;
            }
            #endregion
            #region Body Weight
            if (I.IInfo.BodyWeight != 0)
            {
                S = "C. Weight: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                if (I.IInfo.BodyWeight > 0)
                    S = "+" + I.IInfo.BodyWeight.ToString();
                else
                    S = I.IInfo.BodyWeight.ToString();

                DrawList.Add(new TextList(S + "   ", ref X, Y, Col)); if (X > MaxX) MaxX = X;
            }
            #endregion
            #region Bag Weight
            if (I.IInfo.BagWeight != 0)
            {
                S = "B. Weight: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                if (I.IInfo.BagWeight > 0)
                    S = "+" + I.IInfo.BagWeight.ToString();
                else
                    S = I.IInfo.BagWeight.ToString();

                DrawList.Add(new TextList(S + "   ", ref X, Y, Col)); if (X > MaxX) MaxX = X;
            }
            #endregion

            Spacer = true;
            #endregion
            #region Elements
            bool Comma = false;
            #region Attack

            if (I.TotalStats.Elemental.FireA != 0 || I.AddedStats.Elemental.FireA != 0 ||
                I.TotalStats.Elemental.WindA != 0 || I.AddedStats.Elemental.WindA != 0 ||
                I.TotalStats.Elemental.LightningA != 0 || I.AddedStats.Elemental.LightningA != 0 ||
                I.TotalStats.Elemental.IceA != 0 || I.AddedStats.Elemental.IceA != 0 ||
                I.TotalStats.Elemental.DarkA != 0 || I.AddedStats.Elemental.DarkA != 0 ||
                I.TotalStats.Elemental.HolyA != 0 || I.AddedStats.Elemental.HolyA != 0 ||
                I.TotalStats.Elemental.IllusionA != 0 || I.AddedStats.Elemental.IllusionA != 0
                )
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                if (Spacer)
                {
                    Spacer = false;
                    Y += 10;
                    MaxY += 10;
                }
                DrawList.Add(new TextList("Attack: ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
            }

            #region Fire
            if (I.TotalStats.Elemental.FireA != 0 || I.AddedStats.Elemental.FireA != 0)
            {

                if (I.AddedStats.Elemental.FireA != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(301, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.FireA > 0)
                    S = "+" + I.TotalStats.Elemental.FireA.ToString();
                else
                    S = I.TotalStats.Elemental.FireA.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.FireA != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.FireA > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.FireA > 0) S = "+" + I.AddedStats.Elemental.FireA.ToString();
                    else S = I.AddedStats.Elemental.FireA.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Ice
            if (I.TotalStats.Elemental.IceA != 0 || I.AddedStats.Elemental.IceA != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.IceA != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(302, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.IceA > 0)
                    S = "+" + I.TotalStats.Elemental.IceA.ToString();
                else
                    S = I.TotalStats.Elemental.IceA.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.IceA != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.IceA > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.IceA > 0) S = "+" + I.AddedStats.Elemental.IceA.ToString();
                    else S = I.AddedStats.Elemental.IceA.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Lightning
            if (I.TotalStats.Elemental.LightningA != 0 || I.AddedStats.Elemental.LightningA != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.LightningA != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(303, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.LightningA > 0)
                    S = "+" + I.TotalStats.Elemental.LightningA.ToString();
                else
                    S = I.TotalStats.Elemental.LightningA.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.LightningA != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.LightningA > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.LightningA > 0) S = "+" + I.AddedStats.Elemental.LightningA.ToString();
                    else S = I.AddedStats.Elemental.LightningA.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Wind
            if (I.TotalStats.Elemental.WindA != 0 || I.AddedStats.Elemental.WindA != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Elemental.WindA != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(304, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.WindA > 0)
                    S = "+" + I.TotalStats.Elemental.WindA.ToString();
                else
                    S = I.TotalStats.Elemental.WindA.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.WindA != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.WindA > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.WindA > 0) S = "+" + I.AddedStats.Elemental.WindA.ToString();
                    else S = I.AddedStats.Elemental.WindA.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Holy
            if (I.TotalStats.Elemental.HolyA != 0 || I.AddedStats.Elemental.HolyA != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Elemental.HolyA != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(305, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.HolyA > 0)
                    S = "+" + I.TotalStats.Elemental.HolyA.ToString();
                else
                    S = I.TotalStats.Elemental.HolyA.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.HolyA != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.HolyA > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.HolyA > 0) S = "+" + I.AddedStats.Elemental.HolyA.ToString();
                    else S = I.AddedStats.Elemental.HolyA.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Dark
            if (I.TotalStats.Elemental.DarkA != 0 || I.AddedStats.Elemental.DarkA != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Elemental.DarkA != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(306, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.DarkA > 0)
                    S = "+" + I.TotalStats.Elemental.DarkA.ToString();
                else
                    S = I.TotalStats.Elemental.DarkA.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.DarkA != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.DarkA > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.DarkA > 0) S = "+" + I.AddedStats.Elemental.DarkA.ToString();
                    else S = I.AddedStats.Elemental.DarkA.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Illusion
            if (I.TotalStats.Elemental.IllusionA != 0 || I.AddedStats.Elemental.IllusionA != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Elemental.IllusionA != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(307, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.IllusionA > 0)
                    S = "+" + I.TotalStats.Elemental.IllusionA.ToString();
                else
                    S = I.TotalStats.Elemental.IllusionA.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.IllusionA != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.IllusionA > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.IllusionA > 0) S = "+" + I.AddedStats.Elemental.IllusionA.ToString();
                    else S = I.AddedStats.Elemental.IllusionA.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion

            #endregion
            #region Defense

            if (I.TotalStats.Elemental.FireD != 0 || I.AddedStats.Elemental.FireD != 0 ||
                I.TotalStats.Elemental.WindD != 0 || I.AddedStats.Elemental.WindD != 0 ||
                I.TotalStats.Elemental.LightningD != 0 || I.AddedStats.Elemental.LightningD != 0 ||
                I.TotalStats.Elemental.IceD != 0 || I.AddedStats.Elemental.IceD != 0 ||
                I.TotalStats.Elemental.DarkD != 0 || I.AddedStats.Elemental.DarkD != 0 ||
                I.TotalStats.Elemental.HolyD != 0 || I.AddedStats.Elemental.HolyD != 0 ||
                I.TotalStats.Elemental.IllusionD != 0 || I.AddedStats.Elemental.IllusionD != 0
                )
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                if (Spacer)
                {
                    Spacer = false;
                    Y += 10;
                    MaxY += 10;
                }
                DrawList.Add(new TextList("Defense: ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
            }

            #region Fire
            if (I.TotalStats.Elemental.FireD != 0 || I.AddedStats.Elemental.FireD != 0)
            {

                if (I.AddedStats.Elemental.FireD != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(301, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.FireD > 0)
                    S = "+" + I.TotalStats.Elemental.FireD.ToString();
                else
                    S = I.TotalStats.Elemental.FireD.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.FireD != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.FireD > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.FireD > 0) S = "+" + I.AddedStats.Elemental.FireD.ToString();
                    else S = I.AddedStats.Elemental.FireD.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Ice
            if (I.TotalStats.Elemental.IceD != 0 || I.AddedStats.Elemental.IceD != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.IceD != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(302, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.IceD > 0)
                    S = "+" + I.TotalStats.Elemental.IceD.ToString();
                else
                    S = I.TotalStats.Elemental.IceD.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.IceD != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.IceD > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.IceD > 0) S = "+" + I.AddedStats.Elemental.IceD.ToString();
                    else S = I.AddedStats.Elemental.IceD.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Lightning
            if (I.TotalStats.Elemental.LightningD != 0 || I.AddedStats.Elemental.LightningD != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.LightningD != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(303, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.LightningD > 0)
                    S = "+" + I.TotalStats.Elemental.LightningD.ToString();
                else
                    S = I.TotalStats.Elemental.LightningD.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.LightningD != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.LightningD > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.LightningD > 0) S = "+" + I.AddedStats.Elemental.LightningD.ToString();
                    else S = I.AddedStats.Elemental.LightningD.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Wind
            if (I.TotalStats.Elemental.WindD != 0 || I.AddedStats.Elemental.WindD != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Elemental.WindD != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(304, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.WindD > 0)
                    S = "+" + I.TotalStats.Elemental.WindD.ToString();
                else
                    S = I.TotalStats.Elemental.WindD.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.WindD != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.WindD > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.WindD > 0) S = "+" + I.AddedStats.Elemental.WindD.ToString();
                    else S = I.AddedStats.Elemental.WindD.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Holy
            if (I.TotalStats.Elemental.HolyD != 0 || I.AddedStats.Elemental.HolyD != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Elemental.HolyD != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(305, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.HolyD > 0)
                    S = "+" + I.TotalStats.Elemental.HolyD.ToString();
                else
                    S = I.TotalStats.Elemental.HolyD.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.HolyD != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.HolyD > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.HolyD > 0) S = "+" + I.AddedStats.Elemental.HolyD.ToString();
                    else S = I.AddedStats.Elemental.HolyD.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Dark
            if (I.TotalStats.Elemental.DarkD != 0 || I.AddedStats.Elemental.DarkD != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Elemental.DarkD != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(306, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.DarkD > 0)
                    S = "+" + I.TotalStats.Elemental.DarkD.ToString();
                else
                    S = I.TotalStats.Elemental.DarkD.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.DarkD != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.DarkD > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.DarkD > 0) S = "+" + I.AddedStats.Elemental.DarkD.ToString();
                    else S = I.AddedStats.Elemental.DarkD.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion
            #region Illusion
            if (I.TotalStats.Elemental.IllusionD != 0 || I.AddedStats.Elemental.IllusionD != 0)
            {
                if (Comma)
                    DrawList.Add(new TextList(", ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Elemental.IllusionD != 0) Col = Color.Cyan;
                else Col = Color.White;

                DrawList.Add(new TextList(307, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                if (I.TotalStats.Elemental.IllusionD > 0)
                    S = "+" + I.TotalStats.Elemental.IllusionD.ToString();
                else
                    S = I.TotalStats.Elemental.IllusionD.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Elemental.IllusionD != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Elemental.IllusionD > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Elemental.IllusionD > 0) S = "+" + I.AddedStats.Elemental.IllusionD.ToString();
                    else S = I.AddedStats.Elemental.IllusionD.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                Comma = true;
            }
            #endregion

            #endregion
            #endregion
            Spacer = true;

            #region Light
            if (I.TotalStats.Advanced.Luck != 0 || I.AddedStats.Advanced.Luck != 0 || I.TotalStats.Advanced.Light != 0 || I.AddedStats.Advanced.Light != 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                if (Spacer)
                {
                    Spacer = false;
                    Y += 10;
                    MaxY += 10;
                }
            }
            if (I.TotalStats.Advanced.Light != 0 || I.AddedStats.Advanced.Light != 0)
            {
                S = "Light: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Advanced.Light != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Advanced.Light > 0)
                    S = "+" + I.TotalStats.Advanced.Light.ToString();
                else
                    S = I.TotalStats.Advanced.Light.ToString();

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Advanced.Light != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Advanced.Light > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Advanced.Light > 0) S = "+" + I.AddedStats.Advanced.Light.ToString();
                    else S = I.AddedStats.Advanced.Light.ToString();

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
                DrawList.Add(new TextList("   ", ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
            }
            #endregion
            #region Luck
            if (I.TotalStats.Advanced.Luck != 0 || I.AddedStats.Advanced.Luck != 0)
            {
                S = "Luck: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                if (I.AddedStats.Advanced.Luck != 0) Col = Color.Cyan;
                else Col = Color.White;

                if (I.TotalStats.Advanced.Luck > 0)
                    S = "+" + I.TotalStats.Advanced.Luck.ToString() + "0%";
                else
                    S = I.TotalStats.Advanced.Luck.ToString() + "0%";

                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;


                if (I.AddedStats.Advanced.Luck != 0)
                {
                    S = " (";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;


                    if (I.AddedStats.Advanced.Luck > 0) Col = Color.Green;
                    else Col = Color.Red;

                    if (I.AddedStats.Advanced.Luck > 0) S = "+" + I.AddedStats.Advanced.Luck.ToString() + "0%";
                    else S = I.AddedStats.Advanced.Luck.ToString() + "0%";

                    DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;

                    S = ")";
                    DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                }
            }
            #endregion

            #region Requirement

            if (I.IInfo.RequiredClass != 0 || I.IInfo.ReqAmount != 0 || I.IInfo.RequiredGender != 0)
            {
                Y += 22;
                MaxY += 22;
                X = 0;
            }

            if (I.IInfo.ReqAmount > 0)
            {
                S = string.Format("{0}: ", I.IInfo.ReqType);
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;
                switch (I.IInfo.ReqType)
                {
                    case Requirement.Level:
                        if (I.IInfo.ReqAmount > User.Info.Level)
                            Col = Color.Red;
                        else
                            Col = Color.Green;
                        break;
                    case Requirement.DC:
                        if (I.IInfo.ReqAmount > User.Info.TotalStats.Basic.DC2)
                            Col = Color.Red;
                        else
                            Col = Color.Green;
                        break;
                    case Requirement.MC:
                        if (I.IInfo.ReqAmount > User.Info.TotalStats.Basic.MC2)
                            Col = Color.Red;
                        else
                            Col = Color.Green;
                        break;
                    case Requirement.SC:
                        if (I.IInfo.ReqAmount > User.Info.TotalStats.Basic.SC2)
                            Col = Color.Red;
                        else
                            Col = Color.Green;
                        break;
                }
                S = I.IInfo.ReqAmount.ToString();
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;
                X += 16;
            }

            if (I.IInfo.RequiredClass != 0)
            {
                S = "Class: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                S = string.Format("{0}", I.IInfo.RequiredClass);
                ReqClass C = (ReqClass)Enum.Parse(typeof(ReqClass), User.Info.Job.ToString());
                if ((I.IInfo.RequiredClass & C) != 0)
                    Col = Color.Green;
                else
                    Col = Color.Red;
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;
            }

            if (I.IInfo.RequiredGender != 0)
            {
                S = "Gender: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                S = string.Format("{0}", I.IInfo.RequiredGender);
                ReqGender G = (ReqGender)Enum.Parse(typeof(ReqGender), User.Info.Sex.ToString());
                if ((I.IInfo.RequiredGender & G) != 0)
                    Col = Color.Green;
                else
                    Col = Color.Red;
                DrawList.Add(new TextList(S, ref X, Y, Col)); if (X > MaxX) MaxX = X;
            }
            if (I.IInfo.ReqAmount == 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                S = "Elite";
                DrawList.Add(new TextList(S, ref X, Y, Color.Green)); if (X > MaxX) MaxX = X;
            }
            #endregion

            #region Item Level

            if (I.Level != I.IInfo.MaxLevel)
            {
                Y += 22;
                MaxY += 22;
                X = 0;

                S = "Item Level: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                S = string.Format("{0}/{1}", I.Level, I.IInfo.MaxLevel);
                DrawList.Add(new TextList(S, ref X, Y, Color.White)); if (X > MaxX) MaxX = X;

                S = "   Percent: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                S = Math.Round((I.Experience / (double)I.IInfo.ExpList[I.Level]), 4).ToString("0.00%");
                DrawList.Add(new TextList(S, ref X, Y, Color.White)); if (X > MaxX) MaxX = X;
            }

            if (I.RefinesLeft > 0)
            {
                Y += 16;
                MaxY += 16;
                X = 0;
                S = "Available Refines: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                S = string.Format("{0}", I.RefinesLeft);
                DrawList.Add(new TextList(S, ref X, Y, Color.White)); if (X > MaxX) MaxX = X;

                S = "   Refines Left: ";
                DrawList.Add(new TextList(S, ref X, Y, Color.Gold)); if (X > MaxX) MaxX = X;

                S = string.Format("{0}", I.RefinesLeft + I.IInfo.MaxLevel - I.Level);
                DrawList.Add(new TextList(S, ref X, Y, Color.White)); if (X > MaxX) MaxX = X;

                if (I.RefinesLeft > I.Level + I.IInfo.DefaultRefineCount)
                {
                    S = string.Format(" (+{0})", I.RefinesLeft - I.Level);
                    DrawList.Add(new TextList(S, ref X, Y, Color.Green)); if (X > MaxX) MaxX = X;
                }

            }

            #endregion

            #region Rarity

            if (string.IsNullOrEmpty(I.CustomName))
                S = I.IInfo.Name;
            else
                S = I.CustomName;
            if ((A = Functions.GetStringSize(S).Width + Functions.GetStringSize("   " + I.IInfo.Rarity.ToString()).Width) > MaxX)
                MaxX = A;
            X = MaxX - Functions.GetStringSize(I.IInfo.Rarity.ToString()).Width;

            DrawList.Add(new TextList(I.IInfo.Rarity.ToString(), ref X, 0, Engine.RColours[(byte)I.IInfo.Rarity]));
            if (X > MaxX) MaxX = X;

            #endregion
            HintSize = new Size(MaxX + 8, MaxY + 4);
            Graphics.S.Flush();
            Graphics.D.SetRenderTarget(0, Graphics.HTexture.GetSurfaceLevel(0));
            Graphics.D.Clear(Microsoft.DirectX.Direct3D.ClearFlags.Target, Engine.RColours[(byte)I.IInfo.Rarity], 0, 0, new Rectangle[] { new Rectangle(0, 0, MaxX + 8, MaxY + 4) });
            Graphics.D.Clear(Microsoft.DirectX.Direct3D.ClearFlags.Target, Color.Black, 0, 0, new Rectangle[] { new Rectangle(2, 2, MaxX + 4, MaxY) });

            foreach (TextList T in DrawList)
                T.Draw();
            Graphics.S.Flush();
            Graphics.D.SetRenderTarget(0, Graphics.GSurface);
        }

        #endregion
        public Point Location = Point.Empty, DrawPoint = Point.Empty;
        public bool Visible = false;
        public Size CellSize, GridSize, TotalSize;
        public short GapX, GapY;
        public Item[] ItemArray;
        public int IOffSet;

        private Window parent;
        public Window Parent
        {
            get { return parent; }
            set
            {
                parent = value;
                if (parent != null)
                    parent.ItemGridList.Add(this);
            }
        }

        public void UpdateLocation()
        {
            if (parent != null)
                DrawPoint = Point.Add(Location, new Size(parent.Location));
            else
                DrawPoint = Location;
        }
        public ItemGrid(Size G, Size C, short X, short Y, bool V, Point L)
        {
            GridSize = G;
            CellSize = C;
            GapX = X;
            GapY = Y;
            Visible = V;
            Location = L;
            IOffSet = 0;
            TotalSize = new Size(GridSize.Width * (CellSize.Width + GapX), GridSize.Height * (CellSize.Height + GapY));
        }
        public void NewSize(Size NewSize)
        {
            GridSize = NewSize;
            TotalSize = new Size(GridSize.Width * (CellSize.Width + GapX), GridSize.Height * (CellSize.Height + GapY));
        }

        public void Draw()
        {
            if (!Visible || ItemArray == null) return;
            int Index = IOffSet, SIndex = -1;
            Point TPoint = Point.Empty, P = Graphics.T.PointToClient(System.Windows.Forms.Cursor.Position);
            Rectangle TRect = Rectangle.Empty;
            Size TSize = Size.Empty;

            for (int Y = 0; Y < GridSize.Height; Y++)
                for (int X = 0; X < GridSize.Width; X++)
                {
                    if (Index >= 0 && Index < ItemArray.Length)
                        if (ItemArray[Index] != null)
                        {
                            TPoint = DrawPoint;
                            TSize = CLib.Item.GetImageSize(ItemArray[Index].IInfo.Image);
                            TPoint.Offset((CellSize.Width - TSize.Width) / 2, (CellSize.Height - TSize.Height));
                            TPoint.Offset(X * (GapX + CellSize.Width), Y * (GapY + CellSize.Height));
                            TRect = new Rectangle(TPoint, CellSize);
                            CLib.Item.Draw(ItemArray[Index].IInfo.Image, TPoint, false);
                            if (TRect.Contains(P))
                                 SIndex = Index;
                        }
                    Index++;
                }
            if (new Rectangle(DrawPoint, TotalSize).Contains(P))
                if (SIndex == -1)
                    HItem = null;
                else if (ItemArray[SIndex] != HItem)
                {
                    Engine.DrawItem = true;
                    HItem = ItemArray[SIndex];
                    DrawHint();
                }
                else if (ItemArray[SIndex] == HItem)
                    Engine.DrawItem = true;

        }
        public void CleanUp()
        { }

        public bool Click(Point P)
        {
            if (!Visible || !Parent.Visible) return false;
            if (new Rectangle(Location, TotalSize).Contains(P))
            {
                if (ItemArray != null)
                {
                    int TempX, TempY, Index;

                    TempX = P.X - Location.X;
                    TempY = P.Y - Location.Y;

                    TempX /= (GapX + CellSize.Width);
                    TempY /= (GapY + CellSize.Height);
                    Index = TempY * GridSize.Width + TempX;
                    Index += IOffSet;
                    if (Index < 0 || Index >= ItemArray.Length) return true;

                    if (PItem != null)
                    {
                        if (PItemArray == ItemArray)
                        {
                            if (ItemArray == User.Info.BagItems)
                                ChangeSlot(Index);
                            if (ItemArray[Index] != null)
                            {
                                Item TItem = PItem;
                                PItem = ItemArray[Index];
                                PItemArray = ItemArray;
                                PIndex = Index;
                                ItemArray[Index] = TItem;
                                TItem = null;
                            }
                            else
                            {
                                ItemArray[Index] = PItem;
                                PItem = null;
                                PItemArray = null;
                                PIndex = -1;
                            }
                        }
                        else
                        {
                            ChangeArray(PItemArray, ItemArray, Index, PItem);
                        }
                    }
                    else if (Index >= 0 && Index < ItemArray.Length && ItemArray[Index] != null)
                    {
                        if (ItemArray[Index].IInfo.Behaviour.HasFlag(ItemBehaviour.Stuck)) return true;
                        PItem = ItemArray[Index];
                        PItemArray = ItemArray;
                        PIndex = Index;
                        ItemArray[Index] = null;
                    }
                }

                return true;
            }
            return false;
        }
        public bool RightClick(Point P)
        {
            if (!Visible || !Parent.Visible) return false;
            if (new Rectangle(Location, TotalSize).Contains(P))
            {
                if (ItemArray != null)
                {
                    int TempX, TempY, Index;

                    TempX = P.X - Location.X;
                    TempY = P.Y - Location.Y;

                    TempX /= (GapX + CellSize.Width);
                    TempY /= (GapY + CellSize.Height);
                    Index = TempY * GridSize.Width + TempX;
                    Index += IOffSet;
                    if (Index < 0 || Index >= ItemArray.Length) return true;

                    if (ItemArray[Index] != null )
                    {
                        UseItem(ItemArray[Index]);
                    }
                }

                return true;
            }
            return false;
        }
        public bool DoubleClick(Point P)
        {
            if (!Visible || !Parent.Visible) return false;
            if (new Rectangle(Location, TotalSize).Contains(P))
            {
                if (ItemArray == User.Info.BagItems)
                    UseItem(PItem);

                return true;
            }
            return false;
        }
        public bool MouseDown(Point P)
        {
            if (!Visible || !Parent.Visible) return false;
            if (new Rectangle(Location, TotalSize).Contains(P)) return true;
            else return false;
        }


        public void ChangeArray(Item[] Old, Item[] New, int Index, Item I)
        {
            if (New == User.Info.Equipment && Old == User.Info.BagItems)
            {
                #region Requirements
                if (!I.CorrectSlot((ItemLocation)Index)) return;

                //Level/DC/MC/SC
                int A;
                if ((A = I.IInfo.ReqAmount) > 0)
                {
                    switch (I.IInfo.ReqType)
                    {
                        case Requirement.Level:
                            if (A > User.Info.Level)
                            {
                                //Level too Low
                                return;
                            }
                            break;
                        case Requirement.DC:
                            if (A > User.Info.TotalStats.Basic.DC2)
                            {
                                //Level DC Low
                                return;
                            }
                            break;
                        case Requirement.MC:
                            if (A > User.Info.TotalStats.Basic.MC2)
                            {
                                //Level MC Low
                                return;
                            }
                            break;
                        case Requirement.SC:
                            if (A > User.Info.TotalStats.Basic.SC2)
                            {
                                //Level SC Low
                                return;
                            }
                            break;
                    }
                }
                //Class
                if (I.IInfo.RequiredClass != 0)
                {
                    ReqClass C = (ReqClass)Enum.Parse(typeof(ReqClass), User.Info.Job.ToString());
                    if ((I.IInfo.RequiredClass & C) == 0)
                    {
                        //Wrong Class
                        return;
                    }
                }
                //Gender
                if (I.IInfo.RequiredGender != 0)
                {
                    ReqGender G = (ReqGender)Enum.Parse(typeof(ReqGender), User.Info.Sex.ToString());
                    if ((I.IInfo.RequiredGender & G) != 0)
                    {
                        //Wrong Gender
                        return;
                    }
                }
                #endregion
                if (New[Index] != null)
                    if (New[Index].IInfo.Behaviour.HasFlag(ItemBehaviour.Stuck)) return;
                Out.EquipItem((ItemLocation)Index, I.UniqueID);
            }
            else if (New == User.Info.BagItems && Old == User.Info.Equipment)
            {
                Out.UnEquipItem(I.UniqueID);
                if (PItem == I)
                {
                    PItemArray[PIndex] = PItem;
                    PItem = null;
                    PItemArray = null;
                    PIndex = -1;
                }
            }
        }
        public void UseItem(Item I)
        {
            if (I == null) return;
            switch (I.IInfo.Type)
            {
                case ItemType.Amulet:
                    ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.Amulet, I);
                    break;
                case ItemType.Poison:
                    ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.Poison, I);
                    break;
                case ItemType.Boots:
                    ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.Boots, I);
                    break;

                case ItemType.Candle:
                    ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.Candle, I);
                    break;
                case ItemType.Belt:
                    ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.Belt, I);
                    break;
                case ItemType.Weapon:
                    ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.Weapon, I);
                    break;
                case ItemType.Armor:
                    ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.Armour, I);
                    break;

                case ItemType.Helmet:
                    ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.Helmet, I);
                    break;

                case ItemType.Necklace:
                    ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.Necklace, I);
                    break;
                case ItemType.Stone:
                    ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.Stone, I);
                    break;
                case ItemType.Bracelet:
                    if (User.Info.Equipment[(int)ItemLocation.BraceletL] == null)
                        ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.BraceletL, I);
                    else
                        ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.BraceletR, I);
                    break;
                case ItemType.Ring:
                    if (User.Info.Equipment[(int)ItemLocation.RingL] == null)
                        ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.RingL, I);
                    else
                        ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.RingR, I);
                    break;
                case ItemType.Medal:
                    ChangeArray(ItemArray, User.Info.Equipment, (int)ItemLocation.Medal, I);
                    break;
            }

        }


        public void ChangeSlot(int Index)
        {
            if (ItemArray != User.Info.BagItems || PIndex == Index) return;
            Out.ChangeBagSlot((byte)PIndex, (byte)Index);
        }
    }


    public struct TextList
    {
        public string Text;
        public int Image;
        public Point P;
        public Color Col;
        public TextList(string S, ref int x, int y, Color col)
        {
            Text = S;
            P = new Point(x, y);
            Col = col;
            x += Functions.GetStringSize(S).Width;
            Image = -1;
        }
        public TextList(int img, ref int x, int y, Color col)
        {
            Text = "";
            P = new Point(x, y);
            Col = col;
            x += 20;
            Image = img;
        }
        public void Draw()
        {
            P.Offset(4, 0);
            if (Image >= 0)
                CLib.Interface.Draw(Image, P, false);
            else
                Graphics.DXNormalFont.DrawText(Graphics.S, Text, P, Col);
        }
    }
}
