﻿using System;
using System.Collections.Generic;
using System.Drawing;
using Clash_Library;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace Clash_Client
{
    class IntroScenes
    {
        public static class BackGrounds
        {
            public static DateTime LastFrame = DateTime.Now;
            public static int CurrentFrame = 0;
            public static bool LoggingOut = false;
            public static BackGround Login, LoggingIn, CharSel, Loading;
            public static void Create()
            {
                Login = new BackGround(0, true);
                LoggingIn = new BackGround(1, false);
                LoggingIn.DrawAfter = LoggingInF;
                CharSel = new BackGround(35, false);
                CharSel.DrawAfter = CharSelF;
                Loading = new BackGround(193, false);
                Loading.DrawAfter = LoadingF;
            }
            public static void LoggingInF()
            {
                if (DateTime.Now - LastFrame > new TimeSpan(0, 0, 0, 0, 50))
                {
                    LastFrame = DateTime.Now;
                    if (LoggingOut)
                    {
                        if (--LoggingIn.Image <= 1)
                        {
                            LoggingOut = false;
                            Login.Visible = true;
                            LoggingIn.Visible = false;
                            Engine.CurrentStage = GameStage.Login;
                            LoginDialog.Window.Visible = true;
                        }
                    }
                    else
                    {
                        if (++LoggingIn.Image >= 17)
                        {
                            LoggingIn.Visible = false;
                            CharSel.Visible = true;
                            Engine.CurrentStage = GameStage.CharSel;
                        }
                    }
                }
            }
            public static void CharSelF()
            {
                Graphics.DXNormalFont.DrawText(Graphics.S, "Clash Client", new Rectangle(342, 7, 116, 15), DrawTextFormat.VerticalCenter | DrawTextFormat.Center, Color.PaleGoldenrod);
                if (Engine.CharacterList.Count <= 0)
                {
                    CharSelVars.Character1.Visible = false;
                    CharSelVars.Character2.Visible = false;
                    CharSelVars.Character3.Visible = false;
                    CharSelVars.Character4.Visible = false;
                    return;
                }
                if (Engine.CharSelected >= 0 && Engine.CharSelected < Engine.CharacterList.Count)
                {
                    Gender tempSex = Engine.CharacterList[Engine.CharSelected].Sex;
                    Class tempClass = Engine.CharacterList[Engine.CharSelected].Job;
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[Engine.CharSelected].Name, new Rectangle(130, 463, 140, 19), DrawTextFormat.VerticalCenter | DrawTextFormat.Center, Color.White);
                    switch (tempClass)
                    {
                        case Class.Warrior:
                            if (tempSex == Gender.Male)
                                CLib.Interface.Draw(60 + CurrentFrame, new Point(90, 122), true);
                            else
                                CLib.Interface.Draw(60 + 16 + CurrentFrame, new Point(90, 122), true);
                            break;
                        case Class.Wizard:
                            if (tempSex == Gender.Male)
                            {
                                CLib.Interface.Draw(92 + CurrentFrame, new Point(90, 58), true);
                                CLib.Interface.DrawBlend(251 + CurrentFrame, new Point(90, 58), true, Color.White);
                            }
                            else
                            {
                                CLib.Interface.Draw(92 + 16 + CurrentFrame, new Point(100, 88), true);
                                CLib.Interface.DrawBlend(251 + 16 + CurrentFrame, new Point(100, 88), true, Color.White);
                            }
                            break;
                        case Class.Taoist:
                            if (tempSex == Gender.Male)
                                CLib.Interface.Draw(124 + CurrentFrame, new Point(100, 122), true);

                            else
                                CLib.Interface.Draw(124 + 16 + CurrentFrame, new Point(100, 122), true);
                            break;
                        case Class.Assassin:
                            if (tempSex == Gender.Male)
                                CLib.Interface.Draw(156 + CurrentFrame, new Point(+118, 122), true);
                            else
                                CLib.Interface.Draw(156 + 16 + CurrentFrame, new Point(118, 122), true);
                            break;
                    }
                    if (DateTime.Now - LastFrame > new TimeSpan(0, 0, 0, 0, 150))
                    {
                        LastFrame = DateTime.Now;
                        CurrentFrame++;
                        if (CurrentFrame > 15) CurrentFrame = 0;
                    }
                }
                CharSelVars.Character1.State = ButtonState.Normal;
                CharSelVars.Character2.State = ButtonState.Normal;
                CharSelVars.Character3.State = ButtonState.Normal;
                CharSelVars.Character4.State = ButtonState.Normal;
                switch (Engine.CharSelected)
                {
                    case 0:
                        CharSelVars.Character1.State = ButtonState.Pressed;
                        break;
                    case 1:
                        CharSelVars.Character2.State = ButtonState.Pressed;
                        break;
                    case 2:
                        CharSelVars.Character3.State = ButtonState.Pressed;
                        break;
                    case 3:
                        CharSelVars.Character4.State = ButtonState.Pressed;
                        break;
                }

                Point tempPoint = Point.Empty;
                if (Engine.CharacterList.Count > 0)
                {
                    tempPoint = CharSelVars.Character1.DrawPoint;
                    CharSelVars.Character1.Visible = true;
                    CharSelVars.Character1.Image = 48 + (byte)Engine.CharacterList[0].Job;
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[0].Name, new Point(tempPoint.X + 115, tempPoint.Y + 11), Color.White);
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[0].Level.ToString(), new Point(tempPoint.X + 115, tempPoint.Y + 33), Color.White);
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[0].Job.ToString(), new Point(tempPoint.X + 194, tempPoint.Y + 33), Color.White);

                }
                else
                {
                    CharSelVars.Character1.Visible = false;
                }
                if (Engine.CharacterList.Count > 1)
                {
                    tempPoint = CharSelVars.Character2.DrawPoint;
                    CharSelVars.Character2.Visible = true;
                    CharSelVars.Character2.Image = 48 + (byte)Engine.CharacterList[1].Job;
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[1].Name, new Point(tempPoint.X + 115, tempPoint.Y + 11), Color.White);
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[1].Level.ToString(), new Point(tempPoint.X + 115, tempPoint.Y + 33), Color.White);
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[1].Job.ToString(), new Point(tempPoint.X + 194, tempPoint.Y + 33), Color.White);
                }
                else
                {
                    CharSelVars.Character2.Visible = false;
                }
                if (Engine.CharacterList.Count > 2)
                {
                    tempPoint = CharSelVars.Character3.DrawPoint;
                    CharSelVars.Character3.Visible = true;
                    CharSelVars.Character3.Image = 48 + (byte)Engine.CharacterList[2].Job;
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[2].Name, new Point(tempPoint.X + 115, tempPoint.Y + 11), Color.White);
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[2].Level.ToString(), new Point(tempPoint.X + 115, tempPoint.Y + 33), Color.White);
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[2].Job.ToString(), new Point(tempPoint.X + 194, tempPoint.Y + 33), Color.White);
                }
                else
                {
                    CharSelVars.Character3.Visible = false;
                }
                if (Engine.CharacterList.Count > 3)
                {
                    tempPoint = CharSelVars.Character4.DrawPoint;
                    CharSelVars.Character4.Visible = true;
                    CharSelVars.Character4.Image = 48 + (byte)Engine.CharacterList[3].Job;
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[3].Name, new Point(tempPoint.X + 115, tempPoint.Y + 11), Color.White);
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[3].Level.ToString(), new Point(tempPoint.X + 115, tempPoint.Y + 33), Color.White);
                    Graphics.DXNormalFont.DrawText(Graphics.S, Engine.CharacterList[3].Job.ToString(), new Point(tempPoint.X + 194, tempPoint.Y + 33), Color.White);
                }
                else
                {
                    CharSelVars.Character4.Visible = false;
                }

            }
            public static void LoadingF()
            {
                if (DateTime.Now - LastFrame > new TimeSpan(0, 0, 0, 0, 70))
                {
                    LastFrame = DateTime.Now;
                    if (++CurrentFrame > 9) CurrentFrame = 0;
                }
                CLib.Interface.Draw(201 + CurrentFrame, new Point(354, 500), false);
            }
        }
        public static class LoginDialog
        {
            public static Window Window;
            public static Button Close, OK, NewAccount, ChangePass, Safe;
            public static TextBox LoginID, Password;

            public static void Create()
            {
                Window = new Window(19, WindowPosition.Centre, false , true, false);

                OK = new Button(20, new Point(245, 77), true, SoundList.ButtonClick);
                OK.Function = OKF;
                OK.Parent = Window;

                Close = new Button(21, new Point(141, 171), true, SoundList.ButtonClick);
                Close.Function = QuitF;
                Close.Parent = Window;

                ChangePass = new Button(22, new Point(141, 145), true, SoundList.ButtonClick);
                ChangePass.Function = ChangePassF;
                ChangePass.Parent = Window;

                NewAccount = new Button(23, new Point(93, 144), true, SoundList.ButtonClick);
                NewAccount.Function = NewAccountF;
                NewAccount.Parent = Window;

                Safe = new Button(29, new Point(93, 170), true, SoundList.ButtonClick, true, 1);
                Safe.Function = SafeF;
                Safe.Parent = Window;

                LoginID = new TextBox(new Point(99, 77), new Size(137, 17), true);
                LoginID.Parent = Window;
                LoginID.Select();

                Password = new TextBox(new Point(99, 108), new Size(137, 17), true, true);
                Password.Parent = Window;

            }
            public static void QuitF()
            {
                Engine.GameRunning = false;
            }
            public static void OKF()
            {
                OK.Locked = true;
                Out.Login();
            }
            public static void NewAccountF()
            {
                Window.Visible = false;
                AccountDialog.Window.Visible = true;
                AccountDialog.LoginID.Select();
            }
            public static void ChangePassF()
            {
                Window.Visible = false;
                PasswordDialog.Window.Visible = true;
                PasswordDialog.LoginID.Select();
            }
            public static void SafeF()
            {
                SafeDialog.Window.Visible = !SafeDialog.Window.Visible;
                SafeDialog.RandomF();
            }
        }
        public static class AccountDialog
        {
            public static Window Window;
            public static Button Confirm, Cancel;
            public static TextBox LoginID, Password, Password2, Name, DateOfBirth, Question1, Answer1, Question2, Answer2, Phone, Mobile, Email;

            public static void Create()
            {
                Window = new Window(33, WindowPosition.Centre, false, true, false);

                Confirm = new Button(34, new Point(144, 430), true, SoundList.ButtonClick);
                Confirm.Function = NewAccountF;
                Confirm.Parent = Window;

                Cancel = new Button(21, new Point(253, 430), true, SoundList.ButtonClick);
                Cancel.Function = CancelF;
                Cancel.Parent = Window;

                LoginID = new TextBox(new Point(190, 153), new Size(111, 12), true);
                LoginID.Parent = Window;

                Password = new TextBox(new Point(190, 174), new Size(111, 12), true);
                Password.Password = true;
                Password.Parent = Window;

                Password2 = new TextBox(new Point(190, 195), new Size(111, 12), true);
                Password2.Password = true;
                Password2.Parent = Window;

                Name = new TextBox(new Point(190, 222), new Size(111, 12), true);
                Name.AnyLetter = true;
                Name.Parent = Window;

                DateOfBirth = new TextBox(new Point(190, 244), new Size(111, 12), true);
                DateOfBirth.MaxLength = 15;
                DateOfBirth.AnyLetter = true;
                DateOfBirth.Parent = Window;

                Question1 = new TextBox(new Point(190, 280), new Size(161, 11), true);
                Question1.AnyLetter = true;
                Question1.Parent = Window;
                Answer1 = new TextBox(new Point(190, 299), new Size(161, 11), true);
                Answer1.AnyLetter = true;
                Answer1.Parent = Window;

                Question2 = new TextBox(new Point(190, 320), new Size(161, 11), true);
                Question2.AnyLetter = true;
                Question2.Parent = Window;
                Answer2 = new TextBox(new Point(190, 339), new Size(161, 11), true);
                Answer2.AnyLetter = true;
                Answer2.Parent = Window;

                Phone = new TextBox(new Point(190, 369), new Size(115, 12), true);
                Phone.MaxLength = 15;
                Phone.Parent = Window;

                Mobile = new TextBox(new Point(190, 389), new Size(115, 12), true);
                Mobile.MaxLength = 15;
                Mobile.Parent = Window;

                Email = new TextBox(new Point(190, 411), new Size(161, 12), true);
                Email.MaxLength = 50;
                Email.AnyLetter = true;
                Email.Parent = Window;
            }
            public static void NewAccountF()
            {
                Out.NewAccount();
            }
            public static void CancelF()
            {
                Window.CleanUp();
                LoginDialog.Window.Visible = true;
                LoginDialog.LoginID.Select();
            }
        }
        public static class SafeDialog
        {
            private static bool UseCaps;
            public static Window Window;
            public static Button Esc, Delete, Random, Enter, B0, B1, B2, B3, B4, B5, B6, B7, B8, B9,
                A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T, U, V, W, X, Y, Z;
            public static void Create()
            {
                Window = new Window(24, WindowPosition.BottomRight, false, true, false);


                Esc = new Button(28, new Point(10, 10), true, SoundList.SmallClick);
                Esc.Function = EscapeF;
                Esc.Parent = Window;

                B0 = new Button(25, new Point(10, 42), true, SoundList.SmallClick);
                B0.Function = B0F;
                B0.Parent = Window;

                B1 = new Button(25, new Point(41, 42), true, SoundList.SmallClick);
                B1.Function = B1F;
                B1.Parent = Window;

                B2 = new Button(25, new Point(72, 42), true, SoundList.SmallClick);
                B2.Function = B2F;
                B2.Parent = Window;

                B3 = new Button(25, new Point(103, 42), true, SoundList.SmallClick);
                B3.Function = B3F;
                B3.Parent = Window;

                B4 = new Button(25, new Point(134, 42), true, SoundList.SmallClick);
                B4.Function = B4F;
                B4.Parent = Window;

                B5 = new Button(25, new Point(165, 42), true, SoundList.SmallClick);
                B5.Function = B5F;
                B5.Parent = Window;

                B6 = new Button(25, new Point(10, 74), true, SoundList.SmallClick);
                B6.Function = B6F;
                B6.Parent = Window;

                B7 = new Button(25, new Point(41, 74), true, SoundList.SmallClick);
                B7.Function = B7F;
                B7.Parent = Window;

                B8 = new Button(25, new Point(72, 74), true, SoundList.SmallClick);
                B8.Function = B8F;
                B8.Parent = Window;

                B9 = new Button(25, new Point(103, 74), true, SoundList.SmallClick);
                B9.Function = B9F;
                B9.Parent = Window;

                Delete = new Button(26, new Point(134, 74), true, SoundList.SmallClick);
                Delete.Function = DeleteF;
                Delete.Parent = Window;


                A = new Button(25, new Point(10, 106), true, SoundList.SmallClick);
                A.Function = AF;
                A.Parent = Window;

                B = new Button(25, new Point(41, 106), true, SoundList.SmallClick);
                B.Function = BF;
                B.Parent = Window;

                C = new Button(25, new Point(72, 106), true, SoundList.SmallClick);
                C.Function = CF;
                C.Parent = Window;

                D = new Button(25, new Point(103, 106), true, SoundList.SmallClick);
                D.Function = DF;
                D.Parent = Window;

                E = new Button(25, new Point(134, 106), true, SoundList.SmallClick);
                E.Function = EF;
                E.Parent = Window;

                F = new Button(25, new Point(165, 106), true, SoundList.SmallClick);
                F.Function = FF;
                F.Parent = Window;

                G = new Button(25, new Point(10, 138), true, SoundList.SmallClick);
                G.Function = GF;
                G.Parent = Window;

                H = new Button(25, new Point(41, 138), true, SoundList.SmallClick);
                H.Function = HF;
                H.Parent = Window;

                I = new Button(25, new Point(72, 138), true, SoundList.SmallClick);
                I.Function = IF;
                I.Parent = Window;

                J = new Button(25, new Point(103, 138), true, SoundList.SmallClick);
                J.Function = JF;
                J.Parent = Window;

                K = new Button(25, new Point(134, 138), true, SoundList.SmallClick);
                K.Function = KF;
                K.Parent = Window;

                L = new Button(25, new Point(165, 138), true, SoundList.SmallClick);
                L.Function = LF;
                L.Parent = Window;

                M = new Button(25, new Point(10, 170), true, SoundList.SmallClick);
                M.Function = MF;
                M.Parent = Window;

                N = new Button(25, new Point(41, 170), true, SoundList.SmallClick);
                N.Function = NF;
                N.Parent = Window;

                O = new Button(25, new Point(72, 170), true, SoundList.SmallClick);
                O.Function = OF;
                O.Parent = Window;

                P = new Button(25, new Point(103, 170), true, SoundList.SmallClick);
                P.Function = PF;
                P.Parent = Window;

                Q = new Button(25, new Point(134, 170), true, SoundList.SmallClick);
                Q.Function = QF;
                Q.Parent = Window;

                R = new Button(25, new Point(165, 170), true, SoundList.SmallClick);
                R.Function = RF;
                R.Parent = Window;

                S = new Button(25, new Point(10, 202), true, SoundList.SmallClick);
                S.Function = SF;
                S.Parent = Window;

                T = new Button(25, new Point(41, 202), true, SoundList.SmallClick);
                T.Function = TF;
                T.Parent = Window;

                U = new Button(25, new Point(72, 202), true, SoundList.SmallClick);
                U.Function = UF;
                U.Parent = Window;

                V = new Button(25, new Point(103, 202), true, SoundList.SmallClick);
                V.Function = VF;
                V.Parent = Window;

                W = new Button(25, new Point(134, 202), true, SoundList.SmallClick);
                W.Function = WF;
                W.Parent = Window;

                X = new Button(25, new Point(165, 202), true, SoundList.SmallClick);
                X.Function = XF;
                X.Parent = Window;

                Y = new Button(25, new Point(10, 234), true, SoundList.SmallClick);
                Y.Function = YF;
                Y.Parent = Window;

                Z = new Button(25, new Point(41, 234), true, SoundList.SmallClick);
                Z.Function = ZF;
                Z.Parent = Window;

                Random = new Button(31, new Point(72, 234), true, SoundList.SmallClick);
                Random.Function = RandomF;
                Random.Parent = Window;

                Enter = new Button(27, new Point(134, 234), true, SoundList.SmallClick);
                Enter.Function = EnterF;
                Enter.Parent = Window;

            }
            public static void EscapeF()
            {
                Window.CleanUp();
            }
            public static void DeleteF()
            {
                if (TextBox.Focused != null)
                    TextBox.Focused.BackSpace();
            }
            public static void RandomF()
            {
                System.Random rand = new System.Random();
                List<string> KeyPadkeys = new List<string>();
                List<int> KeyPadID = new List<int>();
                #region Keys
                KeyPadkeys.Add("0");
                KeyPadkeys.Add("1");
                KeyPadkeys.Add("2");
                KeyPadkeys.Add("3");
                KeyPadkeys.Add("4");
                KeyPadkeys.Add("5");
                KeyPadkeys.Add("6");
                KeyPadkeys.Add("7");
                KeyPadkeys.Add("8");
                KeyPadkeys.Add("9");
                KeyPadkeys.Add("A");
                KeyPadkeys.Add("B");
                KeyPadkeys.Add("C");
                KeyPadkeys.Add("D");
                KeyPadkeys.Add("E");
                KeyPadkeys.Add("F");
                KeyPadkeys.Add("G");
                KeyPadkeys.Add("H");
                KeyPadkeys.Add("I");
                KeyPadkeys.Add("J");
                KeyPadkeys.Add("K");
                KeyPadkeys.Add("L");
                KeyPadkeys.Add("M");
                KeyPadkeys.Add("N");
                KeyPadkeys.Add("O");
                KeyPadkeys.Add("P");
                KeyPadkeys.Add("Q");
                KeyPadkeys.Add("R");
                KeyPadkeys.Add("S");
                KeyPadkeys.Add("T");
                KeyPadkeys.Add("U");
                KeyPadkeys.Add("V");
                KeyPadkeys.Add("W");
                KeyPadkeys.Add("X");
                KeyPadkeys.Add("Y");
                KeyPadkeys.Add("Z");
                #endregion
                #region
                KeyPadID.Add(1);
                KeyPadID.Add(2);
                KeyPadID.Add(3);
                KeyPadID.Add(4);
                KeyPadID.Add(5);
                KeyPadID.Add(6);
                KeyPadID.Add(7);
                KeyPadID.Add(8);
                KeyPadID.Add(9);
                KeyPadID.Add(10);
                KeyPadID.Add(12);
                KeyPadID.Add(13);
                KeyPadID.Add(14);
                KeyPadID.Add(15);
                KeyPadID.Add(16);
                KeyPadID.Add(17);
                KeyPadID.Add(18);
                KeyPadID.Add(19);
                KeyPadID.Add(20);
                KeyPadID.Add(21);
                KeyPadID.Add(22);
                KeyPadID.Add(23);
                KeyPadID.Add(24);
                KeyPadID.Add(25);
                KeyPadID.Add(26);
                KeyPadID.Add(27);
                KeyPadID.Add(28);
                KeyPadID.Add(29);
                KeyPadID.Add(30);
                KeyPadID.Add(31);
                KeyPadID.Add(32);
                KeyPadID.Add(33);
                KeyPadID.Add(34);
                KeyPadID.Add(35);
                KeyPadID.Add(36);
                KeyPadID.Add(37);
                #endregion
                int ID = rand.Next(KeyPadID.Count);
                int ID2 = rand.Next(KeyPadkeys.Count);
                for (int A = 0; A < 36; A++)
                {
                    ID = rand.Next(KeyPadID.Count);
                    ID2 = rand.Next(KeyPadkeys.Count);
                    if (!UseCaps) Window.ButtonList[KeyPadID[ID]].Text = KeyPadkeys[ID2].ToLower();
                    else Window.ButtonList[KeyPadID[ID]].Text = KeyPadkeys[ID2];
                    KeyPadID.RemoveAt(ID);
                    KeyPadkeys.RemoveAt(ID2);
                }
                UseCaps = !UseCaps;
            }
            public static void EnterF()
            {
                LoginDialog.OKF();
            }
            public static void B0F()
            {
                if (SafeDialog.B0.Text != null && SafeDialog.B0.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.B0.Text);
            }
            public static void B1F()
            {
                if (SafeDialog.B1.Text != null && SafeDialog.B1.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.B1.Text);
            }
            public static void B2F()
            {
                if (SafeDialog.B2.Text != null && SafeDialog.B2.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.B2.Text);
            }
            public static void B3F()
            {
                if (SafeDialog.B3.Text != null && SafeDialog.B3.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.B3.Text);
            }
            public static void B4F()
            {
                if (SafeDialog.B4.Text != null && SafeDialog.B4.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.B4.Text);
            }
            public static void B5F()
            {
                if (SafeDialog.B5.Text != null && SafeDialog.B5.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.B5.Text);
            }
            public static void B6F()
            {
                if (SafeDialog.B6.Text != null && SafeDialog.B6.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.B6.Text);
            }
            public static void B7F()
            {
                if (SafeDialog.B7.Text != null && SafeDialog.B7.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.B7.Text);
            }
            public static void B8F()
            {
                if (SafeDialog.B8.Text != null && SafeDialog.B8.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.B8.Text);
            }
            public static void B9F()
            {
                if (SafeDialog.B9.Text != null && SafeDialog.B9.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.B9.Text);
            }
            public static void AF()
            {
                if (SafeDialog.A.Text != null && SafeDialog.A.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.A.Text);
            }
            public static void BF()
            {
                if (SafeDialog.B.Text != null && SafeDialog.B.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.B.Text);
            }
            public static void CF()
            {
                if (SafeDialog.C.Text != null && SafeDialog.C.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.C.Text);
            }
            public static void DF()
            {
                if (SafeDialog.D.Text != null && SafeDialog.D.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.D.Text);
            }
            public static void EF()
            {
                if (SafeDialog.E.Text != null && SafeDialog.E.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.E.Text);
            }
            public static void FF()
            {
                if (SafeDialog.F.Text != null && SafeDialog.F.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.F.Text);
            }
            public static void GF()
            {
                if (SafeDialog.G.Text != null && SafeDialog.G.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.G.Text);
            }
            public static void HF()
            {
                if (SafeDialog.H.Text != null && SafeDialog.H.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.H.Text);
            }
            public static void IF()
            {
                if (SafeDialog.I.Text != null && SafeDialog.I.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.I.Text);
            }
            public static void JF()
            {
                if (SafeDialog.J.Text != null && SafeDialog.J.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.J.Text);
            }
            public static void KF()
            {
                if (SafeDialog.K.Text != null && SafeDialog.K.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.K.Text);
            }
            public static void LF()
            {
                if (SafeDialog.L.Text != null && SafeDialog.L.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.L.Text);
            }
            public static void MF()
            {
                if (SafeDialog.M.Text != null && SafeDialog.M.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.M.Text);
            }
            public static void NF()
            {
                if (SafeDialog.N.Text != null && SafeDialog.N.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.N.Text);
            }
            public static void OF()
            {
                if (SafeDialog.O.Text != null && SafeDialog.O.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.O.Text);
            }
            public static void PF()
            {
                if (SafeDialog.P.Text != null && SafeDialog.P.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.P.Text);
            }
            public static void QF()
            {
                if (SafeDialog.Q.Text != null && SafeDialog.Q.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.Q.Text);
            }
            public static void RF()
            {
                if (SafeDialog.R.Text != null && SafeDialog.R.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.R.Text);
            }
            public static void SF()
            {
                if (SafeDialog.S.Text != null && SafeDialog.S.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.S.Text);
            }
            public static void TF()
            {
                if (SafeDialog.T.Text != null && SafeDialog.T.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.T.Text);
            }
            public static void UF()
            {
                if (SafeDialog.U.Text != null && SafeDialog.U.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.U.Text);
            }
            public static void VF()
            {
                if (SafeDialog.V.Text != null && SafeDialog.V.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.V.Text);
            }
            public static void WF()
            {
                if (SafeDialog.W.Text != null && SafeDialog.W.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.W.Text);
            }
            public static void XF()
            {
                if (SafeDialog.X.Text != null && SafeDialog.X.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.X.Text);
            }
            public static void YF()
            {
                if (SafeDialog.Y.Text != null && SafeDialog.Y.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.Y.Text);
            }
            public static void ZF()
            {
                if (SafeDialog.Z.Text != null && SafeDialog.Z.Text != "")
                    if (TextBox.Focused != null) TextBox.Focused.Type(SafeDialog.Z.Text);
            }
        }
        public static class PasswordDialog
        {
            public static Window Window;
            public static Button Cancel, Confirm;
            public static TextBox LoginID, Password, NewPassword, NewPassword2;
            public static void Create()
            {
                Window = new Window(32, WindowPosition.Centre, false, true, false);

                Confirm = new Button(34, new Point(174, 251), true, SoundList.ButtonClick);
                Confirm.Function = ConfirmF;
                Confirm.Parent = Window;

                Cancel = new Button(21, new Point(277, 251), true, SoundList.ButtonClick);
                Cancel.Function = CancelF;
                Cancel.Parent = Window;

                LoginID = new TextBox(new Point(240, 121), new Size(134, 12), true);
                LoginID.Parent = Window;

                Password = new TextBox(new Point(240, 153), new Size(134, 12), true);
                Password.Password = true;
                Password.Parent = Window;

                NewPassword = new TextBox(new Point(240, 180), new Size(134, 12), true);
                NewPassword.Password = true;
                NewPassword.Parent = Window;

                NewPassword2 = new TextBox(new Point(240, 212), new Size(134, 12), true);
                NewPassword2.Password = true;
                NewPassword2.Parent = Window;
            }
            public static void ConfirmF()
            {
                Out.ChangePassword();
            }
            public static void CancelF()
            {
                Window.CleanUp();
                LoginDialog.Window.Visible = true;
                LoginDialog.LoginID.Select();
            }
        }
        public static class CharSelVars
        {
            public static Button Start, NewCharacter, DeleteCharacter, Back, Close, Character1, Character2, Character3, Character4;

            public static void Create()
            {
                Start = new Button(42, new Point(439, 426), true, SoundList.ButtonClick);
                Start.Function = StartF;
                BackGrounds.CharSel.ButtonList.Add(Start);

                NewCharacter = new Button(43, new Point(439, 455), true, SoundList.ButtonClick);
                NewCharacter.Function = NewCharacterF;
                BackGrounds.CharSel.ButtonList.Add(NewCharacter);

                DeleteCharacter = new Button(44, new Point(439, 484), true, SoundList.ButtonClick);
                DeleteCharacter.Function = DeleteCharacterF;
                BackGrounds.CharSel.ButtonList.Add(DeleteCharacter);

                Back = new Button(45, new Point(439, 513), true, SoundList.ButtonClick);
                Back.Function = BackF;
                BackGrounds.CharSel.ButtonList.Add(Back);

                Close = new Button(46, new Point(439, 542), true, SoundList.ButtonClick);
                Close.Function = QuitF;
                BackGrounds.CharSel.ButtonList.Add(Close);

                Character1 = new Button(48, new Point(442, 62), false, SoundList.SmallClick, true, 4);
                Character1.Sticky = true;
                Character1.Function = Character1F;
                BackGrounds.CharSel.ButtonList.Add(Character1);

                Character2 = new Button(48, new Point(442, 126), false, SoundList.SmallClick, true, 4);
                Character2.Sticky = true;
                Character2.Function = Character2F;
                BackGrounds.CharSel.ButtonList.Add(Character2);

                Character3 = new Button(48, new Point(442, 190), false, SoundList.SmallClick, true, 4);
                Character3.Sticky = true;
                Character3.Function = Character3F;
                BackGrounds.CharSel.ButtonList.Add(Character3);

                Character4 = new Button(48, new Point(442, 254), false, SoundList.SmallClick, true, 4);
                Character4.Sticky = true;
                Character4.Function = Character4F;
                BackGrounds.CharSel.ButtonList.Add(Character4);
            }
            public static void StartF()
            {
                if (Engine.T.ThreadState == System.Threading.ThreadState.Running)
                {
                    Functions.ShowMessage("Game is Still Loading, Please wait.");
                    MessageDialogVars.Window.DrawBefore = MessageDialogVars.Loading;
                    MessageDialogVars.Close.Visible = false;
                    return;
                }
                Out.StartGame();
            }
            public static void NewCharacterF()
            {
                if (Engine.CharacterList.Count < 4)
                {
                    NewCharacterVars.Window.Visible = true;
                    NewCharacterVars.CharacterName.Select();
                    NewCharacterVars.WarriorF();
                    NewCharacterVars.MaleF();
                }
                else
                {
                    Functions.ShowMessage(Constants.MaxCharacters);
                }
            }
            public static void DeleteCharacterF()
            {
                if (Engine.CharSelected >= 0)
                {
                    Functions.AskQuestion(
                        Constants.DeleteCharacter + Environment.NewLine + Environment.NewLine + Constants.DeleteCharacter2,
                        QuestionDialogVars.DeleteCharacterF,
                        QuestionDialogVars.ConfirmDeleteF,
                        QuestionDialogVars.CloseF,
                        false);
                }
            }
            public static void BackF()
            {
                Out.Logout();
            }
            public static void QuitF()
            {
                Engine.GameRunning = false;
            }
            public static void Character1F()
            {
                Engine.CharSelected = 0;
            }
            public static void Character2F()
            {
                if (Engine.CharacterList.Count > 1) 
                Engine.CharSelected = 1;
            }
            public static void Character3F()
            {
                if (Engine.CharacterList.Count > 2) 
                Engine.CharSelected = 2;
            }
            public static void Character4F()
            {
                if (Engine.CharacterList.Count > 3) 
                Engine.CharSelected = 3;
            }
        }
        public static class NewCharacterVars
        {
            public static DateTime LastFrame = DateTime.Now;
            public static int CurrentFrame = 0;
            public static Window Window;
            public static TextBox CharacterName;
            public static Button Confirm, Cancel, Warrior, Wizard, Taoist, Assassin, Male, Female;
            public static Class SelectedClass;
            public static Gender SelectedSex;

            public static void Create()
            {
                Window = new Window(41, WindowPosition.Centre, false, true, true);
                Window.DrawBefore = DrawExtraF;

                CharacterName = new TextBox(new Point(387, 139), new Size(137, 16), true);
                CharacterName.Parent = Window;

                Confirm = new Button(34, new Point(359, 399), true, SoundList.ButtonClick);
                Confirm.Function =  ConfirmF;
                Confirm.Parent = Window;

                Cancel = new Button(21, new Point(471, 399), true, SoundList.ButtonClick);
                Cancel.Function =  CancelF;
                Cancel.Parent = Window;

                Warrior = new Button(36, new Point(360, 206), true, SoundList.SmallClick);
                Warrior.Sticky = true;
                Warrior.Function =  WarriorF;
                Warrior.Parent = Window;

                Wizard = new Button(37, new Point(407, 206), true, SoundList.SmallClick);
                Wizard.Sticky = true;
                Wizard.Function =  WizardF;
                Wizard.Parent = Window;

                Taoist = new Button(38, new Point(454, 206), true, SoundList.SmallClick);
                Taoist.Sticky = true;
                Taoist.Function =  TaoistF;
                Taoist.Parent = Window;

                Assassin = new Button(47, new Point(501, 206), true, SoundList.SmallClick);
                Assassin.Sticky = true;
                Assassin.Function =  AssassinF;
                Assassin.Parent = Window;

                Male = new Button(39, new Point(407, 297), true, SoundList.SmallClick);
                Male.Sticky = true;
                Male.Function =  MaleF;
                Male.Parent = Window;

                Female = new Button(40, new Point(454, 297), true, SoundList.SmallClick);
                Female.Sticky = true;
                Female.Function =  FemaleF;
                Female.Parent = Window;
            }
            public static void ConfirmF()
            {
                Out.NewCharacter();
            }
            public static void CancelF()
            {
                Window.CleanUp();
            }
            public static void WarriorF()
            {
                SelectedClass = Class.Warrior;
                Warrior.State = ButtonState.Pressed;
                Wizard.State = ButtonState.Normal;
                Taoist.State = ButtonState.Normal;
                Assassin.State = ButtonState.Normal;
            }
            public static void WizardF()
            {
                SelectedClass = Class.Wizard;
                Warrior.State = ButtonState.Normal;
                Wizard.State = ButtonState.Pressed;
                Taoist.State = ButtonState.Normal;
                Assassin.State = ButtonState.Normal;
            }
            public static void TaoistF()
            {
                SelectedClass = Class.Taoist;
                Warrior.State = ButtonState.Normal;
                Wizard.State = ButtonState.Normal;
                Taoist.State = ButtonState.Pressed;
                Assassin.State = ButtonState.Normal;
            }
            public static void AssassinF()
            {
                SelectedClass = Class.Assassin;
                Warrior.State = ButtonState.Normal;
                Wizard.State = ButtonState.Normal;
                Taoist.State = ButtonState.Normal;
                Assassin.State = ButtonState.Pressed;
            }
            public static void MaleF()
            {
                SelectedSex = Gender.Male;
                Male.State = ButtonState.Pressed;
                Female.State = ButtonState.Normal;
            }
            public static void FemaleF()
            {
                SelectedSex = Gender.Female;
                Male.State = ButtonState.Normal;
                Female.State = ButtonState.Pressed;
            }
            public static void DrawExtraF()
            {
                Point TPoint = Window.Location;
                TPoint.Offset(50, 50);
                if (Config.DrawMethod2)
                    Graphics.S.Draw2D(Graphics.GTexture, new Rectangle(0, 0, 300, 400), Rectangle.Empty, TPoint, Color.Black.ToArgb());
                else
                    Graphics.S.Draw(Graphics.GTexture, new Rectangle(0, 0, 300, 400), Vector3.Empty, new Vector3(TPoint.X, TPoint.Y, 0), Color.Black.ToArgb());
                Point tempPoint = Window.Location;
                switch (SelectedClass)
                {
                    case Class.Warrior:
                        if (SelectedSex == Gender.Male)
                            CLib.Interface.Draw(60 + CurrentFrame, new Point(tempPoint.X + 90, tempPoint.Y + 122), true);
                        else
                            CLib.Interface.Draw(60 + 16 + CurrentFrame, new Point(tempPoint.X + 90, tempPoint.Y + 122), true);
                        break;
                    case Class.Wizard:
                        if (SelectedSex == Gender.Male)
                        {
                            CLib.Interface.Draw(92 + CurrentFrame, new Point(tempPoint.X + 90, tempPoint.Y + 58), true);
                            CLib.Interface.DrawBlend(251 + CurrentFrame, new Point(tempPoint.X + 90, tempPoint.Y + 58), true, Color.White);
                        }
                        else
                        {
                            CLib.Interface.Draw(92 + 16 + CurrentFrame, new Point(tempPoint.X + 100, tempPoint.Y + 88), true);
                            CLib.Interface.DrawBlend(251 + 16 + CurrentFrame, new Point(tempPoint.X + 100, tempPoint.Y + 88), true, Color.White);
                        }
                        break;
                    case Class.Taoist:
                        if (SelectedSex == Gender.Male)
                            CLib.Interface.Draw(124 + CurrentFrame, new Point(tempPoint.X + 100, tempPoint.Y + 122), true);
                        else
                            CLib.Interface.Draw(124 + 16 + CurrentFrame, new Point(tempPoint.X + 100, tempPoint.Y + 122), true);
                        break;
                    case Class.Assassin:
                        if (SelectedSex == Gender.Male)
                            CLib.Interface.Draw(156 + CurrentFrame, new Point(tempPoint.X + 118, tempPoint.Y + 122), true);
                        else
                            CLib.Interface.Draw(156 + 16 + CurrentFrame, new Point(tempPoint.X + 118, tempPoint.Y + 122), true);
                        break;
                }
                if (DateTime.Now - LastFrame > new TimeSpan(0, 0, 0, 0, 150))
                {
                    LastFrame = DateTime.Now;
                    CurrentFrame++;
                    if (CurrentFrame > 15) CurrentFrame = 0;
                }
            }
        }
        public static class MessageDialogVars
        {
            public static Window Window;
            public static Button Close;

            public static void Create()
            {
                Window = new Window(188, WindowPosition.Centre, false, false, true);
                Window.DrawAfter = DrawExtraF;
                Close = new Button(189, new Point(258, 83), true, SoundList.ButtonClick, true, 1);
                Close.Function = CloseF;
                Close.Parent = Window;
            }
            public static void CloseF()
            {
                Window.Visible = false;
            }
            public static void QuitF()
            {
                Engine.GameRunning = false;
            }
            public static void DrawExtraF()
            {
                if (!string.IsNullOrEmpty(Window.Text))
                    Graphics.DXNormalFont.DrawText(Graphics.S, Window.Text, Point.Add(Window.Location, new Size(40, 30)), Color.White);

            }
            public static void Loading()
            {
                if (Engine.T.ThreadState == System.Threading.ThreadState.Running) return;
                Close.Visible = true;
                Window.DrawBefore = null;
                Window.Visible = false;
                Out.StartGame();
            }
        }
        public static class QuestionDialogVars
        {
            public static DateTime DialogTime;
            public static Window Window;
            public static Button Yes, No;

            public static void Create()
            {
                DialogTime = DateTime.Now;
                Window = new Window(250, WindowPosition.Centre, false, false, true);

                No = new Button(246, new Point(401, 162), true, SoundList.ButtonClick, true, 1);
                No.Parent = Window;
                Yes = new Button(244, new Point(28, 162), false, SoundList.ButtonClick, true, 1);
                Yes.Parent = Window;
            }
            public static void CloseF()
            {
                Window.Visible = false;
            }
            public static void QuitF()
            {
                Engine.GameRunning = false;
            }
            public static void RetryF()
            {
                Window.Text = "Waiting for Connection....";
                DialogTime = DateTime.Now;
                No.Image = 246;
                Yes.Visible = false;
                Yes.Function = CloseF;
                Window.DrawAfter = NoConnectionF;
                Network.Connect();
            }
            public static void ConfirmDeleteF()
            {
                Out.DeleteCharacter();
            }
            public static void NoConnectionF()
            {
                if (DateTime.Now < DialogTime + new TimeSpan(0, 0, 11))
                {
                    int seconds = 10 - (DateTime.Now - DialogTime).Duration().Seconds;
                    if (!string.IsNullOrEmpty(Window.Text))
                        Graphics.DXNormalFont.DrawText(Graphics.S, Window.Text + seconds.ToString(), Point.Add(Window.Location, new Size(40, 30)), Color.White);
                    if (seconds <= 0)
                    {
                        DialogTime = DateTime.Now - new TimeSpan(0, 0, 14);
                        Window.Text = "Failed to Connect to the Server. \n\nWould you like to Retry?";
                        Yes.Visible = true;
                        No.Image = 248;
                        Window.DrawAfter = DrawExtraF;
                    }
                }
                else
                {
                    if (!string.IsNullOrEmpty(Window.Text))
                        Graphics.DXNormalFont.DrawText(Graphics.S, Window.Text + Engine.CharacterList[Engine.CharSelected].Name, Point.Add(Window.Location, new Size(40, 30)), Color.White);
                }
            }
            public static void DeleteCharacterF()
            {
                if (DateTime.Now > DialogTime + new TimeSpan(0, 0, 6))
                {
                    if (5 - (DateTime.Now - DialogTime).Duration().Seconds <= 0)
                    {
                        DialogTime = DateTime.Now - new TimeSpan(0, 0, 10);
                        Yes.Visible = true;
                        Yes.Function = ConfirmDeleteF;
                        No.Image = 248;
                    }
                }

                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format(Window.Text, Engine.CharacterList[Engine.CharSelected].Name), Point.Add(Window.Location, new Size(40, 30)), Color.White);

            }
            public static void DrawExtraF()
            {
                if (!string.IsNullOrEmpty(Window.Text))
                    Graphics.DXNormalFont.DrawText(Graphics.S, Window.Text, Point.Add(Window.Location, new Size(30, 40)), Color.White);
            }
            public static void ReviveF()
            {
                Out.Revive();
                Window.Visible = false;
            }
        }

        public static void LoginAccepted()
        {
            LoginDialog.Window.CleanUp();
            AccountDialog.Window.CleanUp();
            SafeDialog.Window.CleanUp();
            PasswordDialog.Window.CleanUp();
            Engine.CurrentStage = GameStage.LoggingIn;
            BackGrounds.LoggingIn.Visible = true;
            BackGrounds.Login.Visible = false;
        }
        public static void Create()
        {
            BackGrounds.Create();
            LoginDialog.Create();
            AccountDialog.Create();
            SafeDialog.Create();
            PasswordDialog.Create();
            MessageDialogVars.Create();
            NewCharacterVars.Create();
            QuestionDialogVars.Create();
            CharSelVars.Create();
        }
    }

    class GameScene
    {
        public static class Bag
        {
            public static Window Window;
            public static Button Items, Quests, Close, Gold;
            public static ItemGrid ItemGrid, QuestGrid;

            public static void Create()
            {
                Window = new Window(57, WindowPosition.TopLeft, false, true, false);

                Items = new Button(219, new Point(28, 29), true, SoundList.SmallClick);
                Items.Function = ItemsF;
                Items.Sticky = true;
                Items.State = ButtonState.Pressed;
                Items.Parent = Window;

                Quests = new Button(220, new Point(123, 29), true, SoundList.SmallClick);
                Quests.Function = QuestsF;
                Quests.Sticky = true;
                Quests.Parent = Window;

                Gold = new Button(216, new Point(15, 242), true, SoundList.SmallClick, true, 0);// Gold Click
                Gold.Function = GoldF;
                Gold.Parent = Window;

                Close = new Button(239, new Point(322, 5), true, SoundList.SmallClick);
                Close.Function = CloseF;
                Close.Parent = Window;

                ItemGrid = new ItemGrid(new Size(8, 5), new Size(34, 30), 3, 3, true, new Point(26, 61));
                ItemGrid.Parent = Window;
                ItemGrid.IOffSet = 6;

                QuestGrid = new ItemGrid(new Size(8, 5), new Size(34, 30), 3, 3, true, new Point(26, 61));
                QuestGrid.Parent = Window;
            }
            public static void CloseF()
            {
                Window.Visible = false;
            }
            public static void GoldF()
            {
            }
            public static void QuestsF()
            {
                Quests.State = ButtonState.Pressed;
                Items.State = ButtonState.Normal;
                ItemGrid.Visible = false;
                QuestGrid.Visible = true;
            }
            public static void ItemsF()
            {
                Quests.State = ButtonState.Normal;
                Items.State = ButtonState.Pressed;
                ItemGrid.Visible = true;
                QuestGrid.Visible = false;
            }
        }
        public static class Character
        {
            public static Window Window;
            public static Button Close;
            public static ItemGrid Necklace, BraceR, BraceL, RingR, RingL, Helmet, Weapon, Armor, Boots, Belt, Candle, Stone, Amulet, Poison, Medal;

            public static void Create()
            {
                Window = new Window(300, WindowPosition.TopRight, false, true, false);
                Window.DrawAfter = WindowF;

                Close = new Button(308, new Point(291, 17), true, SoundList.ButtonClick);
                Close.Function = CloseF;
                Close.Parent = Window;

                Helmet = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(177, 110));
                Helmet.Parent = Window;
                Helmet.IOffSet = (byte)ItemLocation.Helmet;

                Armor = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(15, 145));
                Armor.Parent = Window;
                Armor.IOffSet = (byte)ItemLocation.Armour;

                Weapon = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(15, 110));
                Weapon.Parent = Window;
                Weapon.IOffSet = (byte)ItemLocation.Weapon;

                Necklace = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(177, 144));
                Necklace.Parent = Window;
                Necklace.IOffSet = (byte)ItemLocation.Necklace;

                BraceL = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(15, 180));
                BraceL.Parent = Window;
                BraceL.IOffSet = (byte)ItemLocation.BraceletL;

                BraceR = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(177, 179));
                BraceR.Parent = Window;
                BraceR.IOffSet = (byte)ItemLocation.BraceletR;

                RingL = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(15, 215));
                RingL.Parent = Window;
                RingL.IOffSet = (byte)ItemLocation.RingL;

                RingR = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(177, 214));
                RingR.Parent = Window;
                RingR.IOffSet = (byte)ItemLocation.RingR;

                Candle = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(95, 284));
                Candle.Parent = Window;
                Candle.IOffSet = (byte)ItemLocation.Candle;

                Boots = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(15, 285));
                Boots.Parent = Window;
                Boots.IOffSet = (byte)ItemLocation.Boots;

                Poison = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(177, 249));
                Poison.Parent = Window;
                Poison.IOffSet = (byte)ItemLocation.Poison;

                Amulet = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(177, 285));
                Amulet.Parent = Window;
                Amulet.IOffSet = (byte)ItemLocation.Amulet;

                Candle = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(142, 285));
                Candle.Parent = Window;
                Candle.IOffSet = (byte)ItemLocation.Candle;

                Medal = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(97, 285));
                Medal.Parent = Window;
                Medal.IOffSet = (byte)ItemLocation.Medal;

                Belt = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(50, 285));
                Belt.Parent = Window;
                Belt.IOffSet = (byte)ItemLocation.Belt;

                Stone = new ItemGrid(new Size(1, 1), new Size(35, 35), 0, 0, true, new Point(15, 250));
                Stone.Parent = Window;
                Stone.IOffSet = (byte)ItemLocation.Stone;
            }
            public static void CloseF()
            {
                Window.Visible = false;
            }
            public static void WindowF()
            {
                //Level
                string S = null;
                Point TempPoint = Window.Location;
                TempPoint.Offset(5, 2);
                TempPoint.Offset(222,106);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("Lvl: {0}", User.Info.Level), TempPoint, Color.White);

                //Exp
                if (User.Info.MaxExp > 0)
                    S = Math.Round((User.Info.Exp / (double)User.Info.MaxExp), 4).ToString("0.00%");
                else
                    S = "0.00%";
                TempPoint.Offset(0, 24);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("Exp: " + S), TempPoint, Color.White);

                //HP
                S = string.Format("{0}/{1}", User.Info.CurrentHP, User.Info.TotalStats.Basic.HP);
                TempPoint.Offset(0, 24);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("HP: " + S), TempPoint, Color.White);

                //MP
                S = string.Format("{0}/{1}", User.Info.CurrentMP, User.Info.TotalStats.Basic.MP);
                TempPoint.Offset(0, 24);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("MP: " + S), TempPoint, Color.White);

                TempPoint.Offset(0, 24);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("MR: {0}%", User.Info.TotalStats.Advanced.MR), TempPoint, Color.White);
                TempPoint.Offset(0, 24);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("PR: {0}%", User.Info.TotalStats.Advanced.PR), TempPoint, Color.White);
                TempPoint.Offset(0, 24);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("CR: {0}%", User.Info.TotalStats.Advanced.CR), TempPoint, Color.White);
                TempPoint.Offset(0, 24);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("Acc: {0}", User.Info.TotalStats.Basic.Accuracy), TempPoint, Color.White);
                TempPoint.Offset(0, 24);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("Agi: {0}", User.Info.TotalStats.Basic.Agility), TempPoint, Color.White);

                TempPoint = Window.Location;
                TempPoint.Offset(11, 386);
                Graphics.DXNormalFont.DrawText(Graphics.S, "Attack:", TempPoint, Color.White);
                TempPoint.Y += 25;
                Graphics.DXNormalFont.DrawText(Graphics.S, "Defence:", TempPoint, Color.White);

                #region Attack
                TempPoint = Window.Location;
                TempPoint.Offset(63, 386);
                if (User.Info.TotalStats.Elemental.FireA > 0)
                {
                    CLib.Interface.Draw(301, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.FireA < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.FireA.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.FireA < 0)
                {
                    CLib.Interface.Draw(301, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.FireA.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 100;
                if (User.Info.TotalStats.Elemental.IceA > 0)
                {
                    CLib.Interface.Draw(302, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.IceA < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.IceA.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.IceA < 0)
                {
                    CLib.Interface.Draw(302, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.IceA.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 137;
                if (User.Info.TotalStats.Elemental.LightningA > 0)
                {
                    CLib.Interface.Draw(303, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.LightningA < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.LightningA.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.LightningA < 0)
                {
                    CLib.Interface.Draw(303, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.LightningA.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 174;
                if (User.Info.TotalStats.Elemental.WindA > 0)
                {
                    CLib.Interface.Draw(304, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.WindA < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.WindA.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.WindA < 0)
                {
                    CLib.Interface.Draw(304, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.WindA.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 211;
                if (User.Info.TotalStats.Elemental.HolyA > 0)
                {
                    CLib.Interface.Draw(305, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.HolyA < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.HolyA.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.HolyA < 0)
                {
                    CLib.Interface.Draw(305, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.HolyA.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 248;
                if (User.Info.TotalStats.Elemental.DarkA > 0)
                {
                    CLib.Interface.Draw(306, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.DarkA < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.DarkA.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.DarkA < 0)
                {
                    CLib.Interface.Draw(306, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.DarkA.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 285;
                if (User.Info.TotalStats.Elemental.IllusionA > 0)
                {
                    CLib.Interface.Draw(307, TempPoint, false);
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.IllusionA.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.IllusionA < 0)
                {
                    CLib.Interface.Draw(307, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.IllusionA.ToString(), TempPoint, Color.Red);
                }
                #endregion

                #region Defense
                TempPoint = Window.Location;
                TempPoint.Offset(63, 411);
                if (User.Info.TotalStats.Elemental.FireD > 0)
                {
                    CLib.Interface.Draw(301, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.FireD < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.FireD.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.FireD < 0)
                {
                    CLib.Interface.Draw(301, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.FireD.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 100;
                if (User.Info.TotalStats.Elemental.IceD > 0)
                {
                    CLib.Interface.Draw(302, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.IceD < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.IceD.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.IceD < 0)
                {
                    CLib.Interface.Draw(302, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.IceD.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 137;
                if (User.Info.TotalStats.Elemental.LightningD > 0)
                {
                    CLib.Interface.Draw(303, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.LightningD < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.LightningD.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.LightningD < 0)
                {
                    CLib.Interface.Draw(303, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.LightningD.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 174;
                if (User.Info.TotalStats.Elemental.WindD > 0)
                {
                    CLib.Interface.Draw(304, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.WindD < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.WindD.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.WindD < 0)
                {
                    CLib.Interface.Draw(304, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.WindD.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 211;
                if (User.Info.TotalStats.Elemental.HolyD > 0)
                {
                    CLib.Interface.Draw(305, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.HolyD < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.HolyD.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.HolyD < 0)
                {
                    CLib.Interface.Draw(305, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.HolyD.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 248;
                if (User.Info.TotalStats.Elemental.DarkD > 0)
                {
                    CLib.Interface.Draw(306, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.DarkD < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.DarkD.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.DarkD < 0)
                {
                    CLib.Interface.Draw(306, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.DarkD.ToString(), TempPoint, Color.Red);
                }

                TempPoint.X = Window.Location.X + 285;
                if (User.Info.TotalStats.Elemental.IllusionD > 0)
                {
                    CLib.Interface.Draw(307, TempPoint, false);
                    if (User.Info.TotalStats.Elemental.IllusionD < 10)
                        TempPoint.X += 3;
                    TempPoint.X += 16;
                    Graphics.DXNormalFont.DrawText(Graphics.S, "+" + User.Info.TotalStats.Elemental.IllusionD.ToString(), TempPoint, Color.Green);
                }
                else if (User.Info.TotalStats.Elemental.IllusionD < 0)
                {
                    CLib.Interface.Draw(307, TempPoint, false);
                    TempPoint.X += 19;
                    Graphics.DXNormalFont.DrawText(Graphics.S, User.Info.TotalStats.Elemental.IllusionD.ToString(), TempPoint, Color.Red);
                }
                #endregion

                TempPoint = Window.Location;
                TempPoint.Offset(3, 1);
                TempPoint.Offset(11, 337);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("AC: {0}~{1}", User.Info.TotalStats.Basic.AC, User.Info.TotalStats.Basic.AC2), TempPoint, Color.White);
                TempPoint.Offset(103, 0);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("MAC: {0}~{1}", User.Info.TotalStats.Basic.MAC, User.Info.TotalStats.Basic.MAC2), TempPoint, Color.White);
                TempPoint.Offset(103, 0);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("Luck: {0}", User.Info.TotalStats.Advanced.Luck), TempPoint, Color.White);
                TempPoint.Offset(-206, 25);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("DC: {0}~{1}", User.Info.TotalStats.Basic.DC, User.Info.TotalStats.Basic.DC2), TempPoint, Color.White);
                TempPoint.Offset(103, 0);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("MC: {0}~{1}", User.Info.TotalStats.Basic.MC, User.Info.TotalStats.Basic.MC2), TempPoint, Color.White);
                TempPoint.Offset(103, 0);
                Graphics.DXNormalFont.DrawText(Graphics.S, string.Format("SC: {0}~{1}", User.Info.TotalStats.Basic.SC, User.Info.TotalStats.Basic.SC2), TempPoint, Color.White);

            }
        }
        public static class Belt
        {
            public static Window Window;
            public static Button Close, Flip;
            public static ItemGrid ItemGrid;

            public static void Create()
            {
                Window = new Window(236, WindowPosition.BottomLeft, false, true, false);

                Close = new Button(238, new Point(1, 239), true, SoundList.SmallClick);
                Close.Function = CloseF;
                Close.Parent = Window;

                Flip = new Button(237, new Point(20, 239), true, SoundList.SmallClick);
                Flip.Function = FlipF;
                Flip.Parent = Window;

                ItemGrid = new ItemGrid(new Size(1, 6), new Size(30, 32), 4, 4, true, new Point(5, 20));
                ItemGrid.Parent = Window;
            }
            public static void FlipF()
            {
                if (Window.Image == 233)
                {
                    //To Vertical
                    Window.Image = 236;
                    Close.Location = new Point(1, 239);
                    Close.Image = 238;
                    Flip.Location = new Point(20, 239);
                    Flip.Image = 237;


                    ItemGrid.Location = new Point(5, 20);
                    ItemGrid.DrawPoint = new Point(5, 20);
                    ItemGrid.CellSize = new Size(30, 32);
                    ItemGrid.NewSize(new Size(1, 6));


                }
                else
                {
                    //To Horizontal
                    Window.Image = 233;
                    Close.Location = new Point(239, 21);
                    Close.Image = 235;
                    Flip.Location = new Point(239, 1);
                    Flip.Image = 234;

                    ItemGrid.Location = new Point(20, 5);
                    ItemGrid.DrawPoint = new Point(20, 5);
                    ItemGrid.CellSize = new Size(32, 30);
                    ItemGrid.NewSize(new Size(6, 1));

                }
            }
            public static void CloseF()
            {
                Window.Visible = false;
            }
        }
        public static class ButtonDock
        {
            public static Window Window;
            public static Button CharB, BagB, Skill, Trade, BeltB, Map, Quest, Options;

            public static void Create()
            {
                Window = new Window(221, WindowPosition.BottomRight, true, true, false);

                CharB = new Button(223, new Point(4, 4), true, SoundList.SmallClick);
                CharB.Function = CharacterF;
                CharB.Parent = Window;

                BagB = new Button(224, new Point(38, 4), true, SoundList.SmallClick);
                BagB.Function = BagF;
                BagB.Parent = Window;

                Skill = new Button(225, new Point(72, 4), true, SoundList.SmallClick);
                Skill.Function = SkillF;
                Skill.Parent = Window;

                Trade = new Button(230, new Point(106, 4), true, SoundList.SmallClick);
                Trade.Function = TradeF;
                Trade.Parent = Window;

                BeltB = new Button(226, new Point(140, 4), true, SoundList.SmallClick);
                BeltB.Function = BeltF;
                BeltB.Parent = Window;

                Map = new Button(227, new Point(174, 4), true, SoundList.SmallClick);
                Map.Function = MapF;
                Map.Parent = Window;

                Quest = new Button(228, new Point(208, 4), true, SoundList.SmallClick);
                Quest.Function = QuestF;
                Quest.Parent = Window;

                Options = new Button(229, new Point(242, 4), true, SoundList.SmallClick);
                Options.Function = OptionsF;
                Options.Parent = Window;
            }
            public static void CharacterF()
            {
                Character.Window.Visible = !Character.Window.Visible;
            }
            public static void BagF()
            {
                Bag.Window.Visible = !Bag.Window.Visible;
            }
            public static void SkillF()
            {
            }
            public static void TradeF()
            {
            }
            public static void BeltF()
            {
                Belt.Window.Visible = !Belt.Window.Visible;
            }
            public static void MapF()
            {
            }
            public static void QuestF()
            {
            }
            public static void OptionsF()
            {
            }
        }
        public static class Stats
        {
            public static void Create()
            {

            }
        }
        public static class HealthBar
        {
            public static Window Window;

            public static void Create()
            {
                Window = new Window(56, WindowPosition.TopMiddle, true,true , false);
                Window.DrawAfter = DrawHealthF;
            }
            public static void DrawHealthF()
            {
                int Width;
                Texture T;
                Point TPoint;
                if (User.Info != null)
                {
                    TPoint = Window.Location;
                    Graphics.S.Flush();
                    TPoint.Offset(17, 6);
                    if (User.Info.CurrentHP > 0 && User.Info.TotalStats.Basic.HP > 0)
                    {
                        Width = (int)Math.Round(180 * User.Info.CurrentHP / (float)User.Info.TotalStats.Basic.HP);
                        if (Width > 180) Width = 180;
                        if (Width < 0) Width = 0;
                        T = CLib.Interface.GetTexture(211);
                        if (T != null)
                        {
                            if (Config.DrawMethod2)
                                Graphics.S.Draw2D(T, new Rectangle(0, 0, Width, 12), Rectangle.Empty, TPoint, Color.White.ToArgb());
                            else
                                Graphics.S.Draw(T, new Rectangle(0, 0, Width, 12), Vector3.Empty, new Vector3(TPoint.X, TPoint.Y, 0), Color.White.ToArgb());
                        }
                    }
                    Graphics.S.Flush();
                    TPoint.Offset(0, 16);
                    if (User.Info.CurrentMP > 0 && User.Info.TotalStats.Basic.MP > 0)
                    {
                        Width = (int)Math.Round(180 * User.Info.CurrentMP / (float)User.Info.TotalStats.Basic.MP);
                        if (Width > 180) Width = 180;
                        if (Width < 0) Width = 0;
                        T = CLib.Interface.GetTexture(212);
                        if (T != null)
                        {
                            if (Config.DrawMethod2)
                                Graphics.S.Draw2D(T, new Rectangle(0, 0, Width, 12), Rectangle.Empty, TPoint, Color.White.ToArgb());
                            else
                                Graphics.S.Draw(T, new Rectangle(0, 0, Width, 12), Vector3.Empty, new Vector3(TPoint.X, TPoint.Y, 0), Color.White.ToArgb());
                        }
                        
                    }
                    TPoint = Window.Location;
                    TPoint.Offset(17, 6);
                    Graphics.DXNormalFont.DrawText(
                        Graphics.S,
                        string.Format("{0}/{1}", User.Info.CurrentHP, User.Info.TotalStats.Basic.HP),
                        new Rectangle(TPoint, new Size(180, 12)),
                        DrawTextFormat.Center | DrawTextFormat.VerticalCenter,
                        Color.White);
                    TPoint.Offset(0, 16);
                    Graphics.DXNormalFont.DrawText(
                        Graphics.S,
                        string.Format("{0}/{1}", User.Info.CurrentMP, User.Info.TotalStats.Basic.MP),
                        new Rectangle(TPoint, new Size(180, 12)),
                        DrawTextFormat.Center | DrawTextFormat.VerticalCenter,
                        Color.White);                        
                }

            }
        }
        public static class ChatBar
        {
            public static Window Window;
            public static TextBox ChatBox;
            public static void Create()
            {
                Window = new Window(231, new Point(167, 573), false, true, false);

                ChatBox = new TextBox(new Point(19, 3), new Size(321, 19), true);
                ChatBox.Parent = Window;
                ChatBox.MaxLength = 50;
                ChatBox.AnyLetter = true;
            }
        }
        public static class ChatBox
        {


        }

        public static void Create()
        {
            Bag.Create();
            Character.Create();
            Belt.Create();
            ButtonDock.Create();
            Stats.Create();
            HealthBar.Create();
            ChatBar.Create();
        }
    }
}
