﻿using System;
using System.Windows.Forms;
using System.Diagnostics;

namespace Clash_Client
{
    public partial class Main : Form
    {
        public static bool CtrlDown, ShiftDown, AltDown;
        public Main()
        {
            InitializeComponent();
            Config.Load();
         //   TopMost = Config.TopMost;
            ClientSize = Config.CScreenSize;
            SetStyle(ControlStyles.UserPaint | ControlStyles.AllPaintingInWmPaint | ControlStyles.Opaque, true);
            if (!Config.WindowMode) FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
        }

        private void Main_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                if (ItemGrid.PItem != null)
                {
                    ItemGrid.PItemArray[ItemGrid.PIndex] = ItemGrid.PItem;
                    ItemGrid.PItemArray = null;
                    ItemGrid.PItem = null;
                    ItemGrid.PIndex = -1;
                    return;
                }
                for (int I = 0; I < Window.WindowList.Count; I++)
                    if (Window.WindowList[I].RightClick(PointToClient(Cursor.Position)))
                        return;
            }
            else
            {
                for (int I = 0; I < Window.WindowList.Count; I++)
                    if (Window.WindowList[I].Click(PointToClient(Cursor.Position)))
                        return;

                switch (Engine.CurrentStage)
                {
                    case GameStage.CharSel:
                        IntroScenes.BackGrounds.CharSel.Click(PointToClient(Cursor.Position));
                        return;
                }
            }
        }
        private void Main_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                for (int I = 0; I < Window.WindowList.Count; I++)
                    if (Window.WindowList[I].DoubleClick(PointToClient(Cursor.Position)))
                        return;

                switch (Engine.CurrentStage)
                {
                    case GameStage.CharSel:
                        IntroScenes.BackGrounds.CharSel.DoubleClick(PointToClient(Cursor.Position));
                        return;
                }
            }
        }
        private void Main_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left) Engine.LeftDown = true;
            if (e.Button == MouseButtons.Right) Engine.RightDown = true;
            for (int I = 0; I < Window.WindowList.Count; I++)
                if (Window.WindowList[I].MouseDown(PointToClient(Cursor.Position))) return;


            switch (Engine.CurrentStage)
            {
                case GameStage.CharSel:
                    IntroScenes.BackGrounds.CharSel.MouseDown(PointToClient(Cursor.Position));
                    return;
            }
        }
        private void Main_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left) Engine.LeftDown = false;
            if (e.Button == MouseButtons.Right)
            {
                User.CanRun = false;
                Engine.RightDown = false;
            }
            if (e.Button == MouseButtons.Left)
            {
                for (int I = 0; I < Window.WindowList.Count; I++)
                    Window.WindowList[I].MouseUp();
            }
            switch (Engine.CurrentStage)
            {
                case GameStage.CharSel:
                    IntroScenes.BackGrounds.CharSel.MouseUp();
                    break;
            }
        }
        private void Main_MouseMove(object sender, MouseEventArgs e)
        {
            ItemGrid.HItem = null;
            for (int I = 0; I < Window.WindowList.Count; I++)
                if (Window.WindowList[I].MouseMove(PointToClient(Cursor.Position))) return;

            switch (Engine.CurrentStage)
            {
                case GameStage.CharSel:
                    IntroScenes.BackGrounds.CharSel.MouseMove(PointToClient(Cursor.Position));
                    return;
            }
        }
        private void Main_FormClosing(object sender, FormClosingEventArgs e)
        {
            Engine.GameRunning = false;
        }
        private void Main_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter)
            {
                if (TextBox.Focused == IntroScenes.LoginDialog.LoginID)
                    IntroScenes.LoginDialog.Password.Select();
                else if (TextBox.Focused == IntroScenes.LoginDialog.Password)
                    IntroScenes.LoginDialog.OKF();
                else if (IntroScenes.QuestionDialogVars.Window.Visible)
                {
                    if (IntroScenes.QuestionDialogVars.Yes.Visible) IntroScenes.QuestionDialogVars.Yes.Function.Invoke();
                }
                else if (IntroScenes.MessageDialogVars.Window.Visible)
                    IntroScenes.MessageDialogVars.Close.Function.Invoke();
                else if (Engine.CurrentStage == GameStage.Game)
                {
                    if (GameScene.ChatBar.Window.Visible)
                    {
                        Out.SendPacket(new Client_Packets.Chat(GameScene.ChatBar.ChatBox.Text));
                        GameScene.ChatBar.Window.CleanUp();
                    }
                    else
                    {
                        GameScene.ChatBar.Window.Visible = Visible;
                        GameScene.ChatBar.ChatBox.Select();
                    }


                }
            }

            if (TextBox.Focused != null)
            {
                if (e.KeyChar == (char)3) //Copy
                {
                    if (TextBox.Focused.SelWidth < 0)
                        Clipboard.SetText(TextBox.Focused.Text.Substring(TextBox.Focused.SelStart + TextBox.Focused.SelWidth, -TextBox.Focused.SelWidth));
                    else if (TextBox.Focused.SelWidth > 0)
                        Clipboard.SetText(TextBox.Focused.Text.Substring(TextBox.Focused.SelStart, TextBox.Focused.SelWidth));
                }
                else if (e.KeyChar == (char)22) //Paste
                {
                    TextBox.Focused.Type(Clipboard.GetText());
                }
                else if (e.KeyChar == (char)24) //Cut
                {
                    if (TextBox.Focused.SelWidth < 0)
                        Clipboard.SetText(TextBox.Focused.Text.Substring(TextBox.Focused.SelStart + TextBox.Focused.SelWidth, -TextBox.Focused.SelWidth));                    
                    else if (TextBox.Focused.SelWidth > 0)
                        Clipboard.SetText(TextBox.Focused.Text.Substring(TextBox.Focused.SelStart, TextBox.Focused.SelWidth));                    
                    else return;
                    TextBox.Focused.Delete();
                }
                else if (Char.IsLetterOrDigit(e.KeyChar))
                {
                    TextBox.Focused.Type(e.KeyChar.ToString());
                }
                else if (TextBox.Focused.AnyLetter && (Char.IsPunctuation(e.KeyChar) || Char.IsSeparator(e.KeyChar) || Char.IsSymbol(e.KeyChar)))
                {
                    TextBox.Focused.Type(e.KeyChar.ToString());
                }
                else if (e.KeyChar == (char)Keys.Back)
                {
                    TextBox.Focused.BackSpace();
                }
            }
            else if (Engine.CurrentStage == GameStage.Game)
            {
                switch (e.KeyChar)
                {
                    case 'B':
                    case 'b':
                        GameScene.ButtonDock.BagF();
                        break;
                    case 'C':
                    case 'c':
                        GameScene.ButtonDock.CharacterF();
                        break;
                    case 'Z':
                    case 'z':
                        GameScene.ButtonDock.BeltF();
                        break;
                    case (char)26: //Ctrl Z
                        GameScene.Belt.FlipF();
                        break;
                }


            }

        }
        private void Main_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Alt && e.KeyCode == Keys.F4)
            {
                Process.GetCurrentProcess().Kill();
                e.Handled = true;
                return;
            }

            switch (e.KeyCode)
            {
                case Keys.F4:

                    break;
                case Keys.Home:
                    if (TextBox.Focused != null)
                    {
                        if (ShiftDown)
                        {
                            if (TextBox.Focused.SelWidth == 0)
                                TextBox.Focused.SelStart = TextBox.Focused.TextPointer;
                            
                            TextBox.Focused.TextPointer = 0;
                            TextBox.Focused.SelWidth = TextBox.Focused.TextPointer - TextBox.Focused.SelStart;
                        }
                        else
                        {
                            TextBox.Focused.TextPointer = 0;
                            TextBox.Focused.SelStart = 0;
                            TextBox.Focused.SelWidth = 0;
                        }
                        return;
                    }
                    break;
                case Keys.End:
                    if (TextBox.Focused != null)
                    {
                        if (ShiftDown)
                        {
                            if (TextBox.Focused.SelWidth == 0)
                                TextBox.Focused.SelStart = TextBox.Focused.TextPointer;
                            TextBox.Focused.TextPointer = TextBox.Focused.Text.Length;
                            TextBox.Focused.SelWidth = TextBox.Focused.TextPointer - TextBox.Focused.SelStart;
                        }
                        else
                        {
                            TextBox.Focused.TextPointer = TextBox.Focused.Text.Length;
                            TextBox.Focused.SelStart = 0;
                            TextBox.Focused.SelWidth = 0;
                        }
                        return;
                    }
                    break;
                case Keys.Left:
                    if (TextBox.Focused != null)
                    {
                        if (ShiftDown)
                        {
                            if (TextBox.Focused.SelWidth == 0)
                                TextBox.Focused.SelStart = TextBox.Focused.TextPointer;

                            if (TextBox.Focused.TextPointer > 0)
                            {
                                TextBox.Focused.TextPointer = TextBox.Focused.TextPointer - 1;
                                TextBox.Focused.SelWidth = TextBox.Focused.TextPointer - TextBox.Focused.SelStart;
                            }
                        }
                        else
                        {
                            if (TextBox.Focused.TextPointer > 0)
                                TextBox.Focused.TextPointer = TextBox.Focused.TextPointer - 1;
                            TextBox.Focused.SelStart = 0;
                            TextBox.Focused.SelWidth = 0;
                        }
                        return;
                    }
                    break;
                case Keys.Right:
                    if (TextBox.Focused != null)
                    {
                        if (ShiftDown)
                        {
                            if (TextBox.Focused.SelWidth == 0)
                                TextBox.Focused.SelStart = TextBox.Focused.TextPointer;

                            if (TextBox.Focused.TextPointer < TextBox.Focused.Text.Length)
                            {
                                TextBox.Focused.TextPointer = TextBox.Focused.TextPointer + 1;
                                TextBox.Focused.SelWidth = TextBox.Focused.TextPointer - TextBox.Focused.SelStart;
                            }
                        }
                        else
                        {
                            if (TextBox.Focused.TextPointer < TextBox.Focused.Text.Length)
                                TextBox.Focused.TextPointer = TextBox.Focused.TextPointer + 1;
                            TextBox.Focused.SelStart = 0;
                            TextBox.Focused.SelWidth = 0;
                        }
                        return;
                    }
                    break;
                case Keys.Delete:
                    if (TextBox.Focused != null)
                    {
                        TextBox.Focused.Delete();
                        return;
                    }
                    break;
                case Keys.Tab:
                    if (TextBox.Focused != null)
                    {
                        if (!ShiftDown)
                        {
                            if (TextBox.Focused.Parent.TextBoxList.IndexOf(TextBox.Focused) < TextBox.Focused.Parent.TextBoxList.Count - 1)
                                TextBox.Focused.Parent.TextBoxList[TextBox.Focused.Parent.TextBoxList.IndexOf(TextBox.Focused) + 1].Select();
                            else
                                TextBox.Focused.Parent.TextBoxList[0].Select();
                        }
                        else
                        {
                            if (TextBox.Focused.Parent.TextBoxList.IndexOf(TextBox.Focused) > 0)
                                TextBox.Focused.Parent.TextBoxList[TextBox.Focused.Parent.TextBoxList.IndexOf(TextBox.Focused) - 1].Select();
                            else
                                TextBox.Focused.Parent.TextBoxList[TextBox.Focused.Parent.TextBoxList.Count - 1].Select();
                        }
                        return;
                    }
                    break;
                case Keys.Escape: 
                    if (IntroScenes.MessageDialogVars.Window.Visible)
                    {
                        IntroScenes.MessageDialogVars.Close.Function.Invoke();
                        return;
                    }
                    if (IntroScenes.QuestionDialogVars.Window.Visible)
                    {
                        IntroScenes.QuestionDialogVars.No.Function.Invoke();
                        return;
                    } if (Engine.CurrentStage == GameStage.Game)
                    {
                        if (GameScene.ChatBar.Window.Visible)
                        {
                            GameScene.ChatBar.Window.CleanUp();
                            return;
                        }
                    }
                    break;
                case Keys.ShiftKey:
                    ShiftDown = true;
                    break;
                case Keys.ControlKey:
                    CtrlDown = true;
                    break;
                case Keys.RButton | Keys.ShiftKey:
                    AltDown = true;
                    break;
            }


        }
        private void Main_KeyUp(object sender, KeyEventArgs e)
        {

            switch (e.KeyCode)
            {
                case Keys.ShiftKey:
                    ShiftDown = false;
                    break;
                case Keys.ControlKey:
                    CtrlDown = false;
                    break;
                case Keys.RButton | Keys.ShiftKey:
                    AltDown = false;
                    break;
            }
        }

        private void Main_Load(object sender, EventArgs e)
        {
        }
    }
}
