﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.Net.Sockets;
using Clash_Library;


namespace Clash_Client
{
    class Network
    {
        public static Queue<Packet> PacketList = new Queue<Packet>();
        public static NetworkStream NStream;
        public static MemoryStream MStream;
        public static BinaryWriter BWriter;
        public static BinaryReader BReader;
        public static bool Connected;
        public static TcpClient client = null;
        public static IPAddress IPAddress = IPAddress.Parse(Config.IPAddress);//93.96.163.159
        public static DateTime ConnectTime, LastPacket;

        public static void Connect()
        {
            try
            {
                client = new TcpClient();
                client.BeginConnect(IPAddress, Config.Port, OnConnect, client);
            }
            catch (Exception ex)
            {
                File.AppendAllText(@".\Error.txt", string.Format("[{0}] {1}" + Environment.NewLine, Engine.Time, ex));
            }
        }
        public static void OnConnect(IAsyncResult result)
        {
            try
            {
                if (client.Connected)
                {
                    NStream = client.GetStream();
                    MStream = new MemoryStream();
                    IntroScenes.QuestionDialogVars.Window.Visible = false;
                    if (!IntroScenes.QuestionDialogVars.Window.Visible) Functions.QuestionList.Clear(); 
                    IntroScenes.LoginDialog.Window.Visible = true;
                    ConnectTime = Engine.Time;
                    Connected = true;
                    BWriter = new BinaryWriter(MStream);
                    BReader = new BinaryReader(NStream);
                    System.Threading.ThreadPool.QueueUserWorkItem(CheckStream);
                }
            }
            catch (Exception ex)
            {
                File.AppendAllText(@".\Error.txt", string.Format("[{0}] {1}" + Environment.NewLine, Engine.Time, ex));
            }
        }
        public static void CheckStream(object o)
        {
            Packet P;
            string S = null;
            while (Engine.GameRunning)
            {
                try
                {
                    if (client != null)
                        if (client.Connected)
                        {
                            while (NStream.CanRead && NStream.DataAvailable)
                                try
                                {
                                    S = BReader.ReadString();
                                    if (!string.IsNullOrEmpty(S))
                                    {
                                        P = Activator.CreateInstance(Type.GetType(string.Format("Server_Packets.{0},Clash Library", S))) as Packet;
                                        if (P != null)
                                            P.Read(Network.BReader);
                                        if (S == "ItemList")
                                        {
                                            In.Read(P);
                                        }
                                        else
                                            PacketList.Enqueue(P);
                                    }
                                }
                                catch (Exception ex)
                                {
                                    if (S != null)
                                        File.AppendAllText(@".\Error.txt", string.Format("[{0} {1}] {1}" + Environment.NewLine, Engine.Time, S, ex));
                                    else
                                        File.AppendAllText(@".\Error.txt", string.Format("[{0} {1}] {1}" + Environment.NewLine, Engine.Time, "null", ex));
                                }

                            if (Engine.Time - LastPacket > new TimeSpan(0, 0, 15))
                                Out.KeepAlive();

                            lock (MStream)
                            {
                                MStream.WriteTo(NStream);
                                MStream.SetLength(0);
                            }

                        }
                        else
                        {
                            Functions.ShowMessage(Constants.ServerOffLine);
                            IntroScenes.MessageDialogVars.Close.Function = IntroScenes.MessageDialogVars.QuitF;
                        }
                }
                catch (IOException)
                { }
                catch (Exception ex)
                {
                    File.AppendAllText(@".\Error.txt", string.Format("[{0}] {1}" + Environment.NewLine, Engine.Time, ex));
                }

                System.Threading.Thread.Sleep(1);
            }
        }
        public static void CheckStream()
        {
            while (PacketList.Count > 0)
                In.Read(PacketList.Dequeue());
        }
    }
}
