﻿using System;
using System.Collections.Generic;
using System.Drawing;
using Clash_Library;

namespace Clash_Client
{
    class Magic
    {
        public static List<Magic> MagicList = new List<Magic>();
        public int DrawFrame, FrameCount;
        public TimeSpan FrameTime;
        public DateTime LastFrame;
        public Point Location, DrawPoint;
        public CLib Library;
        public bool Loop;
        public int MaxLight, Light;
        public Color LightColour;

        public Magic(int Count, TimeSpan Time, Point Loc, CLib Lib, int light, Color Col, bool L)
        {
            DrawFrame = 0;
            FrameCount = Count;
            FrameTime = Time;
            Location = Loc;
            Library = Lib;
            LastFrame = Engine.Time;
            MaxLight = light;
            Loop = L;
            LightColour = Col;
        }
        public Magic(int Count, TimeSpan Time, Point Loc, CLib Lib, int light, Color Col)
        {
            DrawFrame = 0;
            FrameCount = Count;
            FrameTime = Time;
            Location = Loc;
            Library = Lib;
            LastFrame = Engine.Time;
            MaxLight = light;
            LightColour = Col;
        }
        public Magic(int Count, TimeSpan Time, Point Loc, CLib Lib)
        {
            DrawFrame = 0;
            FrameCount = Count;
            FrameTime = Time;
            Location = Loc;
            Library = Lib;
            LastFrame = Engine.Time;
            MaxLight = 0;
            LightColour = Color.White;
        }
        public static void MakeMagic(Point Loc, Element E)
        {
            if (!Config.DrawEffects) return;
            MagicList.Add(new Magic(6, new TimeSpan(0, 0, 0, 0, 100), Loc, CLib.Effects[0]));
            if (E.HasFlag(Element.Fire))
                MagicList.Add(new Magic(6, new TimeSpan(0, 0, 0, 0, 100), Loc, CLib.Effects[1]));
            if (E.HasFlag(Element.Lightning))
                MagicList.Add(new Magic(6, new TimeSpan(0, 0, 0, 0, 100), Loc, CLib.Effects[2]));
            if (E.HasFlag(Element.Ice))
                MagicList.Add(new Magic(6, new TimeSpan(0, 0, 0, 0, 100), Loc, CLib.Effects[3]));
            if (E.HasFlag(Element.Wind))
                MagicList.Add(new Magic(6, new TimeSpan(0, 0, 0, 0, 100), Loc, CLib.Effects[4]));
            if (E.HasFlag(Element.Holy))
                MagicList.Add(new Magic(6, new TimeSpan(0, 0, 0, 0, 100), Loc, CLib.Effects[5]));
            if (E.HasFlag(Element.Dark))
                MagicList.Add(new Magic(6, new TimeSpan(0, 0, 0, 0, 100), Loc, CLib.Effects[6]));
            if (E.HasFlag(Element.Illusion))
                MagicList.Add(new Magic(6, new TimeSpan(0, 0, 0, 0, 100), Loc, CLib.Effects[7]));

        }
        public static Magic MakeMagic(Point Loc, int SpellID)
        {
            if (!Config.DrawEffects) return null;
            if (CLib.Magics == null || CLib.Magics.Length <= SpellID || CLib.Magics[SpellID] == null) return null;
            switch (SpellID)
            {
                case 0:
                    return new Magic(17, new TimeSpan(0, 0, 0, 0, 80), Loc, CLib.Magics[SpellID]);
                default:
                    return null;
            }

        }

        public void Operate()
        {
            if (Engine.Time > LastFrame + FrameTime)
            {
                LastFrame = Engine.Time;
                if (Light++ >= MaxLight)
                {
                    MaxLight--;
                    Light -= 2;
                }
                if (DrawFrame++ >= FrameCount)
                    if (Loop)
                        DrawFrame = 0;
                    else
                        MagicList.Remove(this);
            }
        }
        public void Draw()
        {
            if (Library == null) return;
            DrawPoint = Location;
            DrawPoint.Offset(-User.Info.Location.X, -User.Info.Location.Y);
            DrawPoint.Offset(Config.PlayerOffSet);
            DrawPoint.X *= 48; DrawPoint.Y *= 32;
            DrawPoint.Offset(MapClass.OffSet);
            Library.Draw(DrawFrame, DrawPoint, true);
        }
    }
}
