﻿using System;
using System.Drawing;
using Clash_Library;

namespace Clash_Client
{
    static class User
    {
        public static ActorInfo Info;
        public static MirAction CurrentAction;
        public static bool CanDoAction, FreezeEnding, CanRun;
        public static DateTime LastFrame, LastAttack;
        public static TimeSpan ASpeed = new TimeSpan(0, 0, 0, 1, 500), FrameTime;
        public static int CurrentFrame, DrawFrame, FrameCount, SkipFrame, StartFrame = 0;
        public static bool Struck;
        public static Element StruckEle;
        private static int WShape, AShape, WOffSet, AOffSet;

        public static Point MovePoint
        {
            get
            {
                if (CurrentAction == MirAction.Walking)
                    return Functions.Move(Info.Location, Info.Dir, -1);
                if (CurrentAction == MirAction.Running)
                    if (CurrentFrame >= 3)
                        return Functions.Move(Info.Location, Info.Dir, -1);
                    else
                        return Functions.Move(Info.Location, Info.Dir, -2);
                else
                    return Info.Location;
            }
        }

        public static bool CanNextAction()
        {
            return CanDoAction && !Info.Dead;
        }
        public static void CalcGender()
        {
            if (Info.Job == Class.Assassin)
            {
                AOffSet = ((byte)Info.Sex * 512);
                WOffSet = ((byte)Info.Sex * 512);
            }
            else
            {
                AOffSet = ((byte)Info.Sex * 808);
                WOffSet = ((byte)Info.Sex * 416);
            }
        }

        public static void DoAction(MirAction A)
        {
            if (A != MirAction.Standing)
                CanDoAction = false;
            CurrentAction = A;
            FreezeEnding = true;
            CurrentFrame = 0;
            switch (A)
            {
                case MirAction.Standing:
                    StartFrame = Human.Stand.Start;
                    FrameCount = Human.Stand.Count;
                    SkipFrame = Human.Stand.Skip;
                    FrameTime = Human.Stand.Time;
                    break;
                case MirAction.Walking:
                    StartFrame = Human.Walk.Start;
                    FrameCount = Human.Walk.Count;
                    SkipFrame = Human.Walk.Skip;
                    FrameTime = Human.Walk.Time;
                    break;
                case MirAction.Running:
                    StartFrame = Human.Run.Start;
                    FrameCount = Human.Run.Count;
                    SkipFrame = Human.Run.Skip;
                    FrameTime = Human.Run.Time;
                    break;
                case MirAction.Attack1:
                    LastAttack = Engine.Time;
                    StartFrame = Human.Attack1.Start;
                    FrameCount = Human.Attack1.Count;
                    SkipFrame = Human.Attack1.Skip;
                    FrameTime = Human.Attack1.Time;
                    break;
                case MirAction.Attack2:
                    LastAttack = Engine.Time;
                    StartFrame = Human.Attack2.Start;
                    FrameCount = Human.Attack2.Count;
                    SkipFrame = Human.Attack2.Skip;
                    FrameTime = Human.Attack2.Time;
                    break;
                case MirAction.Attack3:
                    LastAttack = Engine.Time;
                    StartFrame = Human.Attack3.Start;
                    FrameCount = Human.Attack3.Count;
                    SkipFrame = Human.Attack3.Skip;
                    FrameTime = Human.Attack3.Time;
                    break;
                case MirAction.Harvest:
                    StartFrame = Human.Harvest.Start;
                    FrameCount = Human.Harvest.Count;
                    SkipFrame = Human.Harvest.Skip;
                    FrameTime = Human.Harvest.Time;
                    break;
                case MirAction.BattleStance:
                    StartFrame = Human.BattleStance.Start;
                    FrameCount = Human.BattleStance.Count;
                    SkipFrame = Human.BattleStance.Skip;
                    FrameTime = Human.BattleStance.Time;
                    break;
                case MirAction.Spell:
                    StartFrame = Human.Spell.Start;
                    FrameCount = Human.Spell.Count;
                    SkipFrame = Human.Spell.Skip;
                    FrameTime = Human.Spell.Time;
                    break;
                case MirAction.Struck:
                    Magic.MakeMagic(User.Info.Location, StruckEle);
                    StartFrame = Human.Struck.Start;
                    FrameCount = Human.Struck.Count;
                    SkipFrame = Human.Struck.Skip;
                    FrameTime = Human.Struck.Time;
                    StruckEle = Element.None;
                    break;
                case MirAction.Dieing:
                    StartFrame = Human.Die.Start;
                    FrameCount = Human.Die.Count;
                    SkipFrame = Human.Die.Skip;
                    FrameTime = Human.Die.Time;
                    break;
                case MirAction.Dead:                    
                    Functions.AskQuestion("Do you want to revive, in Town?", IntroScenes.QuestionDialogVars.DrawExtraF, IntroScenes.QuestionDialogVars.ReviveF, IntroScenes.QuestionDialogVars.CloseF, true);
                    StartFrame = Human.Die.Start + Human.Die.Count - 1;
                    FrameCount = 1;
                    SkipFrame = Human.Die.Count - 1;
                    FrameTime = Human.Die.Time;
                    break;

            }
        }
            
        public static void Operate()
        {
            switch (CurrentAction)
            {
                case MirAction.Standing:
                    if (Engine.Time > LastFrame + FrameTime)
                    {
                        LastFrame = Engine.Time;
                        if (Struck)
                        {
                            CanDoAction = false;
                            DoAction(MirAction.Struck);
                            return;
                        }
                        if (CurrentFrame > 0) CanDoAction = true;

                        if (++CurrentFrame >= FrameCount)
                            CurrentFrame = 0;

                    }
                    break;
                case MirAction.Walking:
                case MirAction.Running:
                    if (Engine.CanMove)
                    {
                        if (Engine.Time - LastFrame > FrameTime)
                        {
                            LastFrame = Engine.Time;
                            if (++CurrentFrame >= FrameCount)
                            {
                                if (Struck)
                                {
                                    CanDoAction = false;
                                    DoAction(MirAction.Struck);
                                    return;
                                }
                                CanDoAction = true;

                                if (!FreezeEnding)
                                {
                                    CurrentFrame = 0;
                                    CanDoAction = true;
                                    DoAction(MirAction.Standing);
                                }
                                else
                                {
                                    CurrentFrame = FrameCount -1;
                                    FreezeEnding = false;
                                }
                            }

                        }
                    }
                    break;
                case MirAction.BattleStance:
                    if (Struck)
                    {
                        CanDoAction = false;
                        DoAction(MirAction.Struck);
                        return;
                    }
                    CanDoAction = true;
                    if (Engine.Time - LastFrame > FrameTime)
                    {
                        LastFrame = Engine.Time;
                        DoAction(MirAction.Standing);
                    }
                    break;
                case MirAction.Attack1:
                case MirAction.Attack2:
                case MirAction.Attack3:
                case MirAction.Spell: //6 Frames
                    if (Engine.Time - LastFrame > FrameTime)
                    {
                        LastFrame = Engine.Time;
                        if (++CurrentFrame >= FrameCount)
                        {
                            if (Struck)
                            {
                                CanDoAction = false;
                                DoAction(MirAction.Struck);
                                return;
                            }
                            CurrentFrame = 0;
                            CanDoAction = true;
                            DoAction(MirAction.BattleStance);
                        }
                    }
                    break;
                case MirAction.Harvest: //6 Frames
                    if (Engine.Time - LastFrame > FrameTime)
                    {
                        LastFrame = Engine.Time;
                        if (++CurrentFrame >= FrameCount)
                        {
                            if (Struck)
                            {
                                CanDoAction = false;
                                DoAction(MirAction.Struck);
                                return;
                            }
                            CurrentFrame = 0;
                            CanDoAction = true;
                            DoAction(MirAction.Standing);
                        }
                    }
                    break;
                case MirAction.Struck: //6 Frames
                    Struck = false;
                    CanRun = false;
                    if (Engine.Time - LastFrame > FrameTime)
                    {
                        LastFrame = Engine.Time;
                        if (++CurrentFrame >= FrameCount)
                        {
                            if (Info.CurrentHP <= 0)
                            {
                                CanDoAction = false;
                                Struck = false;
                                Info.Dead = true;
                                DoAction(MirAction.Dieing);
                                return;
                            }
                            if (Struck)
                            {
                                CanDoAction = false;
                                DoAction(MirAction.Struck);
                                return;
                            }
                            CurrentFrame = 0;
                            CanDoAction = true;
                            DoAction(MirAction.Standing);
                        }
                    }
                    break;
                case MirAction.Dieing:
                    if (Engine.Time - LastFrame > FrameTime)
                    {
                        LastFrame = Engine.Time;
                        if (++CurrentFrame >= FrameCount)
                            DoAction(MirAction.Dead);
                    }
                    break;
            }
        }


        public static void Draw()
        {
            DrawFrame = StartFrame + (byte)Info.Dir * (FrameCount + SkipFrame) + CurrentFrame;

            WShape = 0; AShape = 0;
            if (Info != null && Info.Equipment != null)
            {
                if (Info.Equipment[(byte)ItemLocation.Armour] != null) AShape = Info.Equipment[(byte)ItemLocation.Armour].IInfo.Shape;
                if (Info.Equipment[(byte)ItemLocation.Weapon] != null) WShape = Info.Equipment[(byte)ItemLocation.Weapon].IInfo.Shape;
            }

            Point TPoint = new Point(48 * Config.PlayerOffSet.X, 32 * Config.PlayerOffSet.Y);
            if (Info.Job == Class.Assassin) DrawA(TPoint);
            else DrawWWT(TPoint);
        }
        private static void DrawWWT(Point TPoint)
        {
            #region Weapon
            switch (Info.Dir)
            {
                case Direction.Down:
                case Direction.Up:
                case Direction.Up_Left:
                case Direction.Left:
                case Direction.Down_Left:
                    if (CLib.Weapons != null)
                        if (WShape >= 0 && WShape < CLib.Weapons.Length && CLib.Weapons[WShape] != null)
                            CLib.Weapons[WShape].Draw(DrawFrame + WOffSet, TPoint, true);
                        else if (CLib.Weapons.Length > 0 && CLib.Weapons[0] != null)
                            CLib.Weapons[0].Draw(DrawFrame  + WOffSet, TPoint, true);
                    break;
            }
            #endregion


            if (CLib.Armours != null)
                if (AShape >= 0 && AShape < CLib.Armours.Length && CLib.Armours[AShape] != null)
                    CLib.Armours[AShape].Draw(DrawFrame + AOffSet, TPoint, true);
                else if (CLib.Armours.Length > 0 && CLib.Armours[0] != null)
                    CLib.Armours[0].Draw(DrawFrame + AOffSet, TPoint, true);

            if (CLib.Hairs != null)
                if (Info.Hair >= 0 && Info.Hair < CLib.Hairs.Length && CLib.Hairs[Info.Hair] != null)
                    CLib.Hairs[Info.Hair].Draw(DrawFrame + AOffSet, TPoint, true);

            #region Weapon
            switch (Info.Dir)
            {
                case Direction.Down_Right:
                case Direction.Right:
                case Direction.Up_Right:
                    if (CLib.Weapons != null)
                        if (WShape >= 0 && WShape < CLib.Weapons.Length && CLib.Weapons[WShape] != null)
                            CLib.Weapons[WShape].Draw(DrawFrame + WOffSet, TPoint, true);
                        else if (CLib.Weapons.Length > 0 && CLib.Weapons[0] != null)
                            CLib.Weapons[0].Draw(DrawFrame + WOffSet, TPoint, true);
                    break;
            }
            #endregion
        }
        private static void DrawA(Point TPoint)
        {
            #region Weapon
            switch (Info.Dir)
            {
                case Direction.Down:
                case Direction.Up:
                case Direction.Up_Left:
                case Direction.Left:
                case Direction.Down_Left:
                    if (CLib.WeaponsAL != null)
                        if (WShape >= 0 && WShape < CLib.WeaponsAL.Length && CLib.WeaponsAL[WShape] != null)
                            CLib.WeaponsAL[WShape].Draw(DrawFrame + WOffSet, TPoint, true);
                        else if (CLib.WeaponsAL.Length > 0 && CLib.WeaponsAL[0] != null)
                            CLib.WeaponsAL[0].Draw(DrawFrame + WOffSet, TPoint, true);

                    if (CLib.WeaponsAR != null)
                        if (WShape >= 0 && WShape < CLib.WeaponsAR.Length && CLib.WeaponsAR[WShape] != null)
                            CLib.WeaponsAR[WShape].Draw(DrawFrame + WOffSet, TPoint, true);
                        else if (CLib.WeaponsAR.Length > 0 && CLib.WeaponsAR[0] != null)
                            CLib.WeaponsAR[0].Draw(DrawFrame + WOffSet, TPoint, true);
                    break;
            }
            #endregion

            if (CLib.ArmoursA != null)
                if (AShape >= 0 && AShape < CLib.ArmoursA.Length && CLib.ArmoursA[AShape] != null)
                    CLib.ArmoursA[AShape].Draw(DrawFrame + AOffSet, TPoint, true);
                else if (CLib.ArmoursA.Length > 0 && CLib.ArmoursA[0] != null)
                    CLib.ArmoursA[0].Draw(DrawFrame + AOffSet, TPoint, true);

            if (CLib.HairsA != null)
                if (Info.Hair >= 0 && Info.Hair < CLib.HairsA.Length && CLib.HairsA[Info.Hair] != null)
                    CLib.HairsA[Info.Hair].Draw(DrawFrame + AOffSet, TPoint, true);

            #region Weapon
            switch (Info.Dir)
            {
                case Direction.Down_Right:
                case Direction.Right:
                case Direction.Up_Right:
                    if (CLib.WeaponsAL != null)
                        if (WShape >= 0 && WShape < CLib.WeaponsAL.Length && CLib.WeaponsAL[WShape] != null)
                            CLib.WeaponsAL[WShape].Draw(DrawFrame + WOffSet, TPoint, true);
                        else if (CLib.WeaponsAL.Length > 0 && CLib.WeaponsAL[0] != null)
                            CLib.WeaponsAL[0].Draw(DrawFrame + WOffSet, TPoint, true);

                    if (CLib.WeaponsAR != null)
                        if (WShape >= 0 && WShape < CLib.WeaponsAR.Length && CLib.WeaponsAR[WShape] != null)
                            CLib.WeaponsAR[WShape].Draw(DrawFrame + WOffSet, TPoint, true);
                        else if (CLib.WeaponsAR.Length > 0 && CLib.WeaponsAR[0] != null)
                            CLib.WeaponsAR[0].Draw(DrawFrame + WOffSet, TPoint, true);
                    break;
            }
            #endregion
        }
    }
}
