﻿using System;
using System.Threading;
using System.Windows.Forms;

namespace Clash_Client
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        /// 
        static void Main()
        {
            using (Main M = new Main())
            {
                Graphics.Create(M);
                CLib.Interface = new CLib(@".\Data\Interface.CLib", true, true);
                Engine.T = new Thread(new ThreadStart(CLib.Initialize));
                Engine.T.Start();
                IntroScenes.Create();
                Functions.AskQuestion("Waiting for Connection...", IntroScenes.QuestionDialogVars.NoConnectionF, IntroScenes.QuestionDialogVars.RetryF, IntroScenes.QuestionDialogVars.QuitF, false);
                Network.Connect();
                MonsterFrame.Create();
                M.Show();
                while (Engine.GameRunning)
                {
                    Engine.Time = DateTime.Now;
                    Network.CheckStream();

                    if (Engine.CurrentStage == GameStage.Game)
                    {
                        Engine.Calculate();
                        Engine.CheckMouse();
                        Engine.RenderGScene();
                    }
                    else
                        Engine.RenderIScene();


                    if (Functions.QuestionList.Count > 0 && !IntroScenes.QuestionDialogVars.Window.Visible)
                        Functions.QuestionList.Dequeue().Show();

                    Application.DoEvents();
                }
                Out.Disconnect();
                System.Diagnostics.Process.GetCurrentProcess().Kill();
            }
        }
    }
}
