﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using Clash_Library;
using Microsoft.DirectX.Direct3D;
using Microsoft.DirectX;

namespace Clash_Client
{

    public class CLib : IDisposable
    {
        #region Static Region
        public static BinaryFormatter BF = new BinaryFormatter();
        public static CLib Interface;
        public static CLib Tile;
        public static CLib SmallTile;
        public static CLib Item;
        public static CLib[] Objects;
        public static CLib[] Mir3Objects;
        public static CLib[] Armours;
        public static CLib[] ArmoursA;
        public static CLib[] Monsters;
        public static CLib[] Weapons;
        public static CLib[] WeaponsAL;
        public static CLib[] WeaponsAR;
        public static CLib[] Hairs;
        public static CLib[] HairsA;
        public static CLib[] Effects;
        public static CLib[] Magics;
        public static void DisposeAll()
        {
            if (Interface != null) Interface.Dispose();
            Interface = null;
            if (Tile != null) Tile.Dispose();
            Tile = null;
            if (SmallTile != null) SmallTile.Dispose();
            SmallTile = null;
            if (Item != null) Item.Dispose();
            Item = null;

            if (Objects != null)
                for (int I = 0; I < Objects.Length; I++)
                {
                    if (Objects[I] != null) Objects[I].Dispose();
                    Objects[I] = null;
                }
            Objects = null;

            if (Mir3Objects != null)
                for (int I = 0; I < Mir3Objects.Length; I++)
                {
                    if (Mir3Objects[I] != null) Mir3Objects[I].Dispose();
                    Mir3Objects[I] = null;
                }
            Mir3Objects = null;

            if (Armours != null)
                for (int I = 0; I < Armours.Length; I++)
                {
                    if (Armours[I] != null) Armours[I].Dispose();
                    Armours[I] = null;
                }
            Armours = null;

            if (ArmoursA != null)
                for (int I = 0; I < ArmoursA.Length; I++)
                {
                    if (ArmoursA[I] != null) ArmoursA[I].Dispose();
                    ArmoursA[I] = null;
                }
            ArmoursA = null;

            if (Monsters != null)
                for (int I = 0; I < Monsters.Length; I++)
                {
                    if (Monsters[I] != null) Monsters[I].Dispose();
                    Monsters[I] = null;
                }
            Monsters = null;

            if (Weapons != null)
                for (int I = 0; I < Weapons.Length; I++)
                {
                    if (Weapons[I] != null) Weapons[I].Dispose();
                    Weapons[I] = null;
                }
            Weapons = null;

            if (WeaponsAL != null)
                for (int I = 0; I < WeaponsAL.Length; I++)
                {
                    if (WeaponsAL[I] != null) WeaponsAL[I].Dispose();
                    WeaponsAL[I] = null;
                }
            WeaponsAL = null;

            if (WeaponsAR != null)
                for (int I = 0; I < WeaponsAR.Length; I++)
                {
                    if (WeaponsAR[I] != null) WeaponsAR[I].Dispose();
                    WeaponsAR[I] = null;
                }
            WeaponsAR = null;

            if (Hairs != null)
                for (int I = 0; I < Hairs.Length; I++)
                {
                    if (Hairs[I] != null) Hairs[I].Dispose();
                    Hairs[I] = null;
                }
            Hairs = null;

            if (HairsA != null)
                for (int I = 0; I < HairsA.Length; I++)
                {
                    if (HairsA[I] != null) HairsA[I].Dispose();
                    HairsA[I] = null;
                }
            HairsA = null;

            if (Effects != null)
                for (int I = 0; I < Effects.Length; I++)
                {
                    if (Effects[I] != null) Effects[I].Dispose();
                    Effects[I] = null;
                }
            Effects = null;

            if (Magics != null)
                for (int I = 0; I < Magics.Length; I++)
                {
                    if (Magics[I] != null) Magics[I].Dispose();
                    Magics[I] = null;
                }
            Magics = null;

        }

        public static void Initialize()
        {            
            Tile = new CLib(@".\Data\Tiles.CLib", false);
            SmallTile = new CLib(@".\Data\SmTiles.CLib", false);
            Objects = new CLib[15];
            Objects[0] = new CLib(@".\Data\Objects.CLib", false);
            Objects[1] = new CLib(@".\Data\Objects2.CLib", false);
            Objects[2] = new CLib(@".\Data\Objects3.CLib", false);
            Objects[3] = new CLib(@".\Data\Objects4.CLib", false);
            Objects[4] = new CLib(@".\Data\Objects5.CLib", false);
            Objects[5] = new CLib(@".\Data\Objects6.CLib", false);
            Objects[6] = new CLib(@".\Data\Objects7.CLib", false);
            Objects[7] = new CLib(@".\Data\Objects8.CLib", false);
            Objects[8] = new CLib(@".\Data\Objects9.CLib", false);
            Objects[9] = new CLib(@".\Data\Objects10.CLib", false);
            Objects[10] = new CLib(@".\Data\Objects11.CLib", false);
            Objects[11] = new CLib(@".\Data\Objects12.CLib", false);
            Objects[12] = new CLib(@".\Data\Objects13.CLib", false);
            Objects[13] = new CLib(@".\Data\Objects14.CLib", false);
            Item = new CLib(@".\Data\Items.CLib", true, true);

            #region Mir 3 Libs
            Mir3Objects = new CLib[74];

            Mir3Objects[0] = new CLib(@".\Data\Mir 3 Data\tilesc.CLib", false);
            Mir3Objects[1] = new CLib(@".\Data\Mir 3 Data\tiles30c.CLib", false);
            Mir3Objects[2] = new CLib(@".\Data\Mir 3 Data\Tiles5c.CLib", false);
            Mir3Objects[3] = new CLib(@".\Data\Mir 3 Data\smtilesc.CLib", false);
            Mir3Objects[4] = new CLib(@".\Data\Mir 3 Data\housesc.CLib", false);
            Mir3Objects[5] = new CLib(@".\Data\Mir 3 Data\cliffsc.CLib", false);
            Mir3Objects[6] = new CLib(@".\Data\Mir 3 Data\dungeonsc.CLib", false);
            Mir3Objects[8] = new CLib(@".\Data\Mir 3 Data\furnituresc.CLib", false);
            Mir3Objects[9] = new CLib(@".\Data\Mir 3 Data\wallsc.CLib", false);
            Mir3Objects[10] = new CLib(@".\Data\Mir 3 Data\smobjectsc.CLib", false);
            Mir3Objects[11] = new CLib(@".\Data\Mir 3 Data\animationsc.CLib", false);

            Mir3Objects[15] = new CLib(@".\Data\Mir 3 Data\Wood\tilesc.CLib", false);
            Mir3Objects[17] = new CLib(@".\Data\Mir 3 Data\Wood\Tiles5c.CLib", false);
            Mir3Objects[19] = new CLib(@".\Data\Mir 3 Data\Wood\housesc.CLib", false);
            Mir3Objects[20] = new CLib(@".\Data\Mir 3 Data\Wood\cliffsc.CLib", false);
            Mir3Objects[21] = new CLib(@".\Data\Mir 3 Data\Wood\dungeonsc.CLib", false);
            Mir3Objects[22] = new CLib(@".\Data\Mir 3 Data\Wood\innersc.CLib", false);
            Mir3Objects[23] = new CLib(@".\Data\Mir 3 Data\Wood\furnituresc.CLib", false);
            Mir3Objects[24] = new CLib(@".\Data\Mir 3 Data\Wood\wallsc.CLib", false);
            Mir3Objects[25] = new CLib(@".\Data\Mir 3 Data\Wood\smobjectsc.CLib", false);
            Mir3Objects[26] = new CLib(@".\Data\Mir 3 Data\Wood\animationsc.CLib", false);

            Mir3Objects[30] = new CLib(@".\Data\Mir 3 Data\Sand\tilesc.CLib", false);
            Mir3Objects[32] = new CLib(@".\Data\Mir 3 Data\Sand\Tiles5c.CLib", false);
            Mir3Objects[34] = new CLib(@".\Data\Mir 3 Data\Sand\housesc.CLib", false);
            Mir3Objects[35] = new CLib(@".\Data\Mir 3 Data\Sand\cliffsc.CLib", false);
            Mir3Objects[36] = new CLib(@".\Data\Mir 3 Data\Sand\dungeonsc.CLib", false);
            Mir3Objects[39] = new CLib(@".\Data\Mir 3 Data\Sand\wallsc.CLib", false);
            Mir3Objects[40] = new CLib(@".\Data\Mir 3 Data\Sand\smobjectsc.CLib", false);
            Mir3Objects[41] = new CLib(@".\Data\Mir 3 Data\Sand\animationsc.CLib", false);

            Mir3Objects[45] = new CLib(@".\Data\Mir 3 Data\Snow\tilesc.CLib", false);
            Mir3Objects[46] = new CLib(@".\Data\Mir 3 Data\Snow\tiles30c.CLib", false);
            Mir3Objects[47] = new CLib(@".\Data\Mir 3 Data\Snow\Tiles5c.CLib", false);
            Mir3Objects[48] = new CLib(@".\Data\Mir 3 Data\Snow\smtilesc.CLib", false);
            Mir3Objects[49] = new CLib(@".\Data\Mir 3 Data\Snow\housesc.CLib", false);
            Mir3Objects[50] = new CLib(@".\Data\Mir 3 Data\Snow\cliffsc.CLib", false);
            Mir3Objects[51] = new CLib(@".\Data\Mir 3 Data\Snow\dungeonsc.CLib", false);
            Mir3Objects[52] = new CLib(@".\Data\Mir 3 Data\Snow\innersc.CLib", false);
            Mir3Objects[54] = new CLib(@".\Data\Mir 3 Data\Snow\wallsc.CLib", false);
            Mir3Objects[55] = new CLib(@".\Data\Mir 3 Data\Snow\smobjectsc.CLib", false);
            Mir3Objects[56] = new CLib(@".\Data\Mir 3 Data\Snow\animationsc.CLib", false);

            Mir3Objects[60] = new CLib(@".\Data\Mir 3 Data\Forest\tilesc.CLib", false);
            Mir3Objects[62] = new CLib(@".\Data\Mir 3 Data\Forest\Tiles5c.CLib", false);
            Mir3Objects[66] = new CLib(@".\Data\Mir 3 Data\Forest\dungeonsc.CLib", false);
            Mir3Objects[71] = new CLib(@".\Data\Mir 3 Data\Forest\animationsc.CLib", false);

            #endregion
            if (!Directory.Exists(@".\Data\Monsters\")) Directory.CreateDirectory(@".\Data\Monsters\");
            int Count = 0;
            foreach (string S in Directory.GetFiles(@".\Data\Monsters\", @"*.CLib"))
            {
                int X = int.Parse(Path.GetFileNameWithoutExtension(S));
                if (X > Count)
                    Count = X;
            }
            if (Count > 0)
            {
                Monsters = new CLib[Count +1];
                for (int I = 0; I < Monsters.Length; I++)
                    Monsters[I] = new CLib(@".\Data\Monsters\" + I.ToString("00") + ".CLib", true, true);
            }


            if (!Directory.Exists(@".\Data\Armours\")) Directory.CreateDirectory(@".\Data\Armours\");
            Count = Directory.GetFiles(@".\Data\Armours\", @"*.CLib").Length;
            if (Count > 0)
            {
                Count = int.Parse(Path.GetFileNameWithoutExtension(Directory.GetFiles(@".\Data\Armours\", @"*.CLib")[Count - 1]));
                Armours = new CLib[Count +1];
                for (int I = 0; I < Armours.Length; I++)
                    Armours[I] = new CLib(@".\Data\Armours\" + I.ToString("00") + ".CLib", true, true);
            }


            if (!Directory.Exists(@".\Data\ArmoursA\")) Directory.CreateDirectory(@".\Data\ArmoursA\");
            Count = Directory.GetFiles(@".\Data\ArmoursA\", @"*.CLib").Length;
            if (Count > 0)
            {
                Count = int.Parse(Path.GetFileNameWithoutExtension(Directory.GetFiles(@".\Data\ArmoursA\", @"*.CLib")[Count - 1]));
                ArmoursA = new CLib[Count + 1];
                for (int I = 0; I < ArmoursA.Length; I++)
                    ArmoursA[I] = new CLib(@".\Data\ArmoursA\" + I.ToString("00") + ".CLib", true, true);
            }


            if (!Directory.Exists(@".\Data\Weapons\")) Directory.CreateDirectory(@".\Data\Weapons\");
            Count = 0;
            foreach (string S in Directory.GetFiles(@".\Data\Weapons\", @"*.CLib"))
            {
                int X = int.Parse(Path.GetFileNameWithoutExtension(S));
                if (X > Count)
                    Count = X;
            }
            if (Count > 0)
            {
                Weapons = new CLib[Count + 1];
                for (int I = 0; I < Weapons.Length; I++)
                    Weapons[I] = new CLib(@".\Data\Weapons\" + I.ToString("00") + ".CLib", true, true);
            }

            if (!Directory.Exists(@".\Data\WeaponsAR\")) Directory.CreateDirectory(@".\Data\WeaponsAR\");
            Count = Directory.GetFiles(@".\Data\WeaponsAR\", @"*.CLib").Length;
            if (Count > 0)
            {
                Count = int.Parse(Path.GetFileNameWithoutExtension(Directory.GetFiles(@".\Data\WeaponsAR\", @"*.CLib")[Count - 1]));

                WeaponsAR = new CLib[Count +1];
                for (int I = 0; I < WeaponsAR.Length; I++)
                    WeaponsAR[I] = new CLib(@".\Data\WeaponsAR\" + I.ToString("00") + ".CLib", true, true);
            }


            if (!Directory.Exists(@".\Data\WeaponsAL\")) Directory.CreateDirectory(@".\Data\WeaponsAL\");
            Count = Directory.GetFiles(@".\Data\WeaponsAL\", @"*.CLib").Length;
            if (Count > 0)
            {
                Count = int.Parse(Path.GetFileNameWithoutExtension(Directory.GetFiles(@".\Data\WeaponsAL\", @"*.CLib")[Count - 1]));

                WeaponsAL = new CLib[Count +1];
                for (int I = 0; I < WeaponsAL.Length; I++)
                    WeaponsAL[I] = new CLib(@".\Data\WeaponsAL\" + I.ToString("00") + ".CLib", true, true);
            }


            if (!Directory.Exists(@".\Data\Hairs\")) Directory.CreateDirectory(@".\Data\Hairs\");
            Count = Directory.GetFiles(@".\Data\Hairs\", @"*.CLib").Length;
            if (Count > 0)
            {
                Count = int.Parse(Path.GetFileNameWithoutExtension(Directory.GetFiles(@".\Data\Hairs\", @"*.CLib")[Count - 1]));

                Hairs = new CLib[Count + 1];
                for (int I = 0; I < Hairs.Length; I++)
                    Hairs[I] = new CLib(@".\Data\Hairs\" + I.ToString("00") + ".CLib", true, true);
            }

            if (!Directory.Exists(@".\Data\HairsA\")) Directory.CreateDirectory(@".\Data\HairsA\");
            Count = Directory.GetFiles(@".\Data\HairsA\", @"*.CLib").Length;
            if (Count > 0)
            {
                Count = int.Parse(Path.GetFileNameWithoutExtension(Directory.GetFiles(@".\Data\HairsA\", @"*.CLib")[Count - 1]));

                HairsA = new CLib[Count + 1];
                for (int I = 0; I < HairsA.Length; I++)
                    HairsA[I] = new CLib(@".\Data\HairsA\" + I.ToString("00") + ".CLib", true, true);
            }

            if (!Directory.Exists(@".\Data\Effects\")) Directory.CreateDirectory(@".\Data\Effects\");
            Count = Directory.GetFiles(@".\Data\Effects\", @"*.CLib").Length;
            if (Count > 0)
            {
                Count = int.Parse(Path.GetFileNameWithoutExtension(Directory.GetFiles(@".\Data\Effects\", @"*.CLib")[Count - 1]));

                Effects = new CLib[Count + 1];
                for (int I = 0; I < Effects.Length; I++)
                    Effects[I] = new CLib(@".\Data\Effects\" + I.ToString("00") + ".CLib", true, true);
            }

            if (!Directory.Exists(@".\Data\Magics\")) Directory.CreateDirectory(@".\Data\Magics\");
            Count = Directory.GetFiles(@".\Data\Magics\", @"*.CLib").Length;
            if (Count > 0)
            {
                Count = int.Parse(Path.GetFileNameWithoutExtension(Directory.GetFiles(@".\Data\Magics\", @"*.CLib")[Count - 1]));

                Magics = new CLib[Count + 1];
                for (int I = 0; I < Magics.Length; I++)
                    Magics[I] = new CLib(@".\Data\Magics\" + I.ToString("000") + ".CLib", true, true);
            }



        }
        public static void Convert()
        {
            while (Engine.GameRunning)
            {
                DateTime LastGC = Engine.Time;
                if (Interface != null)
                    Interface.ConvertLibrary();

                if (Armours != null)
                    foreach (CLib Lib in Armours)
                        if (Lib != null) Lib.ConvertLibrary();

                if (Monsters != null)
                    foreach (CLib Lib in Monsters)
                        if (Lib != null) Lib.ConvertLibrary();

                if (Weapons != null)
                    foreach (CLib Lib in Weapons)
                        if (Lib != null) Lib.ConvertLibrary();


                if (Item != null)
                    Item.ConvertLibrary();
                if (Engine.Time > LastGC + new TimeSpan(0, 0, 100))
                {
                    LastGC = Engine.Time;
                    GC.Collect();
                }
                System.Threading.Thread.Sleep(1000);
            }
        }

        #endregion
        #region Fields
        private Dictionary<int, ImageInfo> IndexInfo;
        private CLibImage[] ImageList;
        public Queue<int> ConvertList;
        private bool Retain, Disconnect;
        private string FileName;
        private FileStream FStream;
        private long PosOffSet;
        #endregion

        public CLib(string file, bool retain, bool Dis)
        {
            try
            {
                Disconnect = Dis;
                Retain = retain;
                FileName = file;
                ConvertList = new Queue<int>();
                if (File.Exists(file))
                {
                    FStream = new FileStream(file, FileMode.Open);
                    IndexInfo = (Dictionary<int, ImageInfo>)BF.Deserialize(FStream);
                    int[] Keys = new int[IndexInfo.Count];
                    IndexInfo.Keys.CopyTo(Keys, 0);
                    ImageList = new CLibImage[Keys[Keys.Length - 1] + 1];
                    Keys = null;
                    PosOffSet = FStream.Position;
                    if (Disconnect)
                    {
                        FStream.Dispose();
                        FStream = null;
                    }
                }
            }
            catch (Exception ex)
            {
                File.AppendAllText(@".\Error.txt", string.Format("[{0}] {1}" + Environment.NewLine, Engine.Time, ex));
            }
        }
        public CLib(string file, bool retain)
        {
            try
            {
                Retain = retain;
                ConvertList = new Queue<int>();
                if (File.Exists(file))
                {
                    FStream = new FileStream(file, FileMode.Open);
                    IndexInfo = (Dictionary<int, ImageInfo>)BF.Deserialize(FStream);
                    int[] Keys = new int[IndexInfo.Count];
                    IndexInfo.Keys.CopyTo(Keys, 0);
                    ImageList = new CLibImage[Keys[Keys.Length - 1] + 1];
                    Keys = null;
                    PosOffSet = FStream.Position;
                }
            }
            catch (Exception ex)
            {
                File.AppendAllText(@".\Error.txt", string.Format("[{0}] {1}" + Environment.NewLine, Engine.Time, ex));
            }
        }


        public void LoadImage(int ID)
        {
            if (IndexInfo == null) return;
            ImageInfo TempInfo;
            byte[] buffer;
            if (!IndexInfo.TryGetValue(ID, out TempInfo)) return;
            buffer = new byte[TempInfo.Length];
            if (Disconnect)
                using (FStream = new FileStream(FileName, FileMode.Open))
                {
                    FStream.Seek(TempInfo.Start + PosOffSet, SeekOrigin.Begin);
                    FStream.Read(buffer, 0, TempInfo.Length);
                }
            else
            {
                FStream.Seek(TempInfo.Start + PosOffSet, SeekOrigin.Begin);
                FStream.Read(buffer, 0, TempInfo.Length);
            }
            ImageList[ID] = new CLibImage(buffer, Retain);
            ConvertList.Enqueue(ID);
        }


        public void Draw(int ID, Point Pos, bool OffSet)
        {
            if (ImageList == null || IndexInfo == null) return;
            if (ID < 0 || ID >= ImageList.Length) return;
            if (ImageList[ID] == null) LoadImage(ID);
            if (ImageList[ID] == null) return;

            if (OffSet) Pos.Offset(IndexInfo[ID].OffSet);
            if (Config.DrawMethod2)
                Graphics.S.Draw2D(ImageList[ID].Texture, Point.Empty, 0, Pos, Color.White.ToArgb());
            else
                Graphics.S.Draw(ImageList[ID].Texture, Vector3.Empty, new Vector3(Pos.X, Pos.Y, 0), Color.White.ToArgb());


        }
        public void Draw(int ID, Point Pos, bool OffSet, Color Col)
        {
            if (ImageList == null || IndexInfo == null) return;
            if (ID < 0 || ID >= ImageList.Length) return;
            if (ImageList[ID] == null) LoadImage(ID);
            if (ImageList[ID] == null) return;

            if (OffSet) Pos.Offset(IndexInfo[ID].OffSet);
            if (Config.DrawMethod2)
                Graphics.S.Draw2D(ImageList[ID].Texture, Point.Empty, 0, Pos, Col.ToArgb());
            else
                Graphics.S.Draw(ImageList[ID].Texture, Vector3.Empty, new Vector3(Pos.X, Pos.Y, 0), Col.ToArgb());
        }
        public void DrawBlend(int ID, Point Pos, bool OffSet, Color Col)
        {
            if (ImageList == null || IndexInfo == null) return;
            if (ID < 0 || ID >= ImageList.Length) return;
            if (ImageList[ID] == null) LoadImage(ID);
            if (ImageList[ID] == null) return;

            if (OffSet) Pos.Offset(IndexInfo[ID].OffSet);
            Graphics.SetBlend(true);
            if (Config.DrawMethod2)
                Graphics.S.Draw2D(ImageList[ID].Texture, Point.Empty, 0, Pos, Col.ToArgb());
            else
                Graphics.S.Draw(ImageList[ID].Texture, Vector3.Empty, new Vector3(Pos.X, Pos.Y, 0), Col.ToArgb());
            Graphics.SetBlend(false);
        }

        
        public Size GetImageSize(int ID)
        {
            if (IndexInfo == null) return Size.Empty;
            ImageInfo TempInfo;
            if (IndexInfo.TryGetValue(ID, out TempInfo))
                return TempInfo.ImageSize;
            else
                return Size.Empty;
        }
        public Point GetImageOffSet(int ID)
        {
            if (IndexInfo == null) return Point.Empty;
            ImageInfo TempInfo;
            if (IndexInfo.TryGetValue(ID, out TempInfo))
                return TempInfo.OffSet;
            else
                return Point.Empty;
        }
        public bool GetTransparent(int ID, Point P)
        {
            if (ImageList == null || IndexInfo == null) return false;
            if (ID < 0 || ID >= ImageList.Length) return false;
            if (ImageList[ID] == null) LoadImage(ID);
            if (ImageList[ID] == null) return false;
            return Config.PixelDetect || ImageList[ID].IsTransparent(P);
        }

        public Texture GetTexture(int ID)
        {
            if (ImageList == null || IndexInfo == null) return null;
            if (ID < 0 || ID >= ImageList.Length) return null;
            if (ImageList[ID] == null) LoadImage(ID);
            if (ImageList[ID] == null) return null;
            return ImageList[ID].Texture;
        }


        public void ConvertLibrary()
        {
            int ID;
            while (ConvertList.Count > 0)
            {
                ID = ConvertList.Dequeue();
                if (ImageList[ID] != null)
                    ImageList[ID].Convert();
            }
        }
        public void Dispose()
        {
            if (FStream != null)
            {
                FStream.Dispose();
                FStream = null;
            }
            IndexInfo = null;
        }
        public void Dispose(int ID)
        {
            if (ImageList == null || IndexInfo == null) return;
            if (ID < 0 || ID >= ImageList.Length) return;
            if (ImageList[ID] == null) return;
            ImageList[ID].Dispose();
            ImageList[ID] = null;            
        }
    }

    public class CLibImage : IDisposable
    {
        #region Fields
        private Bitmap BMap;
        public Texture Texture;
        private BitArray Bits;
        private Size S;
        private bool Converted;
        #endregion
        public CLibImage(byte[] ImgBytes, bool Retain)
        {
            using (MemoryStream mStream = new MemoryStream(ImgBytes))
            {
                BMap = new Bitmap(mStream);
                S = BMap.Size;
                mStream.Position = 0;
                Texture = TextureLoader.FromStream(Graphics.D, mStream, S.Width, S.Height, 0, Usage.None, Format.A8B8G8R8, Pool.Managed, Filter.None, Filter.None, Color.Black.ToArgb());
                ImgBytes = null;
                if (!Retain)
                {
                    BMap.Dispose();
                    BMap = null;
                }
                else
                    Bits = new BitArray(BMap.Width * BMap.Height);
            }
        }
        public bool IsTransparent(Point P)
        {
            try
            {                
                if (Converted)
                    return Bits[P.X * S.Height + P.Y];
                if (BMap == null) return true;
                return (BMap.GetPixel(P.X, P.Y) != Color.FromArgb(0, 0, 0));
            }
            catch (Exception ex)
            {
                File.AppendAllText(@".\Error.txt", string.Format("[{0}] {1}" + Environment.NewLine, Engine.Time, ex));
            }

            return false;
        }
        public void Convert()
        {
            try
            {
                if (!Converted && BMap != null)
                {
                    using (Bitmap I = new Bitmap(BMap))
                    {
                        Bits = new BitArray(S.Width * S.Height, true);
                        for (int x = 0; x < S.Width; x++)
                            for (int y = 0; y < S.Height; y++)
                                if (I.GetPixel(x, y) == Color.FromArgb(0, 0, 0)) Bits[x * S.Height + y] = false;
                        Converted = true;
                    }
                    BMap.Dispose();
                }
            }
            catch (Exception ex)
            {
                File.AppendAllText(@".\Error.txt", string.Format("[{0}] {1}" + Environment.NewLine, Engine.Time, ex));
            }

        }
        public void Dispose()
        {
            if (BMap != null) BMap.Dispose();
            if (Texture != null) Texture.Dispose();
            Converted = false;
            Bits = null;
        }
    }


}
