﻿using System;
using System.Collections.Generic;

namespace Clash_Client
{

    public struct FrameDefaults
    {
        public int Start, Count, Skip;
        public TimeSpan Time;
        public FrameDefaults(int _Start, int _Count, int _Skip, TimeSpan _Time)
        {
            Start = _Start;
            Count = _Count;
            Skip = _Skip;
            Time = _Time;
        }
    }
    public class Human
    {
        public static FrameDefaults Stand = new FrameDefaults(0, 4, 0, new TimeSpan(0, 0, 0, 0, 400));
        public static FrameDefaults Walk = new FrameDefaults(32, 6, 0, new TimeSpan(0, 0, 0, 0, 0));
        public static FrameDefaults Run = new FrameDefaults(80, 6, 0, new TimeSpan(0, 0, 0, 0, 0));
        public static FrameDefaults BattleStance = new FrameDefaults(128, 1, 0, new TimeSpan(0, 0, 0, 0, 2000));
        public static FrameDefaults Attack1 = new FrameDefaults(136, 6, 0, new TimeSpan(0, 0, 0, 0, 85));
        public static FrameDefaults Attack2 = new FrameDefaults(184, 6, 0, new TimeSpan(0, 0, 0, 0, 90));
        public static FrameDefaults Attack3 = new FrameDefaults(232, 8, 0, new TimeSpan(0, 0, 0, 0, 70));
        public static FrameDefaults Spell = new FrameDefaults(296, 6, 0, new TimeSpan(0, 0, 0, 0, 60));
        public static FrameDefaults Harvest = new FrameDefaults(344, 2, 0, new TimeSpan(0, 0, 0, 0, 300));
        public static FrameDefaults Struck = new FrameDefaults(360, 3, 0, new TimeSpan(0, 0, 0, 0, 130));
        public static FrameDefaults Die = new FrameDefaults(384, 4, 0, new TimeSpan(0, 0, 0, 0, 120));
    }
    public class MonsterFrame
    {
        public static List<MonsterFrame> Frames = new List<MonsterFrame>();
        public FrameDefaults Stand;
        public FrameDefaults Walk;
        public FrameDefaults Run;
        public FrameDefaults BattleStance;
        public FrameDefaults Attack;
        public FrameDefaults Spell;
        public FrameDefaults Harvest;
        public FrameDefaults Struck;
        public FrameDefaults Die;
        public FrameDefaults Death;
        public FrameDefaults Skeleton;
        public static void Create()
        {
            new Monster00();
            new Monster01();
        }
    }
    public class Monster00 : MonsterFrame
    {
        public Monster00()
        {
            Stand = new FrameDefaults(0, 4, 0, new TimeSpan(0, 0, 0, 0, 500));
            Walk = new FrameDefaults(32, 6, 0, new TimeSpan(0, 0, 0, 0, 100));
            Attack = new FrameDefaults(80, 6, 0, new TimeSpan(0, 0, 0, 0, 100));
            Spell = new FrameDefaults(80, 6, 0, new TimeSpan(0, 0, 0, 0, 100));
            Struck = new FrameDefaults(128, 2, 0, new TimeSpan(0, 0, 0, 0, 200));
            Die = new FrameDefaults(144, 10, 0, new TimeSpan(0, 0, 0, 0, 130));
            Death = new FrameDefaults(153, 1, 9, new TimeSpan(0, 0, 0, 0, 130));
            Frames.Add(this);
        }
    }
    public class Monster01 : MonsterFrame
    {
        public Monster01()
        {
            Stand = new FrameDefaults(0, 6, 0, new TimeSpan(0, 0, 0, 0, 500));
            Walk = new FrameDefaults(48, 8, 0, new TimeSpan(0, 0, 0, 0, 100));
            Attack = new FrameDefaults(112, 6, 0, new TimeSpan(0, 0, 0, 0, 100));
            Spell = new FrameDefaults(80, 6, 0, new TimeSpan(0, 0, 0, 0, 100));
            Struck = new FrameDefaults(160, 3, 0, new TimeSpan(0, 0, 0, 0, 200));
            Die = new FrameDefaults(184, 6, 0, new TimeSpan(0, 0, 0, 0, 130));
            Death = new FrameDefaults(320, 10, -10, new TimeSpan(0, 0, 0, 0, 130));
            Frames.Add(this);
        }
    }
}
