﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Text;
using System.IO;
using System.Windows.Forms;
using Clash_Library;
using System.Runtime.Serialization.Formatters.Binary;

namespace Clash_Library_Maker
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
        }

        private void CreateList()
        {
            FileList.Items.Clear();
            GetFolders(InPath.Text);
            
        }

        public void GetFolders(string Path)
        {
            foreach (string S in Directory.GetDirectories(Path))
                if (!S.EndsWith(@"\Placements"))
                {
                    FileList.Items.Add(S);
                    GetFolders(S);
                }
        }


        private void InButton_Click(object sender, EventArgs e)
        {
            if (FDialog.ShowDialog() == DialogResult.OK)
            {
                InPath.Text = FDialog.SelectedPath;
                CreateList();
            }
        }

        private void ITicks_Click(object sender, EventArgs e)
        {
            for (int I = 0; I < FileList.Items.Count; I++)
                FileList.SetItemChecked(I, !FileList.GetItemChecked(I));

        }

        private void Convert_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                ConvertFolder(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }
        private void ConvertFolder(string S)
        {
            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetFiles(S, "*." + FFormat.Text).Length;
            FilePrg.Update();
            foreach (string File in Directory.GetFiles(S, "*." + FFormat.Text))
            {
                using (Bitmap B = new Bitmap(File))
                    switch (TFormat.Text)
                    {
                        case "BMP":
                            B.Save(S + @"\" + Path.GetFileNameWithoutExtension(File) + ".bmp", ImageFormat.Bmp);
                            break;
                        case "JPG":
                            B.Save(S + @"\" + Path.GetFileNameWithoutExtension(File) + ".jpg", ImageFormat.Jpeg);
                            break;
                        case "PNG":
                            B.Save(S + @"\" + Path.GetFileNameWithoutExtension(File) + ".png", ImageFormat.Png);
                            break;
                    }

                if (FilePrg.Value++ % 10 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
            }

        }

        private void GPlace_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                GetPlacements(S);
                TotalPrg.Value++;
                TotalPrg.Update();
            }
        }
        private void GetPlacements(string S)
        {
            string FileName = Path.GetFileNameWithoutExtension(S);
            if (!File.Exists(S + ".Wix")) return;
            if (!File.Exists(S +  ".Wil")) return;

            byte[] FileBytes = File.ReadAllBytes(S + ".Wix");
            int ImageCount = BitConverter.ToInt32(FileBytes, 20), OS = 24;
            int[] FilePosition = new int[ImageCount];
            FilePrg.Value = 0;
            FilePrg.Maximum = ImageCount * 3;
            FilePrg.Update();

            for (int I = 0; I < ImageCount; I++)
            {
                FilePosition[I] = BitConverter.ToInt32(FileBytes, OS += 4);

                if (FilePrg.Value++ % 10 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
            }

            FileBytes = File.ReadAllBytes(S + ".WiL");

            Point[] IOffSets = new Point[ImageCount], SOffSets = new Point[ImageCount];


            for (int I = 0; I < ImageCount; I++)
            {
                OS = FilePosition[I] + 4;
                if (OS > 4)
                {
                    IOffSets[I] = new Point(BitConverter.ToInt16(FileBytes, OS), BitConverter.ToInt16(FileBytes, OS += 2));
                    SOffSets[I] = new Point(BitConverter.ToInt16(FileBytes, OS += 3), BitConverter.ToInt16(FileBytes, OS += 2));
                }
                else
                {
                    IOffSets[I] = Point.Empty;
                    SOffSets[I] = Point.Empty;
                }

                if (FilePrg.Value++ % 10 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
            }
            string path = Path.Combine(S, "Placements");
            if (!Directory.Exists(path)) Directory.CreateDirectory(path);

            for (int I = 0; I < ImageCount; I++)
            {
                if (IOffSets[I] != Point.Empty || SOffSets[I] != Point.Empty)
                {
                    FileBytes = ASCIIEncoding.ASCII.GetBytes(
                        IOffSets[I].X.ToString() + Environment.NewLine + IOffSets[I].Y.ToString() + Environment.NewLine +
                        SOffSets[I].X.ToString() + Environment.NewLine + SOffSets[I].Y.ToString());
                    File.WriteAllBytes(Path.Combine(path, I.ToString("00000") + ".txt"), FileBytes);
                }

                if (FilePrg.Value++ % 10 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
            }

        }

        private void CShadow_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                CreateShadows(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }
        private void CreateShadows(string S)
        {
            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetFiles(S, "*." + SFormat.Text).Length;
            FilePrg.Update();
            int Mob = -1, SX, SY,FX,FY;
            string SavePath = "", SPath = S.Insert(S.LastIndexOf('-'), "S");
            string[] Points;
            Bitmap Final;
            if (!Directory.Exists(SPath)) return;

            foreach (string file in Directory.GetFiles(S, "*." + SFormat.Text))
            {

                if (FilePrg.Value++ % 10 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }

                if (!File.Exists(Path.Combine(SPath, Path.GetFileName(file)))) continue;

                if (Mob != int.Parse(Path.GetFileNameWithoutExtension(file)) / 1000)
                {
                    Mob = int.Parse(Path.GetFileNameWithoutExtension(file)) / 1000;
                    SavePath = Path.Combine(InPath.Text, @"Monster\" + Directory.GetDirectories(Path.Combine(InPath.Text, @"Monster\")).Length.ToString("00000"));
                    if (!Directory.Exists(SavePath)) Directory.CreateDirectory(SavePath);
                    if (!Directory.Exists(Path.Combine(SavePath, "Placements"))) Directory.CreateDirectory(Path.Combine(SavePath, "Placements"));
                }

                Points = File.ReadAllLines(Path.Combine(SPath, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"));
                SX = int.Parse(Points[0]); SY = int.Parse(Points[1]);

                Points = File.ReadAllLines(Path.Combine(S, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"));
                SX -= int.Parse(Points[0]); SY -= int.Parse(Points[1]);

                using (Bitmap Img = new Bitmap(file))
                {
                    FX = Img.Width;
                    FY = Img.Height;
                    Img.MakeTransparent(Color.FromArgb(255, 0, 255));
                    using (Bitmap shad = new Bitmap(Path.Combine(SPath, Path.GetFileName(file))))
                    {
                        if (FX < shad.Width + SX) FX = shad.Width + SX;
                        if (FY < shad.Height + SY) FY = shad.Height + SY;
                        Final = new Bitmap(FX, FY);
                        shad.MakeTransparent(Color.FromArgb(255, 0, 255));
                        for (int X = 0; X < shad.Width; X++)
                            for (int Y = 0; Y < shad.Height; Y++)
                            {
                                if (shad.GetPixel(X, Y) != Color.FromArgb(0,0, 0, 0))
                                    if (X % 2 != Y % 2)
                                        shad.SetPixel(X, Y, Color.FromArgb(16, 8, 8));
                                    else
                                        shad.SetPixel(X, Y, Color.FromArgb(0, 0, 0, 0));

                            }
                        using (Graphics G = Graphics.FromImage(Final))
                        {
                            G.Clear(Color.Magenta);
                            G.DrawImage(Img, Point.Empty);
                            G.DrawImage(shad, new Point(SX, SY));
                            G.Save();
                        }
                    }
                }

                switch (SFormat.Text)
                {
                    case "BMP":
                        Final.Save(Path.Combine(SavePath, Path.GetFileName(file)), ImageFormat.Bmp);
                        File.Copy(Path.Combine(S, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"), Path.Combine(SavePath, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"));
                        break;
                    case "JPG":
                        Final.Save(Path.Combine(SavePath, Path.GetFileName(file)), ImageFormat.Jpeg);
                        File.Copy(Path.Combine(S, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"), Path.Combine(SavePath, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"));
                        break;
                    case "PNG":
                        Final.Save(Path.Combine(SavePath, Path.GetFileName(file)), ImageFormat.Png);
                        File.Copy(Path.Combine(S, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"), Path.Combine(SavePath, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"));
                        break;
                }
            }
        }
        private Bitmap CreateShadow(Bitmap B)
        {
            int Width = B.Width;
            int Height = B.Height, HalfHeight = Height / 2;

            Bitmap NewImage = new Bitmap(Width+ HalfHeight, Height );
            using (Graphics G = Graphics.FromImage(NewImage))            
                using (Bitmap TempImg = new Bitmap(B))
                {
                    G.Clear(Color.Magenta);
                    TempImg.MakeTransparent(Color.Black);
                    for (int X = 0; X < TempImg.Width; X++)
                        for (int Y = 0; Y < TempImg.Height; Y++)
                        {
                            if (TempImg.GetPixel(X, Y) != Color.FromArgb(0, 0, 0, 0))
                                if (X % 2 != Y % 2)
                                    TempImg.SetPixel(X, Y, Color.FromArgb(16, 8, 8));
                                else
                                    TempImg.SetPixel(X, Y, Color.FromArgb(0, 0, 0, 0));
                        }
                    G.DrawImage(TempImg, new Point[] { new Point(HalfHeight, HalfHeight), new Point(HalfHeight + Width, HalfHeight), new Point(0, Height) });
                    using (Bitmap TempImg2 = new Bitmap(B))
                    {
                        TempImg2.MakeTransparent(Color.Black);
                        G.DrawImage(TempImg2, new Point(5, 7));
                    }
                    G.Save();
                }


            return NewImage;
        }

        private void CKey_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                ChangeKey(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }
        private void ChangeKey(string S)
        {
            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetFiles(S, "*." + KFormat.Text).Length;
            FilePrg.Update();

            foreach (string file in Directory.GetFiles(S, "*." + KFormat.Text))
            {
                if (FilePrg.Value++ % 10 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }

                MemoryStream MS = new MemoryStream(File.ReadAllBytes(file));

                Bitmap B = new Bitmap(MS);

                for (int X = 0; X < B.Width; X++)
                    for (int Y = 0; Y < B.Height; Y++)
                    {
                        if (B.GetPixel(X, Y) == Color.FromArgb(0, 0, 0))
                            B.SetPixel(X, Y, Color.FromArgb(0, 0, 1));
                        if (B.GetPixel(X, Y) == Color.FromArgb(255, 0, 255))
                            B.SetPixel(X, Y, Color.FromArgb(0, 0, 0));
                    }

                switch (SFormat.Text)
                {
                    case "BMP":
                        B.Save(file, ImageFormat.Bmp);
                        break;
                    case "JPG":
                        B.Save(file, ImageFormat.Jpeg);
                        break;
                    case "PNG":
                        B.Save(file, ImageFormat.Png);
                        break;
                }
            }

        }

        private void Renumber_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                ReNumber(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }
        private void ReNumber(string S)
        {

            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetFiles(S, @"*.png").Length * 2;
            FilePrg.Update();

            string newfile;
            int I = 0;
            foreach (string file in Directory.GetFiles(S, @"*.png"))
            {
               newfile  = Path.GetDirectoryName(file) + @"\" + I.ToString("00000") + @".png";
                if (File.Exists(newfile)) continue;
                File.Move(file, newfile);
                I++;
                if (FilePrg.Value++ % 10 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
            }
            I = 0;
            if (Directory.Exists(S + @"\Placements\"))
            foreach (string file in Directory.GetFiles(S + @"\Placements\", @"*.txt"))
            {
                newfile = Path.GetDirectoryName(file) + @"\" + I.ToString("00000") + @".txt";
                if (File.Exists(newfile)) continue;
                File.Move(file, newfile);
                I++;
                if (FilePrg.Value++ % 50 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
            }
        }

        private void Create_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                CreateLibrary(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }
        private void CreateLibrary(string S)
        {
            string SPath = S.Substring(0, S.LastIndexOf('\\'));
            int ImageCount = Directory.GetFiles(S, @"*." + LFormat.Text).Length;
            if (ImageCount == 0) return;
            ImageCount = int.Parse(Path.GetFileNameWithoutExtension(Directory.GetFiles(S, @"*." + LFormat.Text)[ImageCount - 1]));
            Dictionary<int,ImageInfo> IndexInfo = new Dictionary<int,ImageInfo>();
            ImageInfo IInfo;
            string file;
            string[] Placements;
            byte[] Bytes;

            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetFiles(S, @"*." + LFormat.Text).Length;
            FilePrg.Update();

            using (MemoryStream MStream = new MemoryStream())
            {
                for (int I = 0; I <= ImageCount; I++)
                {
                    if (!File.Exists(Path.Combine(S, I.ToString("00000") + @"." + LFormat.Text))) continue;
                    else
                        file = Path.Combine(S, I.ToString("00000") + @"." + LFormat.Text);

                    if (FilePrg.Value++ % 10 == 0)
                    {
                        FilePrg.Update();
                        Application.DoEvents();
                    }

                    Placements = new string[] { "0", "0" };
                    try
                    {
                        if (File.Exists(S + @"\Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"))
                            Placements = File.ReadAllLines(S + @"\Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt");
                    }
                    catch
                    {
                    }

                    IInfo = new ImageInfo();
                    IInfo.Start = MStream.Length;
                    IInfo.OffSet = new Point(int.Parse(Placements[0]), int.Parse(Placements[1]));
                    using (Bitmap B = new Bitmap(file))
                        IInfo.ImageSize = B.Size;
                    Bytes = File.ReadAllBytes(file);
                    IInfo.Length = Bytes.Length;
                    MStream.Write(Bytes, 0, Bytes.Length);
                    IndexInfo[I] = IInfo;
                }

                using (FileStream FStream = new FileStream(Path.Combine(SPath, Path.GetFileName(S) + @".CLib"), FileMode.Create))
                {
                    new BinaryFormatter().Serialize(FStream, IndexInfo);
                    MStream.WriteTo(FStream);
                }
            }
        }

        private void Clean_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                CleanUp(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }
        private void CleanUp(string S)
        {

            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetFiles(S, @"*." + CFormat.Text).Length;
            FilePrg.Update();
            string Del;
            Image I;

            foreach (string file in Directory.GetFiles(S, @"*." + CFormat.Text))
            {
                if (FilePrg.Value++ % 10 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
                if (Fillers.Checked)
                {
                    using (MemoryStream MS = new MemoryStream(File.ReadAllBytes(file)))
                    {
                        I = Bitmap.FromStream(MS);
                        if (I.Width <= 4 && I.Height == 1)
                        {
                            File.Delete(file);
                            Del = Path.GetDirectoryName(file) + @"\Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt";
                            if (File.Exists(Del))
                                File.Delete(Del);
                        }
                    }
                }
                else
                    File.Delete(file);

            }

        }

        private void Shrink_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                ShrinkName(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }
        private void ShrinkName(string S)
        {
            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetFiles(S, @"*.png").Length * 2;
            FilePrg.Update();
            string newfile;
            foreach (string file in Directory.GetFiles(S, @"*.png"))
            {
                newfile = Path.GetDirectoryName(file) + @"\" + int.Parse(Path.GetFileNameWithoutExtension(file)).ToString("00000") + @".png";
                if (File.Exists(newfile)) continue;
                File.Move(file, newfile);
                if (FilePrg.Value++ % 100 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
            }
            if (Directory.Exists(S + @"\Placements\"))
            foreach (string file in Directory.GetFiles(S + @"\Placements\", @"*.txt"))
            {
                newfile = Path.GetDirectoryName(file) + @"\" + int.Parse(Path.GetFileNameWithoutExtension(file)).ToString("00000") + @".txt";
                if (File.Exists(newfile)) continue;
                File.Move(file, newfile);
                if (FilePrg.Value++ % 100 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
            }
        }

        private void Split_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                SplitFile(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }
        private void SplitFile(string S)
        {
            bool clear = false;            
            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetFiles(S, "*." + LFormat.Text).Length;
            FilePrg.Update();
            int Mob = -1;
            string SavePath = "";

            if (string.IsNullOrEmpty(SplitPath.Text))
            {
                clear = true;
                SplitPath.Text = S.Replace("Raw", "Processed");
            }

            if (!Directory.Exists(SplitPath.Text)) Directory.CreateDirectory(SplitPath.Text);
            foreach (string file in Directory.GetFiles(S, "*." + LFormat.Text))
            {

                if (FilePrg.Value++ % 50 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }

                if (Mob != int.Parse(Path.GetFileNameWithoutExtension(file)) / (int)SplitCount.Value)
                {
                    Mob = int.Parse(Path.GetFileNameWithoutExtension(file)) / (int)SplitCount.Value;
                    SavePath = Path.Combine(SplitPath.Text, Directory.GetDirectories(SplitPath.Text).Length.ToString("00000"));
                    if (!Directory.Exists(SavePath)) Directory.CreateDirectory(SavePath);
                    if (!Directory.Exists(Path.Combine(SavePath, "Placements"))) Directory.CreateDirectory(Path.Combine(SavePath, "Placements"));
                }

                if (File.Exists(Path.Combine(S, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt")))
                    File.Copy(Path.Combine(S, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"), Path.Combine(SavePath, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"));
                File.Copy(file, Path.Combine(SavePath, Path.GetFileName(file)));
            }
            if (clear)
                SplitPath.Text = "";
        }

        private void SButton_Click(object sender, EventArgs e)
        {
            if (FDialog.ShowDialog() == DialogResult.OK)            
                SplitPath.Text = FDialog.SelectedPath;
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                ExtractPlacements(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }

        private void ExtractPlacements(string S)
        {
            FilePrg.Value = 0;
            if (!File.Exists(Path.Combine(S, "00000.txt"))) return;
            string[] Lines = File.ReadAllLines(Path.Combine(S, "00000.txt")), Data, Data2;
            FilePrg.Maximum = Lines.Length;
            FilePrg.Update();

            if (!Directory.Exists(Path.Combine(S, @"Placements\"))) Directory.CreateDirectory(Path.Combine(S, @"Placements\"));

            foreach (string Line in Lines)
            {
                if (FilePrg.Value++ % 50 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
                Data = Line.Split('	');
                Data2 = new string[5];

                for (int I = 0; I < 5; I++)
                    Data2[I] = Data[I + 1];


                File.WriteAllLines(Path.Combine(S, @"Placements\" + Path.GetFileNameWithoutExtension(Data[0]) + ".txt"), Data2);
            }
            File.Delete(Path.Combine(S, "00000.txt"));
        }

        private void Add_Click(object sender, EventArgs e)
        {
            if (SplitBox.Items.Contains((int)SplitCount.Value)) return;
            else SplitBox.Items.Add((int)SplitCount.Value);
        }

        private void Remove_Click(object sender, EventArgs e)
        {
            if (SplitBox.SelectedIndex != -1)
                SplitBox.Items.RemoveAt(SplitBox.SelectedIndex);
        }

        private void SelSplit_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                SSplit(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }
        private void SSplit(string S)
        {
            bool clear = false;
            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetFiles(S, "*." + LFormat.Text).Length;
            FilePrg.Update();
            string SavePath = "";
            int I;

            if (string.IsNullOrEmpty(SplitPath.Text))
            {
                clear = true;
                SplitPath.Text = S.Replace("Raw", "Processed");
            }
            if (!Directory.Exists(SplitPath.Text)) Directory.CreateDirectory(SplitPath.Text);
            SavePath = Path.Combine(SplitPath.Text, Directory.GetDirectories(SplitPath.Text).Length.ToString("00000"));
            if (!Directory.Exists(SavePath)) Directory.CreateDirectory(SavePath);
            if (!Directory.Exists(Path.Combine(SavePath, "Placements"))) Directory.CreateDirectory(Path.Combine(SavePath, "Placements"));
            foreach (string file in Directory.GetFiles(S, "*." + LFormat.Text))
            {

                if (FilePrg.Value++ % 50 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
                I = int.Parse(Path.GetFileNameWithoutExtension(file));
                if (I == 281)
                { }
                if (SplitBox.Items.Contains(I))
                {
                    SavePath = Path.Combine(SplitPath.Text, Directory.GetDirectories(SplitPath.Text).Length.ToString("00000"));
                    if (!Directory.Exists(SavePath)) Directory.CreateDirectory(SavePath);
                    if (!Directory.Exists(Path.Combine(SavePath, "Placements"))) Directory.CreateDirectory(Path.Combine(SavePath, "Placements"));
                }
                if (File.Exists(Path.Combine(S, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt")))
                    File.Copy(Path.Combine(S, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"), Path.Combine(SavePath, @"Placements\" + Path.GetFileNameWithoutExtension(file) + ".txt"));
                File.Copy(file, Path.Combine(SavePath, Path.GetFileName(file)));
            }
            if (clear)
                SplitPath.Text = "";
        }
        private void Clear_Click(object sender, EventArgs e)
        {
            SplitBox.Items.Clear();
        }

        private void DecFolder_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                Decrease(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
            CreateList();
        }
        private void Decrease(string S)
        {
            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetDirectories(S).Length;
            FilePrg.Update();

            string New;
            foreach (string Old in Directory.GetDirectories(S))
            {
                if (FilePrg.Value++ % 50 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
                New = Path.Combine(Path.GetDirectoryName(Old), (int.Parse(Path.GetFileName(Old)) - 1).ToString("00000"));
                Directory.Move(Old, New);
            }
        }


        private void IncFolder_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                Increase(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
            CreateList();
        }
        private void Increase(string S)
        {
            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetDirectories(S).Length;
            FilePrg.Update();

            string Old;
            string New;
            for (int I = Directory.GetDirectories(S).Length - 1; I >= 0; I--)
            {
                Old = Directory.GetDirectories(S)[I];
                New = Path.Combine(Path.GetDirectoryName(Old), (int.Parse(Path.GetFileName(Old)) + 1).ToString("00000"));
                Directory.Move(Old, New);
            }


        }

        private void DecFile_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                DecreaseF(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }
        private void DecreaseF(string S)
        {
            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetFiles(S).Length;
            FilePrg.Update();
            
            string New, Old;
            foreach (string file in Directory.GetFiles(S))
            {
                if (FilePrg.Value++ % 50 == 0)
                {
                    FilePrg.Update();
                    Application.DoEvents();
                }
                New = Path.Combine(Path.GetDirectoryName(file), (int.Parse(Path.GetFileNameWithoutExtension(file)) - 1).ToString("00000") + Path.GetExtension(file));
                Directory.Move(file, New);
                Old = Path.ChangeExtension(file.Insert(file.LastIndexOf('\\'), "\\Placements"), ".txt");
                New = Path.ChangeExtension(New.Insert(New.LastIndexOf('\\'), "\\Placements"), ".txt");
                Directory.Move(Old, New);
            }
        }



        private void IncreaseF(string S)
        {
            FilePrg.Value = 0;
            FilePrg.Maximum = Directory.GetFiles(S).Length;
            FilePrg.Update();

            string Old;
            string New;
            for (int I = Directory.GetFiles(S).Length - 1; I >= 0; I--)
            {
                Old = Directory.GetDirectories(S)[I];
                New = Path.Combine(Path.GetDirectoryName(Old), (int.Parse(Path.GetFileNameWithoutExtension(Old)) + 1).ToString("00000") + Path.GetExtension(Old));
                Directory.Move(Old, New);
                Old = Path.ChangeExtension(Old.Insert(Old.LastIndexOf('\\'), "\\Placements"), ".txt");
                New = Path.ChangeExtension(New.Insert(New.LastIndexOf('\\'), "\\Placements"), ".txt");
                Directory.Move(Old, New);
            }


        }

        private void IncFile_Click(object sender, EventArgs e)
        {
            TotalPrg.Value = 0;
            TotalPrg.Maximum = FileList.CheckedItems.Count;
            TotalPrg.Update();
            foreach (string S in FileList.CheckedItems)
            {
                IncreaseF(S);
                TotalPrg.Value++;
                TotalPrg.Update();
                Application.DoEvents();
            }
        }
    }
}
