﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Threading;

namespace Clash_Server
{
    public partial class Main : Form
    {
        public long TotalBytes, LastBytes;
        public static Queue<string> MessageList = new Queue<string>();

        public Main()
        {
            InitializeComponent();
            Config.Load();
        }


        private void ServerStatus_Click(object sender, EventArgs e)
        {
            ThreadPool.QueueUserWorkItem(Engine.Load);
        }


        private void Main_FormClosing(object sender, FormClosingEventArgs e)
        {
            Config.Save();
            Accounts.Save();
            while (MessageList.Count > 0)
                richTextBox1.AppendText(DateTime.Now.ToShortTimeString() + " " + MessageList.Dequeue() + Environment.NewLine);
            if (!Directory.Exists(Config.LogFolder)) Directory.CreateDirectory(Config.LogFolder);
            string FileName = DateTime.Today.ToShortDateString().Replace('/', '-');
            File.AppendAllLines(Path.Combine(Config.LogFolder, FileName + @".txt"), richTextBox1.Lines);
        }

        private void InterfaceTimer_Tick(object sender, EventArgs e)
        {
            int MC = 0, UC = 0;

            if (Engine.State == EngineState.Running)
            {
                if (InterfaceTimer.Interval != 1000) InterfaceTimer.Interval = 1000;
                foreach (Map M in Engine.MapList.Values)
                    MC += M.Monsters.Count;

                if (Network.MirClients != null)
                    for (int I = Network.MirClients.Count - 1; I >= 0; I--)
                        if (Network.MirClients[I].Stage != ConnectionStage.Exit) UC++;
            }

            while (MessageList.Count > 0)
                richTextBox1.AppendText(DateTime.Now.ToLongTimeString() + " " + MessageList.Dequeue() + Environment.NewLine);


            ServerStatus.Text = string.Format("Server {0}.", Engine.State.ToString());
            switch (Engine.State)
            {
                case EngineState.Stopped:
                    ServerStatus.BackColor = Color.Red;
                    break;
                case EngineState.Running:
                    ServerStatus.BackColor = Color.Green;
                    break;
                case EngineState.Stopping:
                case EngineState.Loading:
                    ServerStatus.BackColor = Color.Orange;
                    break;
                case EngineState.Crashed:
                case EngineState.Failed:
                    ServerStatus.BackColor = Color.Black;
                    break;
            }
            TBandwidth.Text = string.Format("Total Bandwidth: {0} KB", TotalBytes / 1024);
            CBandwidth.Text = string.Format("Bandwidth: {0} KBPS", (TotalBytes - LastBytes) / 1024);
            MobCount.Text = string.Format("Mobs: {0}", MC);
            UserCount.Text = string.Format("Users: {0}", UC);
            LastBytes = TotalBytes;
        }
    }
}
