﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;

namespace Clash_Server
{
    class Network
    {
        #region Fields
        public static TcpListener MainListener;
        public static DateTime StartTime;
        public static List<MirClient> MirClients;
        public static int NextSessionID = 0;
        #endregion

        public static bool Load()
        {
            try
            {
                Main.MessageList.Enqueue("Starting Network.");
                Accounts.Load();
                MainListener = new TcpListener(new IPEndPoint(IPAddress.Parse(Config.IPAddress), Config.Port));
                MainListener.Start(100);
                MainListener.BeginAcceptTcpClient(Connection, null);
                MirClients = new List<MirClient>();

                StartTime = DateTime.Now;
                Main.MessageList.Enqueue("Network Started.");
                return true;
            }
            catch ( Exception ex)
            {
                Main.MessageList.Enqueue(ex.ToString());
                MainListener = null;
                MirClients = null;
            }
            return false;
        }
        public static void Connection(IAsyncResult Result)
        {
            try
            {
                TcpClient newClient = MainListener.EndAcceptTcpClient(Result);
                string IPAddress = newClient.Client.RemoteEndPoint.ToString().Split(':')[0];

                MirClient MC = new MirClient(newClient, NextSessionID++);
                MirClients.Add(MC);

                if (Config.BanList.Contains(IPAddress))
                    MC.SendDisconnect(3);

                MainListener.BeginAcceptTcpClient(new AsyncCallback(Connection), null);
            }
            catch ( Exception ex)
            {
                Main.MessageList.Enqueue(ex.ToString());
            }
        }
    }
}
