﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Threading;
using Clash_Library;
using System.IO;

namespace Clash_Server
{
    class Config
    {

        #region Controls

        public static bool
                    AllowNewAccounts = true,
                    AllowLogin = true,
                    AllowChangePassword = true,
                    AllowNewCharacters = true,
                    AllowDeleteCharacter = true,
                    AllowStartGame = true,
                    AllowReuseName = true,
                    AllowReuseNameOnAcc = true,
                    AllowLogout = true;

        #endregion
        #region Paths
        public static string
            LogFolder = @".\Log\",
            DataFolder = @".\Data\",
            DataFile = @"Data.CL",
            AccountPath = @".\Accounts\",
            MapPath = @".\Maps\";
        #endregion

        public static string IPAddress = "127.0.0.1";
        public static int Port = 7000;
        public static int DataRange = 15;

        private static int _ItemID = 0;
        public static int ItemID
        {
            get { return Interlocked.Increment(ref _ItemID); }
        }

        public static int SpawnAttempts = 10;
        public static int StartMapID = 0;
        public static Point StartPoint = new Point(330, 270);
        public static List<long> MaxExpList = new List<long>();

        public static List<string> BanList = new List<string>();
        private const string ConfigFile = @".\Config.ini";
        public static void Load()
        {
            if (File.Exists(ConfigFile))
            {
                IniReader IReader = new IniReader(ConfigFile);

                AllowNewAccounts = IReader.ReadBoolean("Config", "AllowNewAccounts", AllowNewAccounts);
                AllowLogin = IReader.ReadBoolean("Config", "AllowLogin", AllowLogin);
                AllowChangePassword = IReader.ReadBoolean("Config", "AllowChangePassword", AllowChangePassword);
                AllowNewCharacters = IReader.ReadBoolean("Config", "AllowNewCharacters", AllowNewCharacters);
                AllowDeleteCharacter = IReader.ReadBoolean("Config", "AllowDeleteCharacter", AllowDeleteCharacter);
                AllowStartGame = IReader.ReadBoolean("Config", "AllowStartGame", AllowStartGame);
                AllowReuseName = IReader.ReadBoolean("Config", "AllowReuseName", AllowReuseName);
                AllowReuseNameOnAcc = IReader.ReadBoolean("Config", "AllowReuseNameOnAcc", AllowReuseNameOnAcc);
                AllowLogout = IReader.ReadBoolean("Config", "AllowLogout", AllowLogout);
                LogFolder = IReader.ReadString("Config", "LogFolder", LogFolder);
                DataFolder = IReader.ReadString("Config", "DataFolder", DataFolder);
                DataFile = IReader.ReadString("Config", "DataFile", DataFile);
                AccountPath = IReader.ReadString("Config", "AccountPath", AccountPath);
                MapPath = IReader.ReadString("Config", "MapPath", MapPath);                
                IPAddress = IReader.ReadString("Config", "IPAddress", IPAddress);
                Port = IReader.ReadInt32("Config", "Port", Port);
                DataRange = IReader.ReadInt32("Config", "DataRange", DataRange);
                _ItemID = IReader.ReadInt32("Config", "_ItemID", _ItemID);
                SpawnAttempts = IReader.ReadInt32("Config", "SpawnAttempts", SpawnAttempts);
                StartMapID = IReader.ReadInt32("Config", "StartMapID", StartMapID);
                StartPoint = IReader.ReadPoint("Config", "StartPoint", StartPoint);
            }
            else
                Save();
            if (File.Exists(@".\BanList.txt")) BanList.AddRange(File.ReadAllLines(@".\BanList.txt"));

            MaxExpList.Add(0);
            try
            {
                foreach (String S in File.ReadAllLines(@".\ExpList.txt"))
                {
                    if (File.Exists(@".\ExpList.txt")) MaxExpList.Add(long.Parse(S));
                }
            }
            catch
            { }
        }
        public static void Save()
        {
            IniReader IReader = new IniReader(ConfigFile);
            IReader.DontSave = true;
            IReader.Write("Config", "AllowNewAccounts", AllowNewAccounts);
            IReader.Write("Config", "AllowLogin", AllowLogin);
            IReader.Write("Config", "AllowChangePassword", AllowChangePassword);
            IReader.Write("Config", "AllowNewCharacters", AllowNewCharacters);
            IReader.Write("Config", "AllowDeleteCharacter", AllowDeleteCharacter);
            IReader.Write("Config", "AllowStartGame", AllowStartGame);
            IReader.Write("Config", "AllowReuseName", AllowReuseName);
            IReader.Write("Config", "AllowReuseNameOnAcc", AllowReuseNameOnAcc);
            IReader.Write("Config", "AllowLogout", AllowLogout);

            IReader.Write("Config", "LogFolder", LogFolder);
            IReader.Write("Config", "DataFolder", DataFolder);
            IReader.Write("Config", "DataFile", DataFile);
            IReader.Write("Config", "AccountPath", AccountPath);
            IReader.Write("Config", "MapPath", MapPath);

            IReader.Write("Config", "IPAddress", IPAddress);
            IReader.Write("Config", "Port", Port);
            IReader.Write("Config", "DataRange", DataRange);
            IReader.Write("Config", "ItemID", _ItemID);
            IReader.Write("Config", "SpawnAttempts", SpawnAttempts);
            IReader.Write("Config", "StartMap", StartMapID);
            IReader.Write("Config", "StartPoint", StartPoint);
            IReader.DontSave = false;
            IReader.Save();

            File.WriteAllLines(@".\BanList.txt", BanList);
        }
    }
}
