﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Windows.Forms;
using Clash_Library;

namespace ClashManager
{
    public partial class ItemForm : Form
    {
        ItemInfo CurrentItem = new ItemInfo();

        public ItemForm()
        {
            InitializeComponent();
            
        }

        private void ItemIndex_TextChanged(object sender, EventArgs e)
        {
            if (int.TryParse(ItemIndex.Text, out CurrentItem.Index))
                ItemIndex.BackColor = Color.Green;
            else
                ItemIndex.BackColor = Color.Red;
        }
        private void ItemName_TextChanged(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(ItemName.Text))
                ItemName.BackColor = Color.Green;
            else
                ItemName.BackColor = Color.Red;
            CurrentItem.Name = ItemName.Text;
        }
        private void UpdateName()
        {
            int I = ItemListBox.SelectedIndex;
            if (I == -1) return;
            ItemListBox.SelectedIndexChanged -= ItemListBox_SelectedIndexChanged;
            ItemListBox.Items[I] = CurrentItem;
            ItemListBox.SelectedIndexChanged+= new EventHandler(ItemListBox_SelectedIndexChanged);
        }
        private void ImageIndex_TextChanged(object sender, EventArgs e)
        {
            if (int.TryParse(ImageIndex.Text, out CurrentItem.Image))
                ImageIndex.BackColor = Color.Green;
            else
                ImageIndex.BackColor = Color.Red;
            try
            {
                if (CurrentItem.Image >= 0 && CurrentItem.Image < Directory.GetFiles(@".\Items\", @"*.bmp").Length)
                    pictureBox1.Image = Bitmap.FromFile(Directory.GetFiles(@".\Items\", @"*.bmp")[CurrentItem.Image]);
            }
            catch
            {
            }
        }
        private void Shape_TextChanged(object sender, EventArgs e)
        {
            if (byte.TryParse(Shape.Text, out CurrentItem.Shape))
                Shape.BackColor = Color.Green;
            else
                Shape.BackColor = Color.Red;
        }
        private void ItemType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(ItemType.Text))
            {
                CurrentItem.Type = (ItemType)Enum.Parse(typeof(ItemType), ItemType.Text);
                ItemType.BackColor = Color.Green;
            }
            else
                ItemType.BackColor = Color.Red;
        }
        private void Durability_TextChanged(object sender, EventArgs e)
        {

            if (long.TryParse(Durability.Text, out CurrentItem.Durability))
                Durability.BackColor = Color.Green;
            else
                Durability.BackColor = Color.Red;
        }
        private void Price_TextChanged(object sender, EventArgs e)
        {
            if (long.TryParse(Price.Text, out CurrentItem.Price))
                Price.BackColor = Color.Green;
            else
                Price.BackColor = Color.Red;
        }        
        private void Weight_TextChanged(object sender, EventArgs e)
        {
            if (byte.TryParse(Weight.Text, out CurrentItem.Weight))
                Weight.BackColor = Color.Green;
            else
                Weight.BackColor = Color.Red;
        }
        private void ReqType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(ReqType.Text))
            {
                CurrentItem.ReqType = (Requirement)Enum.Parse(typeof(Requirement), ReqType.Text);
                ReqType.BackColor = Color.Green;
            }
            else
                ReqType.BackColor = Color.Red;
        }
        private void ReqAmount_TextChanged(object sender, EventArgs e)
        {
            if (int.TryParse(ReqAmount.Text, out CurrentItem.ReqAmount))
                ReqAmount.BackColor = Color.Green;
            else
                ReqAmount.BackColor = Color.Red;
            label59.Text = CurrentItem.ReqAmount.ToString();
        }
        private void AddItem_Click(object sender, EventArgs e)
        {
            CurrentItem = new ItemInfo();
            CurrentItem.Index = ItemListBox.Items.Count;
            Main.SData.ItemList.Add(CurrentItem);
            ItemListBox.Items.Add(CurrentItem);
            ItemListBox.SelectedIndex = ItemListBox.Items.Count - 1;
            
        }
        private void ItemListBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            tabControl1.Enabled = true;
            CurrentItem = (ItemInfo)ItemListBox.SelectedItem;
            if (CurrentItem == null) CurrentItem = new ItemInfo();
            UpdateControls();
        }
        private void UpdateControls()
        {
            ItemIndex.Text = CurrentItem.Index.ToString();
            ItemName.Text = CurrentItem.Name;

            ImageIndex.Text = CurrentItem.Image.ToString();
            FloorImage.Text = CurrentItem.FloorImage.ToString();
            BodyImage.Text = CurrentItem.BodyImage.ToString();
            Shape.Text = CurrentItem.Shape.ToString();
            ItemType.Text = CurrentItem.Type.ToString();
            Durability.Text = CurrentItem.Durability.ToString();
            Price.Text = CurrentItem.Price.ToString();
            Weight.Text = CurrentItem.Weight.ToString();
            ReqType.Text = CurrentItem.ReqType.ToString();
            ReqAmount.Text = CurrentItem.ReqAmount.ToString();

            MaxLevel.Text = CurrentItem.MaxLevel.ToString();
            ExpList.Items.Clear();
            foreach (long L in CurrentItem.ExpList)
                ExpList.Items.Add(L);
            DefRefineCount.Text = CurrentItem.DefaultRefineCount.ToString();


            ReqClass.ItemCheck -= ReqClass_ItemCheck;
            for (int I = 0; I < Enum.GetValues(typeof(Clash_Library.ReqClass)).Length; I++)
                if ((CurrentItem.RequiredClass & (Clash_Library.ReqClass)Enum.GetValues(typeof(Clash_Library.ReqClass)).GetValue(I)) != 0)
                    ReqClass.SetItemChecked(I, true);
                else ReqClass.SetItemChecked(I, false);
            ReqClass.ItemCheck+=new ItemCheckEventHandler(ReqClass_ItemCheck);

            ReqGender.ItemCheck -= ReqGender_ItemCheck;
            for (int I = 0; I < Enum.GetValues(typeof(Clash_Library.ReqGender)).Length; I++)
                if ((CurrentItem.RequiredGender & (Clash_Library.ReqGender)Enum.GetValues(typeof(Clash_Library.ReqGender)).GetValue(I)) != 0)
                    ReqGender.SetItemChecked(I, true);
                else ReqGender.SetItemChecked(I, false);
            ReqGender.ItemCheck += new ItemCheckEventHandler(ReqGender_ItemCheck);

            SpecialEffect.ItemCheck -= SpecialEffect_ItemCheck;
            for (int I = 0; I < Enum.GetValues(typeof(Clash_Library.SpecialEffect)).Length; I++)
                if ((CurrentItem.Effect & (Clash_Library.SpecialEffect)Enum.GetValues(typeof(Clash_Library.SpecialEffect)).GetValue(I)) != 0)
                    SpecialEffect.SetItemChecked(I, true);
                else SpecialEffect.SetItemChecked(I, false);
            SpecialEffect.ItemCheck += new ItemCheckEventHandler(SpecialEffect_ItemCheck);

            CanTrade.Checked = CurrentItem.Restrictions.CanTrade;
            CanDrop.Checked = CurrentItem.Restrictions.CanDrop;
            CanBreak.Checked = CurrentItem.Restrictions.CanBreak;

            CanStore.Checked = CurrentItem.Restrictions.CanStore;
            CanDDrop.Checked = CurrentItem.Restrictions.CanDDrop;
            CanSell.Checked = CurrentItem.Restrictions.CanSell;

            CanRepair.Checked = CurrentItem.Restrictions.CanRepair;
            CanSRepair.Checked = CurrentItem.Restrictions.CanSRepair;
            Stuck.Checked = CurrentItem.Restrictions.Stuck;

            CanGem.Checked = CurrentItem.Restrictions.CanGem;
            CanOrb.Checked = CurrentItem.Restrictions.CanOrb;
            CanStack.Checked = CurrentItem.Restrictions.CanStack;


            HP.Text = CurrentItem.Stats.Basic.HP.ToString();
            MP.Text = CurrentItem.Stats.Basic.MP.ToString();
            AC.Text = CurrentItem.Stats.Basic.AC.ToString();
            AC2.Text = CurrentItem.Stats.Basic.AC2.ToString();
            MAC.Text = CurrentItem.Stats.Basic.MAC.ToString();
            MAC2.Text = CurrentItem.Stats.Basic.MAC2.ToString();

            DC.Text = CurrentItem.Stats.Basic.DC.ToString();
            DC2.Text = CurrentItem.Stats.Basic.DC2.ToString();
            MC.Text = CurrentItem.Stats.Basic.MC.ToString();
            MC2.Text = CurrentItem.Stats.Basic.MC2.ToString();
            SC.Text = CurrentItem.Stats.Basic.SC.ToString();
            SC2.Text = CurrentItem.Stats.Basic.SC2.ToString();


            Accuracy.Text = CurrentItem.Stats.Basic.Accuracy.ToString();
            Agility.Text = CurrentItem.Stats.Basic.Agility.ToString();

            ASpeed.Text = CurrentItem.Stats.Advanced.ASpeed.ToString();
            Luck.Text = CurrentItem.Stats.Advanced.Luck.ToString();
            Light.Text = CurrentItem.Stats.Advanced.Light.ToString();
            MR.Text = CurrentItem.Stats.Advanced.MR.ToString();
            PR.Text = CurrentItem.Stats.Advanced.PR.ToString();
            CR.Text = CurrentItem.Stats.Advanced.CR.ToString();
            CA.Text = CurrentItem.Stats.Advanced.CA.ToString();
            PA.Text = CurrentItem.Stats.Advanced.PA.ToString();

            DropCount.Text = CurrentItem.ExistCount.ToString();
            Rarity.Text = CurrentItem.Rarity.ToString();

            FireA.Text = CurrentItem.Stats.Elemental.FireA.ToString();
            LightningA.Text = CurrentItem.Stats.Elemental.LightningA.ToString();
            IceA.Text = CurrentItem.Stats.Elemental.IceA.ToString();
            WindA.Text = CurrentItem.Stats.Elemental.WindA.ToString();
            DarkA.Text = CurrentItem.Stats.Elemental.DarkA.ToString();
            HolyA.Text = CurrentItem.Stats.Elemental.HolyA.ToString();
            IllusionA.Text = CurrentItem.Stats.Elemental.IllusionA.ToString();
            FireD.Text = CurrentItem.Stats.Elemental.FireD.ToString();
            LightningD.Text = CurrentItem.Stats.Elemental.LightningD.ToString();
            IceD.Text = CurrentItem.Stats.Elemental.IceD.ToString();
            WindD.Text = CurrentItem.Stats.Elemental.WindD.ToString();
            DarkD.Text = CurrentItem.Stats.Elemental.DarkD.ToString();
            HolyD.Text = CurrentItem.Stats.Elemental.HolyD.ToString();
            IllusionD.Text = CurrentItem.Stats.Elemental.IllusionD.ToString();

            HandWeight.Text = CurrentItem.HandWeight.ToString();
            BagWeight.Text = CurrentItem.BagWeight.ToString();
            BodyWeight.Text = CurrentItem.BodyWeight.ToString();
        }
        private void ReqClass_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if (e.NewValue == CheckState.Checked)
                CurrentItem.RequiredClass += (int)Enum.GetValues(typeof(Clash_Library.ReqClass)).GetValue(e.Index);
            else
                CurrentItem.RequiredClass -= (int)Enum.GetValues(typeof(Clash_Library.ReqClass)).GetValue(e.Index);
        }
        private void ItemName_Leave(object sender, EventArgs e)
        {
            UpdateName();
        }        
        private void ItemIndex_Leave(object sender, EventArgs e)
        {
            UpdateName();
        }
        private void MaxLevel_TextChanged(object sender, EventArgs e)
        {
            if (uint.TryParse(MaxLevel.Text, out CurrentItem.MaxLevel))
                MaxLevel.BackColor = Color.Green;
            else
                MaxLevel.BackColor = Color.Red;
        }
        private void MaxLevel_Leave(object sender, EventArgs e)
        {
            if (ExpList.Items.Count > CurrentItem.MaxLevel)
                for (int I = ExpList.Items.Count; I > CurrentItem.MaxLevel; I--)
                {
                    ExpList.Items.RemoveAt(ExpList.Items.Count - 1);
                    CurrentItem.ExpList.RemoveAt(CurrentItem.ExpList.Count - 1);
                }
            else if (ExpList.Items.Count < CurrentItem.MaxLevel)
            {
                for (int I = ExpList.Items.Count; I < CurrentItem.MaxLevel; I++)
                {
                    ExpList.Items.Add(0L);
                    CurrentItem.ExpList.Add(0);
                }
            }
        }
        private void textBox1_TextChanged(object sender, EventArgs e)
        {
        }
        private void textBox1_Leave(object sender, EventArgs e)
        {
            if (ExpList.SelectedIndex == -1) return;
            long l;
            long.TryParse(Exp.Text, out l);
            ExpList.Items[ExpList.SelectedIndex] = l;
            for (int I = 0; I < ExpList.Items.Count; I++)
            {
                CurrentItem.ExpList[I] = (long)ExpList.Items[I];
            }

        }
        private void ReqGender_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if (e.NewValue == CheckState.Checked)
                CurrentItem.RequiredGender += (int)Enum.GetValues(typeof(Clash_Library.ReqGender)).GetValue(e.Index);
            else
                CurrentItem.RequiredGender -= (int)Enum.GetValues(typeof(Clash_Library.ReqGender)).GetValue(e.Index);
        }
        private void button1_Click(object sender, EventArgs e)
        {
            using (MemoryStream MStream = new MemoryStream())
            {
                BinaryFormatter BF = new BinaryFormatter();
                BF.Serialize(MStream, CurrentItem);
                MStream.Position = 0;
                CurrentItem = (ItemInfo)BF.Deserialize(MStream);
                CurrentItem.Index = ItemListBox.Items.Count;
                Main.SData.ItemList.Add(CurrentItem);
                ItemListBox.Items.Add(CurrentItem);
                ItemListBox.SelectedIndex = ItemListBox.Items.Count - 1;
            }

        }
        private void CanTrade_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.CanTrade = CanTrade.Checked;
        }
        private void CanDrop_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.CanDrop = CanDrop.Checked;
        }
        private void CanStore_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.CanStore = CanStore.Checked;
        }
        private void CanRepair_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.CanRepair = CanRepair.Checked;
        }
        private void CanSell_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.CanSell = CanSell.Checked;
        }
        private void CanBreak_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.CanBreak = CanBreak.Checked;
        }
        private void CanSRepair_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.CanSRepair = CanSRepair.Checked;
        }
        private void CanGem_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.CanGem = CanGem.Checked;
        }
        private void CanOrb_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.CanOrb = CanOrb.Checked;
        }
        private void CanDDrop_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.CanDDrop = CanDDrop.Checked;
        }
        private void CanStack_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.CanStack = CanStack.Checked;
        }
        private void Stuck_CheckedChanged(object sender, EventArgs e)
        {
            CurrentItem.Restrictions.Stuck = Stuck.Checked;
        }
        private void DC2_TextChanged(object sender, EventArgs e)
        {

            if (short.TryParse(DC2.Text, out CurrentItem.Stats.Basic.DC2))
                DC2.BackColor = Color.Green;
            else
                DC2.BackColor = Color.Red;
        }
        private void MC2_TextChanged(object sender, EventArgs e)
        {
            if (short.TryParse(MC2.Text, out CurrentItem.Stats.Basic.MC2))
                MC2.BackColor = Color.Green;
            else
                MC2.BackColor = Color.Red;

        }
        private void SC2_TextChanged(object sender, EventArgs e)
        {

            if (short.TryParse(SC2.Text, out CurrentItem.Stats.Basic.SC2))
                SC2.BackColor = Color.Green;
            else
                SC2.BackColor = Color.Red;
        }        
        private void Agility_TextChanged(object sender, EventArgs e)
        {

            if (short.TryParse(Agility.Text, out CurrentItem.Stats.Basic.Agility))
                Agility.BackColor = Color.Green;
            else
                Agility.BackColor = Color.Red;
        }
        private void SC_TextChanged(object sender, EventArgs e)
        {
            if (short.TryParse(SC.Text, out CurrentItem.Stats.Basic.SC))
                SC.BackColor = Color.Green;
            else
                SC.BackColor = Color.Red;

        }        
        private void MC_TextChanged(object sender, EventArgs e)
        {
            if (short.TryParse(MC.Text, out CurrentItem.Stats.Basic.MC))
                MC.BackColor = Color.Green;
            else
                MC.BackColor = Color.Red;

        }
        private void DC_TextChanged(object sender, EventArgs e)
        {
            if (short.TryParse(DC.Text, out CurrentItem.Stats.Basic.DC))
                DC.BackColor = Color.Green;
            else
                DC.BackColor = Color.Red;

        }
        private void MP_TextChanged(object sender, EventArgs e)
        {
            if (int.TryParse(MP.Text, out CurrentItem.Stats.Basic.MP))
                MP.BackColor = Color.Green;
            else
                MP.BackColor = Color.Red;

        }
        private void AC2_TextChanged(object sender, EventArgs e)
        {
            if (short.TryParse(AC2.Text, out CurrentItem.Stats.Basic.AC2))
                AC2.BackColor = Color.Green;
            else
                AC2.BackColor = Color.Red;

        }
        private void MAC2_TextChanged(object sender, EventArgs e)
        {
            if (short.TryParse(MAC2.Text, out CurrentItem.Stats.Basic.MAC2))
                MAC2.BackColor = Color.Green;
            else
                MAC2.BackColor = Color.Red;

        }
        private void Accuracy_TextChanged(object sender, EventArgs e)
        {
            if (short.TryParse(Accuracy.Text, out CurrentItem.Stats.Basic.Accuracy))
                Accuracy.BackColor = Color.Green;
            else
                Accuracy.BackColor = Color.Red;

        }
        private void HP_TextChanged(object sender, EventArgs e)
        {
            if (int.TryParse(HP.Text, out CurrentItem.Stats.Basic.HP))
                HP.BackColor = Color.Green;
            else
                HP.BackColor = Color.Red;

        }
        private void AC_TextChanged(object sender, EventArgs e)
        {
            if (short.TryParse(AC.Text, out CurrentItem.Stats.Basic.AC))
                AC.BackColor = Color.Green;
            else
                AC.BackColor = Color.Red;

        }
        private void MAC_TextChanged(object sender, EventArgs e)
        {
            if (short.TryParse(MAC.Text, out CurrentItem.Stats.Basic.MAC))
                MAC.BackColor = Color.Green;
            else
                MAC.BackColor = Color.Red;

        }
        private void DefRefineCount_TextChanged(object sender, EventArgs e)
        {
            if (int.TryParse(DefRefineCount.Text, out CurrentItem.DefaultRefineCount))
                DefRefineCount.BackColor = Color.Green;
            else
                DefRefineCount.BackColor = Color.Red;
        }
        private void FireA_TextChanged(object sender, EventArgs e)
        {
            if (sbyte.TryParse(FireA.Text, out CurrentItem.Stats.Elemental.FireA))
                FireA.BackColor = Color.Green;
            else
                FireA.BackColor = Color.Red;
        }
        private void LightningA_TextChanged(object sender, EventArgs e)
        {
            if (sbyte.TryParse(LightningA.Text, out CurrentItem.Stats.Elemental.LightningA))
                LightningA.BackColor = Color.Green;
            else
                LightningA.BackColor = Color.Red;

        }
        private void IceA_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(IceA.Text, out CurrentItem.Stats.Elemental.IceA))
                IceA.BackColor = Color.Green;
            else
                IceA.BackColor = Color.Red;
        }
        private void WindA_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(WindA.Text, out CurrentItem.Stats.Elemental.WindA))
                WindA.BackColor = Color.Green;
            else
                WindA.BackColor = Color.Red;
        }
        private void DarkA_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(DarkA.Text, out CurrentItem.Stats.Elemental.DarkA))
                DarkA.BackColor = Color.Green;
            else
                DarkA.BackColor = Color.Red;
        }        
        private void HolyA_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(HolyA.Text, out CurrentItem.Stats.Elemental.HolyA))
                HolyA.BackColor = Color.Green;
            else
                HolyA.BackColor = Color.Red;
        }
        private void IllusionA_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(IllusionA.Text, out CurrentItem.Stats.Elemental.IllusionA))
                IllusionA.BackColor = Color.Green;
            else
                IllusionA.BackColor = Color.Red;
        }
        private void IllusionD_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(IllusionD.Text, out CurrentItem.Stats.Elemental.IllusionD))
                IllusionD.BackColor = Color.Green;
            else
                IllusionD.BackColor = Color.Red;
        }
        private void HolyD_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(HolyD.Text, out CurrentItem.Stats.Elemental.HolyD))
                HolyD.BackColor = Color.Green;
            else
                HolyD.BackColor = Color.Red;
        }
        private void DarkD_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(DarkD.Text, out CurrentItem.Stats.Elemental.DarkD))
                DarkD.BackColor = Color.Green;
            else
                DarkD.BackColor = Color.Red;
        }        
        private void WindD_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(WindD.Text, out CurrentItem.Stats.Elemental.WindD))
                WindD.BackColor = Color.Green;
            else
                WindD.BackColor = Color.Red;
        }
        private void IceD_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(IceD.Text, out CurrentItem.Stats.Elemental.IceD))
                IceD.BackColor = Color.Green;
            else
                IceD.BackColor = Color.Red;
        }
        private void LightningD_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(LightningD.Text, out CurrentItem.Stats.Elemental.LightningD))
                LightningD.BackColor = Color.Green;
            else
                LightningD.BackColor = Color.Red;
        }
        private void FireD_TextChanged(object sender, EventArgs e)
        {
            if (sbyte.TryParse(FireD.Text, out CurrentItem.Stats.Elemental.FireD))
                FireD.BackColor = Color.Green;
            else
                FireD.BackColor = Color.Red;
        }
        private void ASpeed_TextChanged(object sender, EventArgs e)
        {
            if (short.TryParse(ASpeed.Text, out CurrentItem.Stats.Advanced.ASpeed))
                ASpeed.BackColor = Color.Green;
            else
                ASpeed.BackColor = Color.Red;
        }
        private void Luck_TextChanged(object sender, EventArgs e)
        {
            if (sbyte.TryParse(Luck.Text, out CurrentItem.Stats.Advanced.Luck))
                Luck.BackColor = Color.Green;
            else
                Luck.BackColor = Color.Red;
        }
        private void Light_TextChanged(object sender, EventArgs e)
        {
            if (sbyte.TryParse(Light.Text, out CurrentItem.Stats.Advanced.Light))
                Light.BackColor = Color.Green;
            else
                Light.BackColor = Color.Red;
        }
        private void MR_TextChanged(object sender, EventArgs e)
        {
            if (sbyte.TryParse(MR.Text, out CurrentItem.Stats.Advanced.MR))
                MR.BackColor = Color.Green;
            else
                MR.BackColor = Color.Red;
        }
        private void PR_TextChanged(object sender, EventArgs e)
        {
            if (sbyte.TryParse(PR.Text, out CurrentItem.Stats.Advanced.PR))
                PR.BackColor = Color.Green;
            else
                PR.BackColor = Color.Red;
        }        
        private void CR_TextChanged(object sender, EventArgs e)
        {
            if (sbyte.TryParse(CR.Text, out CurrentItem.Stats.Advanced.CR))
                CR.BackColor = Color.Green;
            else
                CR.BackColor = Color.Red;
        }
        private void PA_TextChanged(object sender, EventArgs e)
        {
            if (sbyte.TryParse(PA.Text, out CurrentItem.Stats.Advanced.PA))
                PA.BackColor = Color.Green;
            else
                PA.BackColor = Color.Red;
        }
        private void CA_TextChanged(object sender, EventArgs e)
        {
            if (sbyte.TryParse(CA.Text, out CurrentItem.Stats.Advanced.CA))
                CA.BackColor = Color.Green;
            else
                CA.BackColor = Color.Red;
        }
        private void DeleteItem_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure you want to remove this item?", "Remove Item", MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.Yes)
            {
                ItemInfo DelItem = CurrentItem;
                Main.SData.ItemList.Remove(DelItem);
                ItemListBox.Items.Remove(DelItem);
                for (int I = 0; I < Main.SData.ItemList.Count; I++)
                    Main.SData.ItemList[I].Index = I;
                ItemListBox.Items.Clear();
                ItemListBox.Items.AddRange(Main.SData.ItemList.ToArray());

                foreach (MonsterInfo M in Main.SData.MonsterList)
                    for (int I = M.DropList.Count - 1; I >= 0; I--)
                    {
                        if (M.DropList[I].Item == DelItem)
                            M.DropList.RemoveAt(I);
                    }
                
            }
        }
        private void SaveItem_Click(object sender, EventArgs e)
        {
            if (!Directory.Exists(@".\Data\")) Directory.CreateDirectory(@".\Data\");
            BinaryFormatter BF = new BinaryFormatter();
            using (FileStream FStream = new FileStream(@".\Data\Data.CL", FileMode.Create))
                BF.Serialize(FStream, Main.SData);
            
        }
        private void ItemForm_Load(object sender, EventArgs e)
        {
            ItemListBox.Items.AddRange(Main.SData.ItemList.ToArray());
            ReqType.Items.AddRange(Enum.GetNames(typeof(Clash_Library.Requirement)));
            ReqGender.Items.AddRange(Enum.GetNames(typeof(Clash_Library.ReqGender)));
            ReqClass.Items.AddRange(Enum.GetNames(typeof(Clash_Library.ReqClass)));
            ItemType.Items.AddRange(Enum.GetNames(typeof(Clash_Library.ItemType)));
            SpecialEffect.Items.AddRange(Enum.GetNames(typeof(Clash_Library.SpecialEffect)));
            Rarity.Items.AddRange(Enum.GetNames(typeof(Clash_Library.Rarity)));
        }
        private void newItemDataToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are your sure you want to make a new Item List?", "New Item List ", MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.Yes)
            {
                Main.SData.ItemList = new List<ItemInfo>();
                ItemListBox.Items.Clear();
            }
        }
        private void saveItemDataToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string[] Lines = File.ReadAllLines(@"D:\Test.txt");
            foreach (string S in Lines)
            {
                CurrentItem = new ItemInfo();
                string[] Line = S.Split('	');
                if (!string.IsNullOrEmpty(Line[0])) CurrentItem.Index = int.Parse(Line[0]);
                if (!string.IsNullOrEmpty(Line[1])) CurrentItem.Name = Line[1];
                if (!string.IsNullOrEmpty(Line[2])) CurrentItem.Type = (ItemType)short.Parse(Line[2]);
                if (!string.IsNullOrEmpty(Line[3])) CurrentItem.Weight = byte.Parse(Line[3]);
                if (!string.IsNullOrEmpty(Line[4])) CurrentItem.Image = int.Parse(Line[4]);
                if (!string.IsNullOrEmpty(Line[5])) CurrentItem.Shape = byte.Parse(Line[5]);
                if (!string.IsNullOrEmpty(Line[6])) CurrentItem.Durability = long.Parse(Line[6]);
                if (!string.IsNullOrEmpty(Line[7])) CurrentItem.Stats.Basic.AC = short.Parse(Line[7]);
                if (!string.IsNullOrEmpty(Line[8])) CurrentItem.Stats.Basic.AC2 = short.Parse(Line[8]);
                if (!string.IsNullOrEmpty(Line[9])) CurrentItem.Stats.Basic.MAC = short.Parse(Line[9]);
                if (!string.IsNullOrEmpty(Line[10])) CurrentItem.Stats.Basic.MAC2 = short.Parse(Line[10]);
                if (!string.IsNullOrEmpty(Line[11])) CurrentItem.Stats.Basic.DC = short.Parse(Line[11]);
                if (!string.IsNullOrEmpty(Line[12])) CurrentItem.Stats.Basic.DC2 = short.Parse(Line[12]);
                if (!string.IsNullOrEmpty(Line[13])) CurrentItem.Stats.Basic.MC = short.Parse(Line[13]);
                if (!string.IsNullOrEmpty(Line[14])) CurrentItem.Stats.Basic.MC2 = short.Parse(Line[14]);
                if (!string.IsNullOrEmpty(Line[15])) CurrentItem.Stats.Basic.SC = short.Parse(Line[15]);
                if (!string.IsNullOrEmpty(Line[16])) CurrentItem.Stats.Basic.SC2 = short.Parse(Line[16]);
                if (!string.IsNullOrEmpty(Line[17])) CurrentItem.ReqType = (Requirement)Enum.Parse(typeof(Requirement), Line[17]);
                if (!string.IsNullOrEmpty(Line[18])) CurrentItem.ReqAmount = int.Parse(Line[18]);
                if (!string.IsNullOrEmpty(Line[19])) CurrentItem.Price = long.Parse(Line[19]);

                if (!string.IsNullOrEmpty(Line[20])) CurrentItem.Stats.Basic.HP = int.Parse(Line[20]);
                if (!string.IsNullOrEmpty(Line[21])) CurrentItem.Stats.Basic.MP = int.Parse(Line[21]);
                if (!string.IsNullOrEmpty(Line[22])) CurrentItem.Stats.Advanced.CA = sbyte.Parse(Line[22]);
                if (!string.IsNullOrEmpty(Line[23])) CurrentItem.Stats.Advanced.PA = sbyte.Parse(Line[23]);
                if (!string.IsNullOrEmpty(Line[24])) CurrentItem.Stats.Advanced.ASpeed = short.Parse(Line[24]);
                if (!string.IsNullOrEmpty(Line[25])) CurrentItem.Stats.Basic.Accuracy = short.Parse(Line[25]);
                if (!string.IsNullOrEmpty(Line[26])) CurrentItem.Stats.Basic.Agility = short.Parse(Line[26]);

                if (!string.IsNullOrEmpty(Line[28])) CurrentItem.Stats.Advanced.PR = sbyte.Parse(Line[28]);
                if (!string.IsNullOrEmpty(Line[29])) CurrentItem.Stats.Advanced.MR = sbyte.Parse(Line[29]);
                if (!string.IsNullOrEmpty(Line[30])) CurrentItem.Stats.Advanced.CR = sbyte.Parse(Line[30]);
                if (!string.IsNullOrEmpty(Line[31])) CurrentItem.Stats.Advanced.Light = sbyte.Parse(Line[31]);

                if (!string.IsNullOrEmpty(Line[32])) CurrentItem.Restrictions.CanTrade = bool.Parse(Line[32]);
                if (!string.IsNullOrEmpty(Line[33])) CurrentItem.Restrictions.CanDrop = bool.Parse(Line[33]);
                if (!string.IsNullOrEmpty(Line[34])) CurrentItem.Restrictions.CanStore = bool.Parse(Line[34]);
                if (!string.IsNullOrEmpty(Line[35])) CurrentItem.Restrictions.CanDDrop = bool.Parse(Line[35]);
                if (!string.IsNullOrEmpty(Line[36])) CurrentItem.Restrictions.CanBreak = bool.Parse(Line[36]);
                if (!string.IsNullOrEmpty(Line[37])) CurrentItem.Restrictions.CanSell = bool.Parse(Line[37]);
                if (!string.IsNullOrEmpty(Line[38])) CurrentItem.Restrictions.CanRepair = bool.Parse(Line[38]);
                if (!string.IsNullOrEmpty(Line[39])) CurrentItem.Restrictions.CanSRepair = bool.Parse(Line[39]);
                if (!string.IsNullOrEmpty(Line[40])) CurrentItem.Restrictions.Stuck = bool.Parse(Line[40]);
                if (!string.IsNullOrEmpty(Line[41])) CurrentItem.Restrictions.CanGem = bool.Parse(Line[41]);
                if (!string.IsNullOrEmpty(Line[42])) CurrentItem.Restrictions.CanOrb = bool.Parse(Line[42]);

                if (!string.IsNullOrEmpty(Line[44])) CurrentItem.Stats.Advanced.Luck = sbyte.Parse(Line[44]);

                if (!string.IsNullOrEmpty(Line[45])) CurrentItem.Stats.Elemental.FireA = sbyte.Parse(Line[45]);
                if (!string.IsNullOrEmpty(Line[46])) CurrentItem.Stats.Elemental.LightningA = sbyte.Parse(Line[46]);
                if (!string.IsNullOrEmpty(Line[47])) CurrentItem.Stats.Elemental.IceA = sbyte.Parse(Line[47]);
                if (!string.IsNullOrEmpty(Line[48])) CurrentItem.Stats.Elemental.WindA = sbyte.Parse(Line[48]);
                if (!string.IsNullOrEmpty(Line[49])) CurrentItem.Stats.Elemental.HolyA = sbyte.Parse(Line[49]);
                if (!string.IsNullOrEmpty(Line[50])) CurrentItem.Stats.Elemental.DarkA = sbyte.Parse(Line[50]);
                if (!string.IsNullOrEmpty(Line[51])) CurrentItem.Stats.Elemental.IllusionA = sbyte.Parse(Line[51]);

                if (!string.IsNullOrEmpty(Line[52])) CurrentItem.Stats.Elemental.FireD = sbyte.Parse(Line[52]);
                if (!string.IsNullOrEmpty(Line[53])) CurrentItem.Stats.Elemental.LightningD = sbyte.Parse(Line[53]);
                if (!string.IsNullOrEmpty(Line[54])) CurrentItem.Stats.Elemental.IceD = sbyte.Parse(Line[54]);
                if (!string.IsNullOrEmpty(Line[55])) CurrentItem.Stats.Elemental.WindD = sbyte.Parse(Line[55]);
                if (!string.IsNullOrEmpty(Line[56])) CurrentItem.Stats.Elemental.HolyD = sbyte.Parse(Line[56]);
                if (!string.IsNullOrEmpty(Line[57])) CurrentItem.Stats.Elemental.DarkD = sbyte.Parse(Line[57]);
                if (!string.IsNullOrEmpty(Line[58])) CurrentItem.Stats.Elemental.IllusionD = sbyte.Parse(Line[58]);




                Main.SData.ItemList.Add(CurrentItem);
                ItemListBox.Items.Add(CurrentItem);
            }
        }
        private void SpecialEffect_ItemCheck(object sender, ItemCheckEventArgs e)
        {

            if (e.NewValue == CheckState.Checked)
                CurrentItem.Effect += (int)Enum.GetValues(typeof(Clash_Library.SpecialEffect)).GetValue(e.Index);
            else
                CurrentItem.Effect -= (int)Enum.GetValues(typeof(Clash_Library.SpecialEffect)).GetValue(e.Index);
        }

        private void DropCount_TextChanged(object sender, EventArgs e)
        {
            if (int.TryParse(DropCount.Text, out CurrentItem.ExistCount))
                DropCount.BackColor = Color.Green;
            else
                DropCount.BackColor = Color.Red;
        }

        private void ItemForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void HandWeight_TextChanged(object sender, EventArgs e)
        {
            if (sbyte.TryParse(HandWeight.Text, out CurrentItem.HandWeight))
                HandWeight.BackColor = Color.Green;
            else
                HandWeight.BackColor = Color.Red;
        }

        private void BagWeight_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(BagWeight.Text, out CurrentItem.BagWeight))
                BagWeight.BackColor = Color.Green;
            else
                BagWeight.BackColor = Color.Red;
        }

        private void BodyWeight_TextChanged(object sender, EventArgs e)
        {

            if (sbyte.TryParse(BodyWeight.Text, out CurrentItem.BodyWeight))
                BodyWeight.BackColor = Color.Green;
            else
                BodyWeight.BackColor = Color.Red;
        }

        private void Exp_DoubleClick(object sender, EventArgs e)
        {
            for (int I = 0; I < CurrentItem.ExpList.Count; I++)
            {
                if (CurrentItem.ExpList[I] == 0) CurrentItem.ExpList[I] = int.Parse(Exp.Text);
            }
            ExpList.Items.Clear();
            foreach (long L in CurrentItem.ExpList)
                ExpList.Items.Add(L);
        }

        private void FloorImage_TextChanged(object sender, EventArgs e)
        {
            if (int.TryParse(FloorImage.Text, out CurrentItem.FloorImage))
                FloorImage.BackColor = Color.Green;
            else
                FloorImage.BackColor = Color.Red;
        }

        private void BodyImage_TextChanged(object sender, EventArgs e)
        {
            if (int.TryParse(BodyImage.Text, out CurrentItem.BodyImage))
                BodyImage.BackColor = Color.Green;
            else
                BodyImage.BackColor = Color.Red;
        }



    }
}
