﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Windows.Forms;
using Clash_Library;

namespace ClashManager
{
    public partial class Main : Form
    {
        public static ServerData SData = new ServerData();
        ItemForm ItemF = new ItemForm();
        MapForm MapF = new MapForm();
        MonsterForm MonsterF = new MonsterForm();

        public Main()
        {
            try
            {
                InitializeComponent();

                if (File.Exists(@".\Data\Data.CL"))
                    using (FileStream FStream = new FileStream(@".\Data\Data.CL", FileMode.Open))
                        SData = (ServerData)new BinaryFormatter().Deserialize(FStream);


                MapF.MdiParent = this;
                ItemF.MdiParent = this;
                MonsterF.MdiParent = this;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void item_Click(object sender, EventArgs e)
        {
            ItemF.Show();
        }

        private void map_Click(object sender, EventArgs e)
        {
            MapF.Show();
        }

        private void monster_Click(object sender, EventArgs e)
        {
            MonsterF.Show();
        }

        private void Main_FormClosing(object sender, FormClosingEventArgs e)
        {
            switch (MessageBox.Show("Do you want to save the Data?", "Save Data", MessageBoxButtons.YesNoCancel))
            {
                case System.Windows.Forms.DialogResult.Yes:
                    if (!Directory.Exists(@".\Data\")) Directory.CreateDirectory(@".\Data\");
                    BinaryFormatter BF = new BinaryFormatter();
                    using (FileStream FStream = new FileStream(@".\Data\Data.CL", FileMode.Create))
                        BF.Serialize(FStream, Main.SData);
                    break;
                case System.Windows.Forms.DialogResult.No:
                    break;
                case System.Windows.Forms.DialogResult.Cancel:
                    e.Cancel = true;
                    break;
            }
        }
    }
}
