﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Windows.Forms;

namespace LevelMaker
{
    public partial class Main : Form
    {
        Settings SForm;
        Navigate NForm;
        public static string FileName;

        public static Level CurrentLevel;

        public Main()
        {
            InitializeComponent();
            Graphics.Create(DXContainer);
            CurrentLevel = null;
            DXDawTimer.Enabled = true;
            SForm = new Settings();
            NForm = new Navigate();
        }

        private void DXDawTimer_Tick(object sender, EventArgs e)
        {
            if (CurrentLevel == null)
            {
                Graphics.D.Clear(Microsoft.DirectX.Direct3D.ClearFlags.Target, Color.Black, 0, 0);
                Graphics.D.BeginScene();
                Graphics.S.Begin(Microsoft.DirectX.Direct3D.SpriteFlags.AlphaBlend);
                Graphics.DXNormalFont.DrawText(
                    Graphics.S,
                    "No Map Opened",
                    new Rectangle(0, 0, 800, 600),
                    Microsoft.DirectX.Direct3D.DrawTextFormat.Center |
                    Microsoft.DirectX.Direct3D.DrawTextFormat.VerticalCenter,
                    Color.White);
                Graphics.S.End();
                Graphics.D.EndScene();
                Graphics.D.Present();
                return;
            }

            Graphics.D.Clear(Microsoft.DirectX.Direct3D.ClearFlags.Target, CurrentLevel.ClearColour, 0, 0);

            Graphics.D.Present();
        }

        private void settingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SForm.Show();
        }

        private void navigateToolStripMenuItem_Click(object sender, EventArgs e)
        {
            NForm.Show();
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (SaveDialog.ShowDialog() == DialogResult.OK)
            {
                CurrentLevel = new Level();
                FileName = SaveDialog.FileName;
                if (FileName != null)
                    using (FileStream FStream = new FileStream(FileName, FileMode.Create))
                        new BinaryFormatter().Serialize(FStream, CurrentLevel);
                NForm.UpdateI();
                SForm.UpdateI();
            }
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (OpenDialog.ShowDialog() == DialogResult.OK)
            {
                FileName = OpenDialog.FileName;
                try
                {
                    using (FileStream FStream = new FileStream(FileName, FileMode.Open))
                        CurrentLevel = (Level)new BinaryFormatter().Deserialize(FStream);
                    NForm.UpdateI();
                    SForm.UpdateI();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }

            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (FileName != null)
                using (FileStream FStream = new FileStream(FileName, FileMode.Create))
                    new BinaryFormatter().Serialize(FStream, CurrentLevel);
            NForm.UpdateI();
            SForm.UpdateI();
        }

        private void saveAsMenuItem1_Click(object sender, EventArgs e)
        {
            if (SaveDialog.ShowDialog() == DialogResult.OK)
            {
                FileName = SaveDialog.FileName;
                if (FileName != null)
                    using (FileStream FStream = new FileStream(FileName, FileMode.Create))
                        new BinaryFormatter().Serialize(FStream, CurrentLevel);
                NForm.UpdateI();
                SForm.UpdateI();
            }
        }
    }
}
