﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace LevelMaker
{
    public partial class Settings : Form
    {
        public Settings()
        {
            InitializeComponent();
            UpdateI();
        }

        private void SCount_ValueChanged(object sender, EventArgs e)
        {
            Main.CurrentLevel.ScreenCount = (int)SCount.Value;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (ColorDialog.ShowDialog() == DialogResult.OK)
            {
                Main.CurrentLevel.ClearColour = ColorDialog.Color;
                UpdateI();
            }
        }

        private void Settings_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (Visible)
            {
                Visible = false;
                e.Cancel = true;
            }
        }

        public void UpdateI()
        {
            if (Main.CurrentLevel == null)
            {
                SCount.Text = "0";
                SCount.Enabled = false;
                button1.Enabled = false;
                return;
            }

            SCount.Enabled = true;
            button1.Enabled = true;
        
            panel1.BackColor = Main.CurrentLevel.ClearColour;
            SCount.Value = Main.CurrentLevel.ScreenCount;
        }
    }
}
