﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Clash_Library;

namespace Mir_Manager
{
    public partial class Item_Form : Form
    {
        public static bool Selecting;
        CurrencyManager Manager;

        public Item_Form()
        {
            InitializeComponent();
            RequiredType.Items.AddRange(Enum.GetNames(typeof(Requirement)));
            RequiredGender.Items.AddRange(Enum.GetNames(typeof(ReqGender)));
            RequiredClass.Items.AddRange(Enum.GetNames(typeof(ReqClass)));
            ItemMode.Items.AddRange(Enum.GetNames(typeof(ItemType)));
            SpecialEffect.Items.AddRange(Enum.GetNames(typeof(SpecialEffect)));
            Rarity.Items.AddRange(Enum.GetNames(typeof(Rarity)));
            Behaviour.Items.AddRange(Enum.GetNames(typeof(ItemBehaviour)));
        }

        public void DataLoaded()
        {
            Manager = (CurrencyManager)BindingContext[Main.SData.ItemList];
            ItemList.DataSource = Main.SData.ItemList;
        }
        public void SortList()
        {
            for (int I = 0; I < Main.SData.ItemList.Count; I++)
                Main.SData.ItemList[I].Index = I;
        }
        public void RefreshLists()
        {
            bool[] SelList = new bool[ItemList.Items.Count];
            for (int X = 0; X < SelList.Length; X++)
                SelList[X] = ItemList.GetSelected(X);

            Manager.Refresh();
            Main.MonsterF.ItemCombo.Items.Clear();
            Main.MonsterF.ItemCombo.Items.AddRange(Main.SData.ItemList.ToArray());
            Main.MonsterF.ItemCombo.SelectedItem = null;
            Main.MonsterF.ItemCombo.Text = "";
            Main.MonsterF.DropManager.Refresh();

            for (int X = 0; X < SelList.Length; X++)
                ItemList.SetSelected(X, SelList[X]);
        }
        public void ClearInterface()
        {
            ItemIndex.Text = "";
            ItemName.Text = "";
            ItemMode.SelectedItem = null;
            ItemMode.Text = "";
            BImage.Text = "";
            CImage.Text = "";
            FImage.Text = "";
            HImage.Text = "";
            Weight.Text = "";
            Durability.Text = "";
            Price.Text = "";
            StackSize.Text = "";
            RequiredType.SelectedItem = null;
            RequiredType.Text = "";
            RequiredAmount.Text = "";
            RequiredClass.ClearSelected();
            RequiredGender.ClearSelected();
            ExistCount.Text = "";
            Rarity.SelectedItem = null;
            Rarity.Text = "";
            SpecialEffect.ClearSelected();
            HP.Text = "";
            MP.Text = "";
            Accuracy.Text = "";
            Agility.Text = "";
            AC.Text = "";
            AC2.Text = "";
            MAC.Text = "";
            MAC2.Text = "";
            DC.Text = "";
            DC2.Text = "";
            MC.Text = "";
            MC2.Text = "";
            SC.Text = "";
            SC2.Text = "";
            AttackSpeed.Text = "";
            Light.Text = "";
            Luck.Text = "";
            MResist.Text = "";
            CResist.Text = "";
            PResist.Text = "";
            PAttack.Text = "";
            CAttack.Text = "";
            FireA.Text = "";
            FireD.Text = "";
            LightningA.Text = "";
            LightningD.Text = "";
            IceA.Text = "";
            IceD.Text = "";
            WindA.Text = "";
            WindD.Text = "";
            HolyA.Text = "";
            HolyD.Text = "";
            DarkA.Text = "";
            DarkD.Text = "";
            IllusionA.Text = "";
            IllusionD.Text = "";
            MaxLevel.Text = "";
            ExpList.Items.Clear();
            Behaviour.ClearSelected();
        }
        public void FillInterface()
        {
            ReqGender G = 0;
            ReqClass C = 0;
            SpecialEffect S = 0;
            ItemBehaviour B = 0;

            bool Checked = false;
            foreach (ItemInfo BI in ItemList.SelectedItems)
            {
                if (ItemIndex.Text == "") ItemIndex.Text = BI.Index.ToString();
                if (ItemIndex.Text != BI.Index.ToString()) ItemIndex.Text = "#####";

                if (ItemName.Text == "") ItemName.Text = BI.Name;
                if (ItemName.Text != BI.Name) ItemName.Text = "#####";

                if (ItemMode.Text == "") ItemMode.Text = BI.Type.ToString();
                if (ItemMode.Text != BI.Type.ToString()) ItemMode.Text = "#####";

                if (BImage.Text == "") BImage.Text = BI.Image.ToString();
                if (BImage.Text != BI.Image.ToString()) BImage.Text = "#####";

                if (CImage.Text == "") CImage.Text = BI.BodyImage.ToString();
                if (CImage.Text != BI.BodyImage.ToString()) CImage.Text = "#####";

                if (HImage.Text == "") HImage.Text = BI.Shape.ToString();
                if (HImage.Text != BI.Shape.ToString()) HImage.Text = "#####";

                if (FImage.Text == "") FImage.Text = BI.FloorImage.ToString();
                if (FImage.Text != BI.FloorImage.ToString()) FImage.Text = "#####";

                if (Weight.Text == "") Weight.Text = BI.Weight.ToString();
                if (Weight.Text != BI.Weight.ToString()) Weight.Text = "#####";

                if (Durability.Text == "") Durability.Text = BI.Durability.ToString();
                if (Durability.Text != BI.Durability.ToString()) Durability.Text = "#####";

                if (Price.Text == "") Price.Text = BI.Price.ToString();
                if (Price.Text != BI.Price.ToString()) Price.Text = "#####";
                
                if (RequiredType.Text == "") RequiredType.Text = BI.ReqType.ToString();
                if (RequiredType.Text != BI.ReqType.ToString()) RequiredType.Text = "#####";

                if (RequiredAmount.Text == "") RequiredAmount.Text = BI.ReqAmount.ToString();
                if (RequiredAmount.Text != BI.ReqAmount.ToString()) RequiredAmount.Text = "#####";

                if (!Checked)
                {
                    C = BI.RequiredClass;

                    for (int I = 0; I < Enum.GetValues(typeof(ReqClass)).Length; I++)
                        if ((C & (ReqClass)Enum.GetValues(typeof(ReqClass)).GetValue(I)) != 0)
                            RequiredClass.SetItemChecked(I, true);
                        else RequiredClass.SetItemChecked(I, false);
                }
                if (C != BI.RequiredClass)
                {
                    for (int I = 0; I < RequiredClass.Items.Count; I++)
                        RequiredClass.SetItemCheckState(I, CheckState.Indeterminate);
                }
                if (!Checked)
                {
                    G = BI.RequiredGender;

                    for (int I = 0; I < Enum.GetValues(typeof(ReqGender)).Length; I++)
                        if ((G & (ReqGender)Enum.GetValues(typeof(ReqGender)).GetValue(I)) != 0)
                            RequiredGender.SetItemChecked(I, true);
                        else RequiredGender.SetItemChecked(I, false);
                }
                if (G != BI.RequiredGender)
                {
                    for (int I = 0; I < RequiredGender.Items.Count; I++)
                        RequiredGender.SetItemCheckState(I, CheckState.Indeterminate);
                }

                if (ExistCount.Text == "") ExistCount.Text = BI.ExistCount.ToString();
                if (ExistCount.Text != BI.ExistCount.ToString()) ExistCount.Text = "#####";

                if (Rarity.Text == "") Rarity.Text = BI.Rarity.ToString();
                if (Rarity.Text != BI.Rarity.ToString()) Rarity.Text = "#####";

                if (!Checked)
                {
                    S = BI.Effect;

                    for (int I = 0; I < Enum.GetValues(typeof(SpecialEffect)).Length; I++)
                        if ((S & (SpecialEffect)Enum.GetValues(typeof(SpecialEffect)).GetValue(I)) != 0)
                            SpecialEffect.SetItemChecked(I, true);
                        else SpecialEffect.SetItemChecked(I, false);
                }

                if (S != BI.Effect)
                {
                    for (int I = 0; I < SpecialEffect.Items.Count; I++)
                        SpecialEffect.SetItemCheckState(I, CheckState.Indeterminate);
                }

                if (HP.Text == "") HP.Text = BI.Stats.Basic.HP.ToString();
                if (HP.Text != BI.Stats.Basic.HP.ToString()) HP.Text = "#####";

                if (MP.Text == "") MP.Text = BI.Stats.Basic.MP.ToString();
                if (MP.Text != BI.Stats.Basic.MP.ToString()) MP.Text = "#####";

                if (Accuracy.Text == "") Accuracy.Text = BI.Stats.Basic.Accuracy.ToString();
                if (Accuracy.Text != BI.Stats.Basic.Accuracy.ToString()) Accuracy.Text = "#####";

                if (Agility.Text == "") Agility.Text = BI.Stats.Basic.Agility.ToString();
                if (Agility.Text != BI.Stats.Basic.Agility.ToString()) Agility.Text = "#####";

                if (AC.Text == "") AC.Text = BI.Stats.Basic.AC.ToString();
                if (AC.Text != BI.Stats.Basic.AC.ToString()) AC.Text = "#####";

                if (AC2.Text == "") AC2.Text = BI.Stats.Basic.AC2.ToString();
                if (AC2.Text != BI.Stats.Basic.AC2.ToString()) AC2.Text = "#####";

                if (MAC.Text == "") MAC.Text = BI.Stats.Basic.MAC.ToString();
                if (MAC.Text != BI.Stats.Basic.MAC.ToString()) MAC.Text = "#####";

                if (MAC2.Text == "") MAC2.Text = BI.Stats.Basic.MAC2.ToString();
                if (MAC2.Text != BI.Stats.Basic.MAC2.ToString()) MAC2.Text = "#####";

                if (DC.Text == "") DC.Text = BI.Stats.Basic.DC.ToString();
                if (DC.Text != BI.Stats.Basic.DC.ToString()) DC.Text = "#####";

                if (DC2.Text == "") DC2.Text = BI.Stats.Basic.DC2.ToString();
                if (DC2.Text != BI.Stats.Basic.DC2.ToString()) DC2.Text = "#####";

                if (MC.Text == "") MC.Text = BI.Stats.Basic.MC.ToString();
                if (MC.Text != BI.Stats.Basic.MC.ToString()) MC.Text = "#####";

                if (MC2.Text == "") MC2.Text = BI.Stats.Basic.MC2.ToString();
                if (MC2.Text != BI.Stats.Basic.MC2.ToString()) MC2.Text = "#####";

                if (SC.Text == "") SC.Text = BI.Stats.Basic.SC.ToString();
                if (SC.Text != BI.Stats.Basic.SC.ToString()) SC.Text = "#####";

                if (SC2.Text == "") SC2.Text = BI.Stats.Basic.SC2.ToString();
                if (SC2.Text != BI.Stats.Basic.SC2.ToString()) SC2.Text = "#####";

                if (AttackSpeed.Text == "") AttackSpeed.Text = BI.Stats.Advanced.ASpeed.ToString();
                if (AttackSpeed.Text != BI.Stats.Advanced.ASpeed.ToString()) AttackSpeed.Text = "#####";

                if (Light.Text == "") Light.Text = BI.Stats.Advanced.Light.ToString();
                if (Light.Text != BI.Stats.Advanced.Light.ToString()) Light.Text = "#####";

                if (Luck.Text == "") Luck.Text = BI.Stats.Advanced.Luck.ToString();
                if (Luck.Text != BI.Stats.Advanced.Luck.ToString()) Luck.Text = "#####";

                if (MResist.Text == "") MResist.Text = BI.Stats.Advanced.MR.ToString();
                if (MResist.Text != BI.Stats.Advanced.MR.ToString()) MResist.Text = "#####";

                if (PResist.Text == "") PResist.Text = BI.Stats.Advanced.PR.ToString();
                if (PResist.Text != BI.Stats.Advanced.PR.ToString()) PResist.Text = "#####";

                if (CResist.Text == "") CResist.Text = BI.Stats.Advanced.CR.ToString();
                if (CResist.Text != BI.Stats.Advanced.CR.ToString()) CResist.Text = "#####";

                if (PAttack.Text == "") PAttack.Text = BI.Stats.Advanced.PA.ToString();
                if (PAttack.Text != BI.Stats.Advanced.PA.ToString()) PAttack.Text = "#####";

                if (CAttack.Text == "") CAttack.Text = BI.Stats.Advanced.CA.ToString();
                if (CAttack.Text != BI.Stats.Advanced.CA.ToString()) CAttack.Text = "#####";

                if (FireA.Text == "") FireA.Text = BI.Stats.Elemental.FireA.ToString();
                if (FireA.Text != BI.Stats.Elemental.FireA.ToString()) FireA.Text = "#####";

                if (FireD.Text == "") FireD.Text = BI.Stats.Elemental.FireD.ToString();
                if (FireD.Text != BI.Stats.Elemental.FireD.ToString()) FireD.Text = "#####";

                if (LightningA.Text == "") LightningA.Text = BI.Stats.Elemental.LightningA.ToString();
                if (LightningA.Text != BI.Stats.Elemental.LightningA.ToString()) LightningA.Text = "#####";

                if (LightningD.Text == "") LightningD.Text = BI.Stats.Elemental.LightningD.ToString();
                if (LightningD.Text != BI.Stats.Elemental.LightningD.ToString()) LightningD.Text = "#####";

                if (IceA.Text == "") IceA.Text = BI.Stats.Elemental.IceA.ToString();
                if (IceA.Text != BI.Stats.Elemental.IceA.ToString()) IceA.Text = "#####";

                if (IceD.Text == "") IceD.Text = BI.Stats.Elemental.IceD.ToString();
                if (IceD.Text != BI.Stats.Elemental.IceD.ToString()) IceD.Text = "#####";

                if (WindA.Text == "") WindA.Text = BI.Stats.Elemental.WindA.ToString();
                if (WindA.Text != BI.Stats.Elemental.WindA.ToString()) WindA.Text = "#####";

                if (WindD.Text == "") WindD.Text = BI.Stats.Elemental.WindD.ToString();
                if (WindD.Text != BI.Stats.Elemental.WindD.ToString()) WindD.Text = "#####";

                if (HolyA.Text == "") HolyA.Text = BI.Stats.Elemental.HolyA.ToString();
                if (HolyA.Text != BI.Stats.Elemental.HolyA.ToString()) HolyA.Text = "#####";

                if (HolyD.Text == "") HolyD.Text = BI.Stats.Elemental.HolyD.ToString();
                if (HolyD.Text != BI.Stats.Elemental.HolyD.ToString()) HolyD.Text = "#####";

                if (DarkA.Text == "") DarkA.Text = BI.Stats.Elemental.DarkA.ToString();
                if (DarkA.Text != BI.Stats.Elemental.DarkA.ToString()) DarkA.Text = "#####";

                if (DarkD.Text == "") DarkD.Text = BI.Stats.Elemental.DarkD.ToString();
                if (DarkD.Text != BI.Stats.Elemental.DarkD.ToString()) DarkD.Text = "#####";

                if (IllusionA.Text == "") IllusionA.Text = BI.Stats.Elemental.IllusionA.ToString();
                if (IllusionA.Text != BI.Stats.Elemental.IllusionA.ToString()) IllusionA.Text = "#####";

                if (IllusionD.Text == "") IllusionD.Text = BI.Stats.Elemental.IllusionD.ToString();
                if (IllusionD.Text != BI.Stats.Elemental.IllusionD.ToString()) IllusionD.Text = "#####";

                if (!Checked)
                {
                    B = BI.Behaviour;

                    for (int I = 0; I < Enum.GetValues(typeof(ItemBehaviour)).Length; I++)
                        if ((B & (ItemBehaviour)Enum.GetValues(typeof(ItemBehaviour)).GetValue(I)) != 0)
                            Behaviour.SetItemChecked(I, true);
                        else Behaviour.SetItemChecked(I, false);
                }

                if (B != BI.Behaviour)
                {
                    for (int I = 0; I < Behaviour.Items.Count; I++)
                        Behaviour.SetItemCheckState(I, CheckState.Indeterminate);
                }

                if (MaxLevel.Text == "") MaxLevel.Text = BI.MaxLevel.ToString();
                if (MaxLevel.Text != BI.MaxLevel.ToString()) MaxLevel.Text = "#####";

                if (ItemList.SelectedItems.Count == 1)
                {
                    foreach (uint I in BI.ExpList)
                        ExpList.Items.Add(I);
                }

                Checked = true;
            }

        }
        private void NewItem_Click(object sender, EventArgs e)
        {
            Main.SData.ItemList.Add(new ItemInfo());
            SortList();
            RefreshLists();
            if (ItemList.SelectedItems.Count == 0)
                tabControl1.Hide();
            else
                tabControl1.Show();
        }
        private void ItemList_SelectedIndexChanged(object sender, EventArgs e)
        {
            Selecting = true;
            ClearInterface();
            FillInterface();
            Selecting = false;
            if (ItemList.SelectedItems.Count == 0)
                tabControl1.Hide();
            else
                tabControl1.Show();
        }
        private void ItemIndex_Leave(object sender, EventArgs e)
        {
            if (ItemIndex.Text == "#####") return;
            if (Selecting) return;
            int I;
            if (int.TryParse(ItemIndex.Text, out I))
            {
                ItemIndex.BackColor = Color.White;
                ItemIndex.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Index = I;

                RefreshLists();
            }
            else
            {
                ItemIndex.BackColor = Color.RosyBrown;
                ItemIndex.ForeColor = Color.White;
            }
        }
        private void ItemName_Leave(object sender, EventArgs e)
        {
            if (ItemName.Text == "#####") return;
            if (Selecting) return;

            if (!string.IsNullOrWhiteSpace(ItemName.Text))
            {
                ItemName.BackColor = Color.White;
                ItemName.ForeColor = Color.Black;
            }
            else
            {
                ItemName.BackColor = Color.RosyBrown;
                ItemName.ForeColor = Color.White;
            }

            foreach (ItemInfo BI in ItemList.SelectedItems)
                BI.Name = ItemName.Text != null ? ItemName.Text : "";

            RefreshLists();
        }
        private void ItemMode_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (ItemMode.Text == "#####") return;
            if (Selecting) return;

            if (!string.IsNullOrEmpty(ItemMode.Text))
            {
                ItemMode.BackColor = Color.White;
                ItemMode.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Type = (ItemType)Enum.Parse(typeof(ItemType), ItemMode.Text);
            }
            else
            {
                ItemMode.BackColor = Color.RosyBrown;
                ItemMode.ForeColor = Color.White;
            }
        }
        private void BImage_TextChanged(object sender, EventArgs e)
        {
            if (BImage.Text == "#####") return;
            if (Selecting) return;
            ushort I;
            if (ushort.TryParse(BImage.Text, out I))
            {
                BImage.BackColor = Color.White;
                BImage.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Image = I;
            }
            else
            {
                BImage.BackColor = Color.RosyBrown;
                BImage.ForeColor = Color.White;
            }
        }
        private void CImage_TextChanged(object sender, EventArgs e)
        {
            if (CImage.Text == "#####") return;
            if (Selecting) return;
            ushort I;
            if (ushort.TryParse(CImage.Text, out I))
            {
                CImage.BackColor = Color.White;
                CImage.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.BodyImage = I;
            }
            else
            {
                CImage.BackColor = Color.RosyBrown;
                CImage.ForeColor = Color.White;
            }
        }
        private void FImage_TextChanged(object sender, EventArgs e)
        {

            if (FImage.Text == "#####") return;
            if (Selecting) return;
            ushort I;
            if (ushort.TryParse(FImage.Text, out I))
            {
                FImage.BackColor = Color.White;
                FImage.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.FloorImage = I;
            }
            else
            {
                FImage.BackColor = Color.RosyBrown;
                FImage.ForeColor = Color.White;
            }
        }
        private void HImage_TextChanged(object sender, EventArgs e)
        {

            if (HImage.Text == "#####") return;
            if (Selecting) return;
            byte I;
            if (byte.TryParse(HImage.Text, out I))
            {
                HImage.BackColor = Color.White;
                HImage.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Shape = I;
            }
            else
            {
                HImage.BackColor = Color.RosyBrown;
                HImage.ForeColor = Color.White;
            }
        }
        private void Weight_TextChanged(object sender, EventArgs e)
        {
            if (Weight.Text == "#####") return;
            if (Selecting) return;
            byte I;
            if (byte.TryParse(Weight.Text, out I))
            {
                Weight.BackColor = Color.White;
                Weight.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Weight = I;
            }
            else
            {
                Weight.BackColor = Color.RosyBrown;
                Weight.ForeColor = Color.White;
            }
        }
        private void Durability_TextChanged(object sender, EventArgs e)
        {
            if (Durability.Text == "#####") return;
            if (Selecting) return;
            uint I;
            if (uint.TryParse(Durability.Text, out I))
            {
                Durability.BackColor = Color.White;
                Durability.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Durability = I;
            }
            else
            {
                Durability.BackColor = Color.RosyBrown;
                Durability.ForeColor = Color.White;
            }
        }
        private void Price_TextChanged(object sender, EventArgs e)
        {
            if (Price.Text == "#####") return;
            if (Selecting) return;
            uint I;
            if (uint.TryParse(Price.Text, out I))
            {
                Price.BackColor = Color.White;
                Price.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Price = I;
            }
            else
            {
                Price.BackColor = Color.RosyBrown;
                Price.ForeColor = Color.White;
            }
        }
        private void RequiredAmount_TextChanged(object sender, EventArgs e)
        {
            if (RequiredAmount.Text == "#####") return;
            if (Selecting) return;
            int I;
            if (int.TryParse(RequiredAmount.Text, out I))
            {
                RequiredAmount.BackColor = Color.White;
                RequiredAmount.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.ReqAmount = I;
            }
            else
            {
                RequiredAmount.BackColor = Color.RosyBrown;
                RequiredAmount.ForeColor = Color.White;
            }
        }
        private void ExistCount_TextChanged(object sender, EventArgs e)
        {
            if (ExistCount.Text == "#####") return;
            if (Selecting) return;
            int I;
            if (int.TryParse(ExistCount.Text, out I))
            {
                ExistCount.BackColor = Color.White;
                ExistCount.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.ExistCount = I;
            }
            else
            {
                ExistCount.BackColor = Color.RosyBrown;
                ExistCount.ForeColor = Color.White;
            }
        }
        private void RequiredType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (RequiredType.Text == "#####") return;
            if (Selecting) return;

            if (!string.IsNullOrEmpty(RequiredType.Text))
            {
                RequiredType.BackColor = Color.White;
                RequiredType.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.ReqType = (Requirement)Enum.Parse(typeof(Requirement), RequiredType.Text);
            }
            else
            {
                RequiredType.BackColor = Color.RosyBrown;
                RequiredType.ForeColor = Color.White;
            }
        }        
        private void Rarity_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (Rarity.Text == "#####") return;
            if (Selecting) return;

            if (!string.IsNullOrEmpty(Rarity.Text))
            {
                Rarity.BackColor = Color.White;
                Rarity.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Rarity = (Rarity)Enum.Parse(typeof(Rarity), Rarity.Text);
            }
            else
            {
                Rarity.BackColor = Color.RosyBrown;
                Rarity.ForeColor = Color.White;
            }
        }
        private void ResetRarity_Click(object sender, EventArgs e)
        {
            foreach (ItemInfo BI in ItemList.SelectedItems)
            {
                BI.ExistCount = 0;
                BI.Rarity = Clash_Library.Rarity.Junk;
            }

            Selecting = true;
            ClearInterface();
            FillInterface();
            Selecting = false;
        }
        private void RequiredClass_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if (Selecting) return;

            foreach (ItemInfo BI in ItemList.SelectedItems)
                if (e.NewValue == CheckState.Checked)
                {
                    if (!BI.RequiredClass.HasFlag((ReqClass)Enum.GetValues(typeof(ReqClass)).GetValue(e.Index)))
                        BI.RequiredClass += (int)Enum.GetValues(typeof(ReqClass)).GetValue(e.Index);
                }
                else if (BI.RequiredClass.HasFlag((ReqClass)Enum.GetValues(typeof(ReqClass)).GetValue(e.Index)))
                    BI.RequiredClass -= (int)Enum.GetValues(typeof(ReqClass)).GetValue(e.Index);
        }
        private void RequiredGender_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if (Selecting) return;

            foreach (ItemInfo BI in ItemList.SelectedItems)
                if (e.NewValue == CheckState.Checked)
                {
                    if (!BI.RequiredGender.HasFlag((ReqGender)Enum.GetValues(typeof(ReqGender)).GetValue(e.Index)))
                        BI.RequiredGender += (int)Enum.GetValues(typeof(ReqGender)).GetValue(e.Index);
                }
                else if (BI.RequiredGender.HasFlag((ReqGender)Enum.GetValues(typeof(ReqGender)).GetValue(e.Index)))
                    BI.RequiredGender -= (int)Enum.GetValues(typeof(ReqGender)).GetValue(e.Index);
        }
        private void SpecialEffect_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if (Selecting) return;

            foreach (ItemInfo BI in ItemList.SelectedItems)
                if (e.NewValue == CheckState.Checked)
                {
                    if (!BI.Effect.HasFlag((SpecialEffect)Enum.GetValues(typeof(SpecialEffect)).GetValue(e.Index)))
                        BI.Effect += (int)Enum.GetValues(typeof(SpecialEffect)).GetValue(e.Index);
                }
                else if (BI.Effect.HasFlag((SpecialEffect)Enum.GetValues(typeof(SpecialEffect)).GetValue(e.Index)))
                    BI.Effect -= (int)Enum.GetValues(typeof(SpecialEffect)).GetValue(e.Index);
        }
        private void StackSize_TextChanged(object sender, EventArgs e)
        {

            if (StackSize.Text == "#####") return;
            if (Selecting) return;
            ushort I;
            if (ushort.TryParse(StackSize.Text, out I))
            {
                StackSize.BackColor = Color.White;
                StackSize.ForeColor = Color.Black;


            }
            else
            {
                StackSize.BackColor = Color.RosyBrown;
                StackSize.ForeColor = Color.White;
            }
        }
        private void DeleteItem_Click(object sender, EventArgs e)
        {
            if (ItemList.SelectedItems.Count == 0) return;

            if (MessageBox.Show("Are you sure you want to delete the selected Item(s)", "Delete Item(s)", MessageBoxButtons.YesNo) == DialogResult.No)
                return;

            foreach (ItemInfo BI in ItemList.SelectedItems)
            {
                Main.SData.ItemList.Remove(BI);
                foreach (MonsterInfo M in Main.SData.MonsterList)
                    for (int I = M.DropList.Count - 1; I >= 0; I--)
                        if (M.DropList[I].Item == BI)
                            M.DropList.RemoveAt(I);
            }

            SortList();
            Manager.Refresh();
            Main.MonsterF.ItemCombo.Items.Clear();
            Main.MonsterF.ItemCombo.Items.AddRange(Main.SData.ItemList.ToArray());
            Main.MonsterF.ItemCombo.SelectedItem = null;
            Main.MonsterF.ItemCombo.Text = "";
            Main.MonsterF.DropManager.Refresh();

            if (ItemList.SelectedItems.Count == 0)
                tabControl1.Hide();
            else
                tabControl1.Show();
        }
        private void HP_TextChanged(object sender, EventArgs e)
        {
            if (HP.Text == "#####") return;
            if (Selecting) return;
            int I;
            if (int.TryParse(HP.Text, out I))
            {
                HP.BackColor = Color.White;
                HP.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.HP = I;
            }
            else
            {
                HP.BackColor = Color.RosyBrown;
                HP.ForeColor = Color.White;
            }
        }        
        private void MP_TextChanged(object sender, EventArgs e)
        {
            if (MP.Text == "#####") return;
            if (Selecting) return;
            int I;
            if (int.TryParse(MP.Text, out I))
            {
                MP.BackColor = Color.White;
                MP.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.MP = I;
            }
            else
            {
                MP.BackColor = Color.RosyBrown;
                MP.ForeColor = Color.White;
            }
        }
        private void Accuracy_TextChanged(object sender, EventArgs e)
        {
            if (Accuracy.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(Accuracy.Text, out I))
            {
                Accuracy.BackColor = Color.White;
                Accuracy.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.Accuracy = I;
            }
            else
            {
                Accuracy.BackColor = Color.RosyBrown;
                Accuracy.ForeColor = Color.White;
            }
        }
        private void Agility_TextChanged(object sender, EventArgs e)
        {
            if (Agility.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(Agility.Text, out I))
            {
                Agility.BackColor = Color.White;
                Agility.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.Agility = I;
            }
            else
            {
                Agility.BackColor = Color.RosyBrown;
                Agility.ForeColor = Color.White;
            }
        }
        private void AC_TextChanged(object sender, EventArgs e)
        {
            if (AC.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(AC.Text, out I))
            {
                AC.BackColor = Color.White;
                AC.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.AC = I;
            }
            else
            {
                AC.BackColor = Color.RosyBrown;
                AC.ForeColor = Color.White;
            }
        }
        private void DC_TextChanged(object sender, EventArgs e)
        {
            if (DC.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(DC.Text, out I))
            {
                DC.BackColor = Color.White;
                DC.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.DC = I;
            }
            else
            {
                DC.BackColor = Color.RosyBrown;
                DC.ForeColor = Color.White;
            }
        }
        private void AC2_TextChanged(object sender, EventArgs e)
        {
            if (AC2.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(AC2.Text, out I))
            {
                AC2.BackColor = Color.White;
                AC2.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.AC2 = I;
            }
            else
            {
                AC2.BackColor = Color.RosyBrown;
                AC2.ForeColor = Color.White;
            }
        }
        private void DC2_TextChanged(object sender, EventArgs e)
        {
            if (DC2.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(DC2.Text, out I))
            {
                DC2.BackColor = Color.White;
                DC2.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.DC2 = I;
            }
            else
            {
                DC2.BackColor = Color.RosyBrown;
                DC2.ForeColor = Color.White;
            }
        }        
        private void MC_TextChanged(object sender, EventArgs e)
        {
            if (MC.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(MC.Text, out I))
            {
                MC.BackColor = Color.White;
                MC.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.MC = I;
            }
            else
            {
                MC.BackColor = Color.RosyBrown;
                MC.ForeColor = Color.White;
            }
        }        
        private void MAC_TextChanged(object sender, EventArgs e)
        {
            if (MAC.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(MAC.Text, out I))
            {
                MAC.BackColor = Color.White;
                MAC.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.MAC = I;
            }
            else
            {
                MAC.BackColor = Color.RosyBrown;
                MAC.ForeColor = Color.White;
            }
        }
        private void MC2_TextChanged(object sender, EventArgs e)
        {
            if (MC2.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(MC2.Text, out I))
            {
                MC2.BackColor = Color.White;
                MC2.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.MC2 = I;
            }
            else
            {
                MC2.BackColor = Color.RosyBrown;
                MC2.ForeColor = Color.White;
            }
        }
        private void MAC2_TextChanged(object sender, EventArgs e)
        {
            if (MAC2.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(MAC2.Text, out I))
            {
                MAC2.BackColor = Color.White;
                MAC2.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.MAC2 = I;
            }
            else
            {
                MAC2.BackColor = Color.RosyBrown;
                MAC2.ForeColor = Color.White;
            }
        }
        private void SC_TextChanged(object sender, EventArgs e)
        {
            if (SC.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(SC.Text, out I))
            {
                SC.BackColor = Color.White;
                SC.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.SC = I;
            }
            else
            {
                SC.BackColor = Color.RosyBrown;
                SC.ForeColor = Color.White;
            }
        }
        private void SC2_TextChanged(object sender, EventArgs e)
        {
            if (SC2.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(SC2.Text, out I))
            {
                SC2.BackColor = Color.White;
                SC2.ForeColor = Color.Black;


                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Basic.SC2 = I;
            }
            else
            {
                SC2.BackColor = Color.RosyBrown;
                SC2.ForeColor = Color.White;
            }
        }
        private void AttackSpeed_TextChanged(object sender, EventArgs e)
        {
            if (AttackSpeed.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(AttackSpeed.Text, out I))
            {
                AttackSpeed.BackColor = Color.White;
                AttackSpeed.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Advanced.ASpeed = I;
            }
            else
            {
                AttackSpeed.BackColor = Color.RosyBrown;
                AttackSpeed.ForeColor = Color.White;
            }
        }
        private void Light_TextChanged(object sender, EventArgs e)
        {
            if (Light.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(Light.Text, out I))
            {
                Light.BackColor = Color.White;
                Light.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Advanced.Light = I;
            }
            else
            {
                Light.BackColor = Color.RosyBrown;
                Light.ForeColor = Color.White;
            }
        }
        private void Luck_TextChanged(object sender, EventArgs e)
        {
            if (Luck.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(Luck.Text, out I))
            {
                Luck.BackColor = Color.White;
                Luck.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Advanced.Luck = I;
            }
            else
            {
                Luck.BackColor = Color.RosyBrown;
                Luck.ForeColor = Color.White;
            }
        }
        private void CResist_TextChanged(object sender, EventArgs e)
        {
            if (CResist.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(CResist.Text, out I))
            {
                CResist.BackColor = Color.White;
                CResist.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Advanced.CR = I;
            }
            else
            {
                CResist.BackColor = Color.RosyBrown;
                CResist.ForeColor = Color.White;
            }
        }
        private void PResist_TextChanged(object sender, EventArgs e)
        {
            if (PResist.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(PResist.Text, out I))
            {
                PResist.BackColor = Color.White;
                PResist.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Advanced.PR = I;
            }
            else
            {
                PResist.BackColor = Color.RosyBrown;
                PResist.ForeColor = Color.White;
            }
        }
        private void CAttack_TextChanged(object sender, EventArgs e)
        {
            if ( CAttack.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse( CAttack.Text, out I))
            {
                 CAttack.BackColor = Color.White;
                 CAttack.ForeColor = Color.Black;

                 foreach (ItemInfo BI in ItemList.SelectedItems)
                     BI.Stats.Advanced.CA = I;
            }
            else
            {
                 CAttack.BackColor = Color.RosyBrown;
                 CAttack.ForeColor = Color.White;
            }
        }
        private void PAttack_TextChanged(object sender, EventArgs e)
        {
            if (PAttack.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(PAttack.Text, out I))
            {
                PAttack.BackColor = Color.White;
                PAttack.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Advanced.PA = I;
            }
            else
            {
                PAttack.BackColor = Color.RosyBrown;
                PAttack.ForeColor = Color.White;
            }
        }
        private void MResist_TextChanged(object sender, EventArgs e)
        {
            if (MResist.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(MResist.Text, out I))
            {
                MResist.BackColor = Color.White;
                MResist.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Advanced.MR = I;
            }
            else
            {
                MResist.BackColor = Color.RosyBrown;
                MResist.ForeColor = Color.White;
            }
        }
        private void FireA_TextChanged(object sender, EventArgs e)
        {
            if (FireA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(FireA.Text, out I))
            {
                FireA.BackColor = Color.White;
                FireA.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental.FireA = I;
            }
            else
            {
                FireA.BackColor = Color.RosyBrown;
                FireA.ForeColor = Color.White;
            }
        }        
        private void FireD_TextChanged(object sender, EventArgs e)
        {
            if (FireD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(FireD.Text, out I))
            {
                FireD.BackColor = Color.White;
                FireD.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental.FireD = I;
            }
            else
            {
                FireD.BackColor = Color.RosyBrown;
                FireD.ForeColor = Color.White;
            }
        }
        private void LightningD_TextChanged(object sender, EventArgs e)
        {
            if ( LightningD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse( LightningD.Text, out I))
            {
                 LightningD.BackColor = Color.White;
                 LightningD.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental. LightningD = I;
            }
            else
            {
                 LightningD.BackColor = Color.RosyBrown;
                 LightningD.ForeColor = Color.White;
            }
        }
        private void LightningA_TextChanged(object sender, EventArgs e)
        {
            if ( LightningA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse( LightningA.Text, out I))
            {
                 LightningA.BackColor = Color.White;
                 LightningA.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental. LightningA = I;
            }
            else
            {
                 LightningA.BackColor = Color.RosyBrown;
                 LightningA.ForeColor = Color.White;
            }
        }
        private void IceA_TextChanged(object sender, EventArgs e)
        {
            if (IceA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(IceA.Text, out I))
            {
                IceA.BackColor = Color.White;
                IceA.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental.IceA = I;
            }
            else
            {
                IceA.BackColor = Color.RosyBrown;
                IceA.ForeColor = Color.White;
            }
        }
        private void WindA_TextChanged(object sender, EventArgs e)
        {
            if (WindA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(WindA.Text, out I))
            {
                WindA.BackColor = Color.White;
                WindA.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental.WindA = I;
            }
            else
            {
                WindA.BackColor = Color.RosyBrown;
                WindA.ForeColor = Color.White;
            }
        }
        private void IceD_TextChanged(object sender, EventArgs e)
        {
            if (IceD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(IceD.Text, out I))
            {
                IceD.BackColor = Color.White;
                IceD.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental.IceD = I;
            }
            else
            {
                IceD.BackColor = Color.RosyBrown;
                IceD.ForeColor = Color.White;
            }
        }
        private void WindD_TextChanged(object sender, EventArgs e)
        {
            if (WindD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(WindD.Text, out I))
            {
                WindD.BackColor = Color.White;
                WindD.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental.WindD = I;
            }
            else
            {
                WindD.BackColor = Color.RosyBrown;
                WindD.ForeColor = Color.White;
            }
        }
        private void HolyD_TextChanged(object sender, EventArgs e)
        {
            if (HolyD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(HolyD.Text, out I))
            {
                HolyD.BackColor = Color.White;
                HolyD.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental.HolyD = I;
            }
            else
            {
                HolyD.BackColor = Color.RosyBrown;
                HolyD.ForeColor = Color.White;
            }
        }
        private void HolyA_TextChanged(object sender, EventArgs e)
        {
            if ( HolyA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse( HolyA.Text, out I))
            {
                 HolyA.BackColor = Color.White;
                 HolyA.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental. HolyA = I;
            }
            else
            {
                 HolyA.BackColor = Color.RosyBrown;
                 HolyA.ForeColor = Color.White;
            }
        }
        private void DarkA_TextChanged(object sender, EventArgs e)
        {
            if (DarkA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(DarkA.Text, out I))
            {
                DarkA.BackColor = Color.White;
                DarkA.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental.DarkA = I;
            }
            else
            {
                DarkA.BackColor = Color.RosyBrown;
                DarkA.ForeColor = Color.White;
            }
        }
        private void DarkD_TextChanged(object sender, EventArgs e)
        {
            if (DarkD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(DarkD.Text, out I))
            {
                DarkD.BackColor = Color.White;
                DarkD.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental.DarkD = I;
            }
            else
            {
                DarkD.BackColor = Color.RosyBrown;
                DarkD.ForeColor = Color.White;
            }
        }
        private void IllusionD_TextChanged(object sender, EventArgs e)
        {
            if (IllusionD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(IllusionD.Text, out I))
            {
                IllusionD.BackColor = Color.White;
                IllusionD.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental.IllusionD = I;
            }
            else
            {
                IllusionD.BackColor = Color.RosyBrown;
                IllusionD.ForeColor = Color.White;
            }
        }        
        private void IllusionA_TextChanged(object sender, EventArgs e)
        {
            if (IllusionA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(IllusionA.Text, out I))
            {
                IllusionA.BackColor = Color.White;
                IllusionA.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    BI.Stats.Elemental.IllusionA = I;
            }
            else
            {
                IllusionA.BackColor = Color.RosyBrown;
                IllusionA.ForeColor = Color.White;
            }
        }
        private void Behaviour_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if (Selecting) return;

            foreach (ItemInfo BI in ItemList.SelectedItems)
                if (e.NewValue == CheckState.Checked)
                {
                    if (!BI.Behaviour.HasFlag((ItemBehaviour)Enum.GetValues(typeof(ItemBehaviour)).GetValue(e.Index)))
                        BI.Behaviour += (short)Enum.GetValues(typeof(ItemBehaviour)).GetValue(e.Index);
                }
                else if (BI.Behaviour.HasFlag((ItemBehaviour)Enum.GetValues(typeof(ItemBehaviour)).GetValue(e.Index)))
                    BI.Behaviour -= (short)Enum.GetValues(typeof(ItemBehaviour)).GetValue(e.Index);
        }
        private void MaxLevel_TextChanged(object sender, EventArgs e)
        {
            if (IllusionA.Text == "#####") return;
            if (Selecting) return;
            ushort I;
            if (ushort.TryParse(MaxLevel.Text, out I))
            {
                MaxLevel.BackColor = Color.White;
                MaxLevel.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                {
                    BI.MaxLevel = I;
                    BI.ExpList = new List<long>();
                }
                ExpList.Items.Clear();
                for (int i = 0; i < I; i++)
                    ExpList.Items.Add(new long());
            }
            else
            {
                MaxLevel.BackColor = Color.RosyBrown;
                MaxLevel.ForeColor = Color.White;
            }
        }
        private void ExpBox_TextChanged(object sender, EventArgs e)
        {
            if (IllusionA.Text == "#####") return;
            if (Selecting) return;
            uint I;
            if (uint.TryParse(ExpBox.Text, out I))
            {
                ExpBox.BackColor = Color.White;
                ExpBox.ForeColor = Color.Black;

                foreach (ItemInfo BI in ItemList.SelectedItems)
                    foreach (int Indices in ExpList.SelectedIndices)
                        BI.ExpList[Indices] = I;

                bool[] SelList = new bool[ExpList.Items.Count];
                for (int X = 0; X < SelList.Length; X++)
                    SelList[X] = ExpList.GetSelected(X);

                for (int X = 0; X < SelList.Length; X++)
                {
                    if (SelList[X])
                        ExpList.Items[X] = I;
                }

                for (int X = 0; X < SelList.Length; X++)
                    ExpList.SetSelected(X, SelList[X]);

                
            }
            else
            {
                ExpBox.BackColor = Color.RosyBrown;
                ExpBox.ForeColor = Color.White;
            }

        }
    }
}
