﻿using System;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using Clash_Library;

namespace Mir_Manager
{
    public partial class Main : Form
    {
        public static ServerData SData = null;
        public string DataPath = "";
        public static Map_Form MapF;
        public static Item_Form ItemF;
        public static Monster_Form MonsterF;

        public Main()
        {
            InitializeComponent();
            MapF = new Map_Form();
            MapF.MdiParent = this;
            MapF.WindowState = FormWindowState.Maximized;

            ItemF = new Item_Form();
            ItemF.MdiParent = this;
            ItemF.WindowState = FormWindowState.Maximized;

            MonsterF = new Monster_Form();
            MonsterF.MdiParent = this;
            MonsterF.WindowState = FormWindowState.Maximized;   
        }

        private void ViewMaps_Click(object sender, EventArgs e)
        {
            if (SData == null) return;
            if (MapF.Visible)
                MapF.Focus();
            else
                MapF.Show();
        }

        private void ViewItems_Click(object sender, EventArgs e)
        {
            if (SData == null) return;
            if (ItemF.Visible)
                ItemF.Focus();
            else
                ItemF.Show();
        }

        private void NewData_Click(object sender, EventArgs e)
        {
            if (SData != null)
            {
                //Ask to Save.


            }

            if (SaveDialog.ShowDialog() == DialogResult.OK)
            {
                DataPath = SaveDialog.FileName;
                SData = new ServerData();
                using (FileStream FStream = new FileStream(DataPath, FileMode.Create))
                    new BinaryFormatter().Serialize(FStream, SData);
                ItemF.DataLoaded();
                MapF.DataLoaded();
                MonsterF.DataLoaded();
            }
        }

        private void SaveData_Click(object sender, EventArgs e)
        {
            if (SData == null) return;

            using (FileStream FStream = new FileStream(DataPath, FileMode.Create))
                new BinaryFormatter().Serialize(FStream, SData);
            MessageBox.Show("Data Saved.", "Data Saved.");
        }

        private void OpenData_Click(object sender, EventArgs e)
        {

            if (SData != null)
            {
                //Ask to Save.


            }

            if (OpenDialog.ShowDialog() == DialogResult.OK)
            {
                DataPath = OpenDialog.FileName;
                using (FileStream FStream = new FileStream(DataPath, FileMode.Open))
                    SData = (ServerData)new BinaryFormatter().Deserialize(FStream);
            ItemF.DataLoaded();
            MapF.DataLoaded();
            MonsterF.DataLoaded();
            }
        }

        private void ViewMonsters_Click(object sender, EventArgs e)
        {
            if (SData == null) return;
            if (MonsterF.Visible)
                MonsterF.Focus();
            else
                MonsterF.Show();
        }


    }
}
