﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Clash_Library;

namespace Mir_Manager
{
    public partial class Monster_Form : Form
    {
        public static bool Selecting;
        public CurrencyManager Manager, DropManager;

        public Monster_Form()
        {
            InitializeComponent();
            Behaviour.Items.AddRange(Enum.GetNames(typeof(MonsterBehaviour)));
            AI.Items.AddRange(Enum.GetNames(typeof(MonsterAI)));
        }

        public void DataLoaded()
        {
            Manager = (CurrencyManager)BindingContext[Main.SData.MonsterList];
            MonsterList.DataSource = Main.SData.MonsterList;

            if (MonsterList.SelectedItems.Count == 1)
            {
                DropList.DataSource = (MonsterList.SelectedItem as MonsterInfo).DropList;
                DropManager = (CurrencyManager)BindingContext[(MonsterList.SelectedItem as MonsterInfo).DropList];

            }

            if (DropList.SelectedItems.Count == 1)
                panel1.Enabled = true;
            else
                panel1.Enabled = false;

            if (MonsterList.SelectedItems.Count == 0)
                tabControl1.Hide();
            else
                tabControl1.Show();
        }
        public void SortList()
        {
            for (int I = 0; I < Main.SData.MonsterList.Count; I++)
                Main.SData.MonsterList[I].Index = I;
        }
        public void RefreshLists()
        {
            bool[] SelList = new bool[MonsterList.Items.Count];
            for (int X = 0; X < SelList.Length; X++)
                SelList[X] = MonsterList.GetSelected(X);

            Manager.Refresh();
            Main.MapF.MonsterCombo.Items.Clear();
            Main.MapF.MonsterCombo.Items.AddRange(Main.SData.MonsterList.ToArray());
            Main.MapF.MonsterCombo.SelectedItem = null;
            Main.MapF.MonsterCombo.Text = "";
            Main.MapF.SpawnManager.Refresh();

            for (int X = 0; X < SelList.Length; X++)
                MonsterList.SetSelected(X, SelList[X]);

        }

        public void ClearInterface()
        {
            MonsterIndex.Text = "";
            MonsterName.Text = "";
            AI.SelectedItem = null;
            AI.Text = "";
            Image.Text = "";
            Level.Text = "";
            Experience.Text = "";
            MoveSpeed.Text = "";
            CoolEye.Text = "";
            HP.Text = "";
            MP.Text = "";
            Accuracy.Text = "";
            Agility.Text = "";
            AC.Text = "";
            AC2.Text = "";
            MAC.Text = "";
            MAC2.Text = "";
            DC.Text = "";
            DC2.Text = "";
            MC.Text = "";
            MC2.Text = "";
            SC.Text = "";
            SC2.Text = "";
            AttackSpeed.Text = "";
            Light.Text = "";
            Luck.Text = "";
            MResist.Text = "";
            CResist.Text = "";
            PResist.Text = "";
            PAttack.Text = "";
            CAttack.Text = "";
            FireA.Text = "";
            FireD.Text = "";
            LightningA.Text = "";
            LightningD.Text = "";
            IceA.Text = "";
            IceD.Text = "";
            WindA.Text = "";
            WindD.Text = "";
            HolyA.Text = "";
            HolyD.Text = "";
            DarkA.Text = "";
            DarkD.Text = "";
            IllusionA.Text = "";
            IllusionD.Text = "";
            Behaviour.ClearSelected();
            Gold.Text = "";
            GoldChance.Text = "";
        }
        public void FillInterface()
        {
            MonsterBehaviour B = 0;
            bool Checked = false;
            foreach (MonsterInfo MI in MonsterList.SelectedItems)
            {
                if (MonsterIndex.Text == "") MonsterIndex.Text = MI.Index.ToString();
                if (MonsterIndex.Text != MI.Index.ToString()) MonsterIndex.Text = "#####";

                if (MonsterName.Text == "") MonsterName.Text = MI.Name;
                if (MonsterName.Text != MI.Name) MonsterName.Text = "#####";

                if (AI.Text == "") AI.Text = MI.AI.ToString();
                if (AI.Text != MI.AI.ToString()) AI.Text = "#####";

                if (Image.Text == "") Image.Text = MI.Image.ToString();
                if (Image.Text != MI.Image.ToString()) Image.Text = "#####";

                if (Level.Text == "") Level.Text = MI.Level.ToString();
                if (Level.Text != MI.Level.ToString()) Level.Text = "#####";

                if (Experience.Text == "") Experience.Text = MI.Experience.ToString();
                if (Experience.Text != MI.Experience.ToString()) Experience.Text = "#####";

                if (MoveSpeed.Text == "") MoveSpeed.Text = MI.MoveSpeed.TotalMilliseconds.ToString();
                if (MoveSpeed.Text != MI.MoveSpeed.TotalMilliseconds.ToString()) MoveSpeed.Text = "#####";

                if (CoolEye.Text == "") CoolEye.Text = MI.CoolEye.ToString();
                if (CoolEye.Text != MI.CoolEye.ToString()) CoolEye.Text = "#####";

                if (HP.Text == "") HP.Text = MI.Stats.Basic.HP.ToString();
                if (HP.Text != MI.Stats.Basic.HP.ToString()) HP.Text = "#####";

                if (MP.Text == "") MP.Text = MI.Stats.Basic.MP.ToString();
                if (MP.Text != MI.Stats.Basic.MP.ToString()) MP.Text = "#####";

                if (Accuracy.Text == "") Accuracy.Text = MI.Stats.Basic.Accuracy.ToString();
                if (Accuracy.Text != MI.Stats.Basic.Accuracy.ToString()) Accuracy.Text = "#####";

                if (Agility.Text == "") Agility.Text = MI.Stats.Basic.Agility.ToString();
                if (Agility.Text != MI.Stats.Basic.Agility.ToString()) Agility.Text = "#####";

                if (AC.Text == "") AC.Text = MI.Stats.Basic.AC.ToString();
                if (AC.Text != MI.Stats.Basic.AC.ToString()) AC.Text = "#####";

                if (AC2.Text == "") AC2.Text = MI.Stats.Basic.AC2.ToString();
                if (AC2.Text != MI.Stats.Basic.AC2.ToString()) AC2.Text = "#####";

                if (MAC.Text == "") MAC.Text = MI.Stats.Basic.MAC.ToString();
                if (MAC.Text != MI.Stats.Basic.MAC.ToString()) MAC.Text = "#####";

                if (MAC2.Text == "") MAC2.Text = MI.Stats.Basic.MAC2.ToString();
                if (MAC2.Text != MI.Stats.Basic.MAC2.ToString()) MAC2.Text = "#####";

                if (DC.Text == "") DC.Text = MI.Stats.Basic.DC.ToString();
                if (DC.Text != MI.Stats.Basic.DC.ToString()) DC.Text = "#####";

                if (DC2.Text == "") DC2.Text = MI.Stats.Basic.DC2.ToString();
                if (DC2.Text != MI.Stats.Basic.DC2.ToString()) DC2.Text = "#####";

                if (MC.Text == "") MC.Text = MI.Stats.Basic.MC.ToString();
                if (MC.Text != MI.Stats.Basic.MC.ToString()) MC.Text = "#####";

                if (MC2.Text == "") MC2.Text = MI.Stats.Basic.MC2.ToString();
                if (MC2.Text != MI.Stats.Basic.MC2.ToString()) MC2.Text = "#####";

                if (SC.Text == "") SC.Text = MI.Stats.Basic.SC.ToString();
                if (SC.Text != MI.Stats.Basic.SC.ToString()) SC.Text = "#####";

                if (SC2.Text == "") SC2.Text = MI.Stats.Basic.SC2.ToString();
                if (SC2.Text != MI.Stats.Basic.SC2.ToString()) SC2.Text = "#####";

                if (AttackSpeed.Text == "") AttackSpeed.Text = MI.Stats.Advanced.ASpeed.ToString();
                if (AttackSpeed.Text != MI.Stats.Advanced.ASpeed.ToString()) AttackSpeed.Text = "#####";

                if (Light.Text == "") Light.Text = MI.Stats.Advanced.Light.ToString();
                if (Light.Text != MI.Stats.Advanced.Light.ToString()) Light.Text = "#####";

                if (Luck.Text == "") Luck.Text = MI.Stats.Advanced.Luck.ToString();
                if (Luck.Text != MI.Stats.Advanced.Luck.ToString()) Luck.Text = "#####";

                if (MResist.Text == "") MResist.Text = MI.Stats.Advanced.MR.ToString();
                if (MResist.Text != MI.Stats.Advanced.MR.ToString()) MResist.Text = "#####";

                if (PResist.Text == "") PResist.Text = MI.Stats.Advanced.PR.ToString();
                if (PResist.Text != MI.Stats.Advanced.PR.ToString()) PResist.Text = "#####";

                if (CResist.Text == "") CResist.Text = MI.Stats.Advanced.CR.ToString();
                if (CResist.Text != MI.Stats.Advanced.CR.ToString()) CResist.Text = "#####";

                if (PAttack.Text == "") PAttack.Text = MI.Stats.Advanced.PA.ToString();
                if (PAttack.Text != MI.Stats.Advanced.PA.ToString()) PAttack.Text = "#####";

                if (CAttack.Text == "") CAttack.Text = MI.Stats.Advanced.CA.ToString();
                if (CAttack.Text != MI.Stats.Advanced.CA.ToString()) CAttack.Text = "#####";

                if (FireA.Text == "") FireA.Text = MI.Stats.Elemental.FireA.ToString();
                if (FireA.Text != MI.Stats.Elemental.FireA.ToString()) FireA.Text = "#####";

                if (FireD.Text == "") FireD.Text = MI.Stats.Elemental.FireD.ToString();
                if (FireD.Text != MI.Stats.Elemental.FireD.ToString()) FireD.Text = "#####";

                if (LightningA.Text == "") LightningA.Text = MI.Stats.Elemental.LightningA.ToString();
                if (LightningA.Text != MI.Stats.Elemental.LightningA.ToString()) LightningA.Text = "#####";

                if (LightningD.Text == "") LightningD.Text = MI.Stats.Elemental.LightningD.ToString();
                if (LightningD.Text != MI.Stats.Elemental.LightningD.ToString()) LightningD.Text = "#####";

                if (IceA.Text == "") IceA.Text = MI.Stats.Elemental.IceA.ToString();
                if (IceA.Text != MI.Stats.Elemental.IceA.ToString()) IceA.Text = "#####";

                if (IceD.Text == "") IceD.Text = MI.Stats.Elemental.IceD.ToString();
                if (IceD.Text != MI.Stats.Elemental.IceD.ToString()) IceD.Text = "#####";

                if (WindA.Text == "") WindA.Text = MI.Stats.Elemental.WindA.ToString();
                if (WindA.Text != MI.Stats.Elemental.WindA.ToString()) WindA.Text = "#####";

                if (WindD.Text == "") WindD.Text = MI.Stats.Elemental.WindD.ToString();
                if (WindD.Text != MI.Stats.Elemental.WindD.ToString()) WindD.Text = "#####";

                if (HolyA.Text == "") HolyA.Text = MI.Stats.Elemental.HolyA.ToString();
                if (HolyA.Text != MI.Stats.Elemental.HolyA.ToString()) HolyA.Text = "#####";

                if (HolyD.Text == "") HolyD.Text = MI.Stats.Elemental.HolyD.ToString();
                if (HolyD.Text != MI.Stats.Elemental.HolyD.ToString()) HolyD.Text = "#####";

                if (DarkA.Text == "") DarkA.Text = MI.Stats.Elemental.DarkA.ToString();
                if (DarkA.Text != MI.Stats.Elemental.DarkA.ToString()) DarkA.Text = "#####";

                if (DarkD.Text == "") DarkD.Text = MI.Stats.Elemental.DarkD.ToString();
                if (DarkD.Text != MI.Stats.Elemental.DarkD.ToString()) DarkD.Text = "#####";

                if (IllusionA.Text == "") IllusionA.Text = MI.Stats.Elemental.IllusionA.ToString();
                if (IllusionA.Text != MI.Stats.Elemental.IllusionA.ToString()) IllusionA.Text = "#####";

                if (IllusionD.Text == "") IllusionD.Text = MI.Stats.Elemental.IllusionD.ToString();
                if (IllusionD.Text != MI.Stats.Elemental.IllusionD.ToString()) IllusionD.Text = "#####";

                if (!Checked)
                {
                    B = MI.Behaviour;

                    for (int I = 0; I < Enum.GetValues(typeof(MonsterBehaviour)).Length; I++)
                        if ((B & (MonsterBehaviour)Enum.GetValues(typeof(MonsterBehaviour)).GetValue(I)) != 0)
                            Behaviour.SetItemChecked(I, true);
                        else Behaviour.SetItemChecked(I, false);
                }

                if (B != MI.Behaviour)
                {
                    for (int I = 0; I < Behaviour.Items.Count; I++)
                        Behaviour.SetItemCheckState(I, CheckState.Indeterminate);
                }


                if (Gold.Text == "") Gold.Text = MI.Gold.ToString();
                if (Gold.Text != MI.Gold.ToString()) Gold.Text = "#####";

                if (GoldChance.Text == "") GoldChance.Text = MI.GoldRate > 0 ? ((int)(1 / MI.GoldRate)).ToString() : "0";
                if (GoldChance.Text != (MI.GoldRate > 0 ? ((int)(1 / MI.GoldRate)).ToString() : "0")) GoldChance.Text = "#####";


                Checked = true;
            }
        }

        private void HP_TextChanged(object sender, EventArgs e)
        {
            if (HP.Text == "#####") return;
            if (Selecting) return;
            int I;
            if (int.TryParse(HP.Text, out I))
            {
                HP.BackColor = Color.White;
                HP.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.HP = I;
            }
            else
            {
                HP.BackColor = Color.RosyBrown;
                HP.ForeColor = Color.White;
            }
        }
        private void MP_TextChanged(object sender, EventArgs e)
        {
            if (MP.Text == "#####") return;
            if (Selecting) return;
            int I;
            if (int.TryParse(MP.Text, out I))
            {
                MP.BackColor = Color.White;
                MP.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.MP = I;
            }
            else
            {
                MP.BackColor = Color.RosyBrown;
                MP.ForeColor = Color.White;
            }
        }
        private void Accuracy_TextChanged(object sender, EventArgs e)
        {
            if (Accuracy.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(Accuracy.Text, out I))
            {
                Accuracy.BackColor = Color.White;
                Accuracy.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.Accuracy = I;
            }
            else
            {
                Accuracy.BackColor = Color.RosyBrown;
                Accuracy.ForeColor = Color.White;
            }
        }
        private void Agility_TextChanged(object sender, EventArgs e)
        {
            if (Agility.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(Agility.Text, out I))
            {
                Agility.BackColor = Color.White;
                Agility.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.Agility = I;
            }
            else
            {
                Agility.BackColor = Color.RosyBrown;
                Agility.ForeColor = Color.White;
            }
        }
        private void AC_TextChanged(object sender, EventArgs e)
        {
            if (AC.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(AC.Text, out I))
            {
                AC.BackColor = Color.White;
                AC.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.AC = I;
            }
            else
            {
                AC.BackColor = Color.RosyBrown;
                AC.ForeColor = Color.White;
            }
        }
        private void DC_TextChanged(object sender, EventArgs e)
        {
            if (DC.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(DC.Text, out I))
            {
                DC.BackColor = Color.White;
                DC.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.DC = I;
            }
            else
            {
                DC.BackColor = Color.RosyBrown;
                DC.ForeColor = Color.White;
            }
        }
        private void AC2_TextChanged(object sender, EventArgs e)
        {
            if (AC2.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(AC2.Text, out I))
            {
                AC2.BackColor = Color.White;
                AC2.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.AC2 = I;
            }
            else
            {
                AC2.BackColor = Color.RosyBrown;
                AC2.ForeColor = Color.White;
            }
        }
        private void DC2_TextChanged(object sender, EventArgs e)
        {
            if (DC2.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(DC2.Text, out I))
            {
                DC2.BackColor = Color.White;
                DC2.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.DC2 = I;
            }
            else
            {
                DC2.BackColor = Color.RosyBrown;
                DC2.ForeColor = Color.White;
            }
        }
        private void MC_TextChanged(object sender, EventArgs e)
        {
            if (MC.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(MC.Text, out I))
            {
                MC.BackColor = Color.White;
                MC.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.MC = I;
            }
            else
            {
                MC.BackColor = Color.RosyBrown;
                MC.ForeColor = Color.White;
            }
        }
        private void MAC_TextChanged(object sender, EventArgs e)
        {
            if (MAC.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(MAC.Text, out I))
            {
                MAC.BackColor = Color.White;
                MAC.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.MAC = I;
            }
            else
            {
                MAC.BackColor = Color.RosyBrown;
                MAC.ForeColor = Color.White;
            }
        }
        private void MC2_TextChanged(object sender, EventArgs e)
        {
            if (MC2.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(MC2.Text, out I))
            {
                MC2.BackColor = Color.White;
                MC2.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.MC2 = I;
            }
            else
            {
                MC2.BackColor = Color.RosyBrown;
                MC2.ForeColor = Color.White;
            }
        }
        private void MAC2_TextChanged(object sender, EventArgs e)
        {
            if (MAC2.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(MAC2.Text, out I))
            {
                MAC2.BackColor = Color.White;
                MAC2.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.MAC2 = I;
            }
            else
            {
                MAC2.BackColor = Color.RosyBrown;
                MAC2.ForeColor = Color.White;
            }
        }
        private void SC_TextChanged(object sender, EventArgs e)
        {
            if (SC.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(SC.Text, out I))
            {
                SC.BackColor = Color.White;
                SC.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.SC = I;
            }
            else
            {
                SC.BackColor = Color.RosyBrown;
                SC.ForeColor = Color.White;
            }
        }
        private void SC2_TextChanged(object sender, EventArgs e)
        {
            if (SC2.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(SC2.Text, out I))
            {
                SC2.BackColor = Color.White;
                SC2.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Basic.SC2 = I;
            }
            else
            {
                SC2.BackColor = Color.RosyBrown;
                SC2.ForeColor = Color.White;
            }
        }
        private void AttackSpeed_TextChanged(object sender, EventArgs e)
        {
            if (AttackSpeed.Text == "#####") return;
            if (Selecting) return;
            byte I;
            if (byte.TryParse(AttackSpeed.Text, out I))
            {
                AttackSpeed.BackColor = Color.White;
                AttackSpeed.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Advanced.ASpeed = I;
            }
            else
            {
                AttackSpeed.BackColor = Color.RosyBrown;
                AttackSpeed.ForeColor = Color.White;
            }
        }
        private void Light_TextChanged(object sender, EventArgs e)
        {
            if (Light.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(Light.Text, out I))
            {
                Light.BackColor = Color.White;
                Light.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Advanced.Light = I;
            }
            else
            {
                Light.BackColor = Color.RosyBrown;
                Light.ForeColor = Color.White;
            }
        }
        private void Luck_TextChanged(object sender, EventArgs e)
        {
            if (Luck.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(Luck.Text, out I))
            {
                Luck.BackColor = Color.White;
                Luck.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Advanced.Luck = I;
            }
            else
            {
                Luck.BackColor = Color.RosyBrown;
                Luck.ForeColor = Color.White;
            }
        }
        private void CResist_TextChanged(object sender, EventArgs e)
        {
            if (CResist.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(CResist.Text, out I))
            {
                CResist.BackColor = Color.White;
                CResist.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Advanced.CR = I;
            }
            else
            {
                CResist.BackColor = Color.RosyBrown;
                CResist.ForeColor = Color.White;
            }
        }
        private void PResist_TextChanged(object sender, EventArgs e)
        {
            if (PResist.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(PResist.Text, out I))
            {
                PResist.BackColor = Color.White;
                PResist.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Advanced.PR = I;
            }
            else
            {
                PResist.BackColor = Color.RosyBrown;
                PResist.ForeColor = Color.White;
            }
        }
        private void CAttack_TextChanged(object sender, EventArgs e)
        {
            if (CAttack.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(CAttack.Text, out I))
            {
                CAttack.BackColor = Color.White;
                CAttack.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Advanced.CA = I;
            }
            else
            {
                CAttack.BackColor = Color.RosyBrown;
                CAttack.ForeColor = Color.White;
            }
        }
        private void PAttack_TextChanged(object sender, EventArgs e)
        {
            if (PAttack.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(PAttack.Text, out I))
            {
                PAttack.BackColor = Color.White;
                PAttack.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Advanced.PA = I;
            }
            else
            {
                PAttack.BackColor = Color.RosyBrown;
                PAttack.ForeColor = Color.White;
            }
        }
        private void MResist_TextChanged(object sender, EventArgs e)
        {
            if (MResist.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(MResist.Text, out I))
            {
                MResist.BackColor = Color.White;
                MResist.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Advanced.MR = I;
            }
            else
            {
                MResist.BackColor = Color.RosyBrown;
                MResist.ForeColor = Color.White;
            }
        }
        private void FireA_TextChanged(object sender, EventArgs e)
        {
            if (FireA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(FireA.Text, out I))
            {
                FireA.BackColor = Color.White;
                FireA.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.FireA = I;
            }
            else
            {
                FireA.BackColor = Color.RosyBrown;
                FireA.ForeColor = Color.White;
            }
        }
        private void FireD_TextChanged(object sender, EventArgs e)
        {
            if (FireD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(FireD.Text, out I))
            {
                FireD.BackColor = Color.White;
                FireD.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.FireD = I;
            }
            else
            {
                FireD.BackColor = Color.RosyBrown;
                FireD.ForeColor = Color.White;
            }
        }
        private void LightningD_TextChanged(object sender, EventArgs e)
        {
            if (LightningD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(LightningD.Text, out I))
            {
                LightningD.BackColor = Color.White;
                LightningD.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.LightningD = I;
            }
            else
            {
                LightningD.BackColor = Color.RosyBrown;
                LightningD.ForeColor = Color.White;
            }
        }
        private void LightningA_TextChanged(object sender, EventArgs e)
        {
            if (LightningA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(LightningA.Text, out I))
            {
                LightningA.BackColor = Color.White;
                LightningA.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.LightningA = I;
            }
            else
            {
                LightningA.BackColor = Color.RosyBrown;
                LightningA.ForeColor = Color.White;
            }
        }
        private void IceA_TextChanged(object sender, EventArgs e)
        {
            if (IceA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(IceA.Text, out I))
            {
                IceA.BackColor = Color.White;
                IceA.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.IceA = I;
            }
            else
            {
                IceA.BackColor = Color.RosyBrown;
                IceA.ForeColor = Color.White;
            }
        }
        private void WindA_TextChanged(object sender, EventArgs e)
        {
            if (WindA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(WindA.Text, out I))
            {
                WindA.BackColor = Color.White;
                WindA.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.WindA = I;
            }
            else
            {
                WindA.BackColor = Color.RosyBrown;
                WindA.ForeColor = Color.White;
            }
        }
        private void IceD_TextChanged(object sender, EventArgs e)
        {
            if (IceD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(IceD.Text, out I))
            {
                IceD.BackColor = Color.White;
                IceD.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.IceD = I;
            }
            else
            {
                IceD.BackColor = Color.RosyBrown;
                IceD.ForeColor = Color.White;
            }
        }
        private void WindD_TextChanged(object sender, EventArgs e)
        {
            if (WindD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(WindD.Text, out I))
            {
                WindD.BackColor = Color.White;
                WindD.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.WindD = I;
            }
            else
            {
                WindD.BackColor = Color.RosyBrown;
                WindD.ForeColor = Color.White;
            }
        }
        private void HolyD_TextChanged(object sender, EventArgs e)
        {
            if (HolyD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(HolyD.Text, out I))
            {
                HolyD.BackColor = Color.White;
                HolyD.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.HolyD = I;
            }
            else
            {
                HolyD.BackColor = Color.RosyBrown;
                HolyD.ForeColor = Color.White;
            }
        }
        private void HolyA_TextChanged(object sender, EventArgs e)
        {
            if (HolyA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(HolyA.Text, out I))
            {
                HolyA.BackColor = Color.White;
                HolyA.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.HolyA = I;
            }
            else
            {
                HolyA.BackColor = Color.RosyBrown;
                HolyA.ForeColor = Color.White;
            }
        }
        private void DarkA_TextChanged(object sender, EventArgs e)
        {
            if (DarkA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(DarkA.Text, out I))
            {
                DarkA.BackColor = Color.White;
                DarkA.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.DarkA = I;
            }
            else
            {
                DarkA.BackColor = Color.RosyBrown;
                DarkA.ForeColor = Color.White;
            }
        }
        private void DarkD_TextChanged(object sender, EventArgs e)
        {
            if (DarkD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(DarkD.Text, out I))
            {
                DarkD.BackColor = Color.White;
                DarkD.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.DarkD = I;
            }
            else
            {
                DarkD.BackColor = Color.RosyBrown;
                DarkD.ForeColor = Color.White;
            }
        }
        private void IllusionD_TextChanged(object sender, EventArgs e)
        {

            if (IllusionD.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(IllusionD.Text, out I))
            {
                IllusionD.BackColor = Color.White;
                IllusionD.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.IllusionD = I;
            }
            else
            {
                IllusionD.BackColor = Color.RosyBrown;
                IllusionD.ForeColor = Color.White;
            }
        }
        private void IllusionA_TextChanged(object sender, EventArgs e)
        {
            if (IllusionA.Text == "#####") return;
            if (Selecting) return;
            sbyte I;
            if (sbyte.TryParse(IllusionA.Text, out I))
            {
                IllusionA.BackColor = Color.White;
                IllusionA.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Stats.Elemental.IllusionA = I;
            }
            else
            {
                IllusionA.BackColor = Color.RosyBrown;
                IllusionA.ForeColor = Color.White;
            }
        }
        private void Image_TextChanged(object sender, EventArgs e)
        {
            if (Image.Text == "#####") return;
            if (Selecting) return;
            ushort I;
            if (ushort.TryParse(Image.Text, out I))
            {
                Image.BackColor = Color.White;
                Image.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Image = I;
            }
            else
            {
                Image.BackColor = Color.RosyBrown;
                Image.ForeColor = Color.White;
            }


        }
        private void Level_TextChanged(object sender, EventArgs e)
        {
            if (Level.Text == "#####") return;
            if (Selecting) return;
            int I;
            if (int.TryParse(Level.Text, out I))
            {
                Level.BackColor = Color.White;
                Level.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Level = I;
            }
            else
            {
                Level.BackColor = Color.RosyBrown;
                Level.ForeColor = Color.White;
            }
        }
        private void Experience_TextChanged(object sender, EventArgs e)
        {
            if (Experience.Text == "#####") return;
            if (Selecting) return;
            long I;
            if (long.TryParse(Experience.Text, out I))
            {
                Experience.BackColor = Color.White;
                Experience.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Experience = I;
            }
            else
            {
                Experience.BackColor = Color.RosyBrown;
                Experience.ForeColor = Color.White;
            }
        }
        private void MoveSpeed_TextChanged(object sender, EventArgs e)
        {
            if (MoveSpeed.Text == "#####") return;
            if (Selecting) return;
            short I;
            if (short.TryParse(MoveSpeed.Text, out I))
            {
                MoveSpeed.BackColor = Color.White;
                MoveSpeed.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.MoveSpeed = TimeSpan.FromMilliseconds(I);
            }
            else
            {
                MoveSpeed.BackColor = Color.RosyBrown;
                MoveSpeed.ForeColor = Color.White;
            }
        }
        private void CoolEye_TextChanged(object sender, EventArgs e)
        {
            if (CoolEye.Text == "#####") return;
            if (Selecting) return;
            byte I;
            if (byte.TryParse(CoolEye.Text, out I))
            {
                CoolEye.BackColor = Color.White;
                CoolEye.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.CoolEye = I;
            }
            else
            {
                CoolEye.BackColor = Color.RosyBrown;
                CoolEye.ForeColor = Color.White;
            }
        }
        private void MonsterIndex_Leave(object sender, EventArgs e)
        {
            if (MonsterIndex.Text == "#####") return;
            if (Selecting) return;
            int I;
            if (int.TryParse(MonsterIndex.Text, out I))
            {
                MonsterIndex.BackColor = Color.White;
                MonsterIndex.ForeColor = Color.Black;


                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Index = I;

                RefreshLists();
            }
            else
            {
                MonsterIndex.BackColor = Color.RosyBrown;
                MonsterIndex.ForeColor = Color.White;
            }
        }
        private void MonsterName_Leave(object sender, EventArgs e)
        {
            if (MonsterName.Text == "#####") return;
            if (Selecting) return;

            if (!string.IsNullOrWhiteSpace(MonsterName.Text))
            {
                MonsterName.BackColor = Color.White;
                MonsterName.ForeColor = Color.Black;
            }
            else
            {
                MonsterName.BackColor = Color.RosyBrown;
                MonsterName.ForeColor = Color.White;
            }

            foreach (MonsterInfo MI in MonsterList.SelectedItems)
                MI.Name = MonsterName.Text != null ? MonsterName.Text : "";

            RefreshLists();
        }
        private void Behaviour_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if (Selecting) return;

            foreach (MonsterInfo MI in MonsterList.SelectedItems)
                if (e.NewValue == CheckState.Checked)
                {
                    if (!MI.Behaviour.HasFlag((MonsterBehaviour)Enum.GetValues(typeof(MonsterBehaviour)).GetValue(e.Index)))
                        MI.Behaviour += (short)Enum.GetValues(typeof(MonsterBehaviour)).GetValue(e.Index);
                }
                else if (MI.Behaviour.HasFlag((MonsterBehaviour)Enum.GetValues(typeof(MonsterBehaviour)).GetValue(e.Index)))
                    MI.Behaviour -= (short)Enum.GetValues(typeof(MonsterBehaviour)).GetValue(e.Index);
        }

        private void MonsterList_SelectedIndexChanged(object sender, EventArgs e)
        {
            Selecting = true;
            ClearInterface();
            FillInterface();
            Selecting = false;

            if (MonsterList.SelectedItems.Count == 1)
            {
                DropList.DataSource = (MonsterList.SelectedItem as MonsterInfo).DropList;
                DropManager = (CurrencyManager)BindingContext[(MonsterList.SelectedItem as MonsterInfo).DropList];

                AddDrop.Enabled = true;
                DeleteDrop.Enabled = true;

                Selecting = true;
                ClearDropInterface();
                FillDropInterface();
                Selecting = false;
            }
            else
            {
                DropList.DataSource = null;
                DropList.Items.Clear();
                Selecting = true;
                ClearDropInterface();
                Selecting = false;
                AddDrop.Enabled = false;
                DeleteDrop.Enabled = false;
            }
            if (DropList.SelectedItems.Count == 1)
                panel1.Enabled = true;
            else
                panel1.Enabled = false;


            if (MonsterList.SelectedItems.Count == 0)
                tabControl1.Hide();
            else
                tabControl1.Show();
        }

        private void DeleteMonster_Click(object sender, EventArgs e)
        {
            if (MonsterList.SelectedItems.Count == 0) return;

            if (MessageBox.Show("Are you sure you want to delete the selected Monsters(s)", "Delete Monsters(s)", MessageBoxButtons.YesNo) == DialogResult.No)
                return;

            foreach (MonsterInfo MI in MonsterList.SelectedItems)
            {
                Main.SData.MonsterList.Remove(MI);
                foreach (MapInfo M in Main.SData.MapList)
                    for (int I = M.RespawnList.Count - 1; I >= 0; I--)
                        if (M.RespawnList[I].Monster == MI)
                            M.RespawnList.RemoveAt(I);
            }

            SortList();
            Manager.Refresh();
            Main.MapF.SpawnManager.Refresh();
            Main.MapF.MonsterCombo.Items.Clear();
            Main.MapF.MonsterCombo.Items.AddRange(Main.SData.MonsterList.ToArray());
            Main.MapF.MonsterCombo.SelectedItem = null;
            Main.MapF.MonsterCombo.Text = "";
            Main.MapF.SpawnManager.Refresh();

            if (MonsterList.SelectedItems.Count == 0)
                tabControl1.Hide();
            else
                tabControl1.Show();
        }

        private void NewMonster_Click(object sender, EventArgs e)
        {
            Main.SData.MonsterList.Add(new MonsterInfo());
            SortList();
            RefreshLists();

            if (MonsterList.SelectedItems.Count == 0)
                tabControl1.Hide();
            else
                tabControl1.Show();
        }

        private void Gold_TextChanged(object sender, EventArgs e)
        {
            if (Gold.Text == "#####") return;
            if (Selecting) return;
            long I;
            if (long.TryParse(Gold.Text, out I))
            {
                Gold.BackColor = Color.White;
                Gold.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.Gold = I;
            }
            else
            {
                Gold.BackColor = Color.RosyBrown;
                Gold.ForeColor = Color.White;
            }

        }

        private void GoldChance_TextChanged(object sender, EventArgs e)
        {
            if (GoldChance.Text == "#####") return;
            if (Selecting) return;
            double I;
            if ((double.TryParse(GoldChance.Text, out I)) && I > 0)
            {
                GoldChance.BackColor = Color.White;
                GoldChance.ForeColor = Color.Black;

                foreach (MonsterInfo MI in MonsterList.SelectedItems)
                    MI.GoldRate = 1 / I;
            }
            else
            {
                GoldChance.BackColor = Color.RosyBrown;
                GoldChance.ForeColor = Color.White;
            }

        }

        private void DropChance_Leave(object sender, EventArgs e)
        {
            if (DropChance.Text == "#####") return;
            if (Selecting) return;
            double I;
            if ((double.TryParse(DropChance.Text, out I)) && I > 0)
            {
                DropChance.BackColor = Color.White;
                DropChance.ForeColor = Color.Black;

                (DropList.SelectedItem as DropInfo).Chance = 1 / I;
                RefreshDropList();

            }
            else
            {
                DropChance.BackColor = Color.RosyBrown;
                DropChance.ForeColor = Color.White;
            }
        }

        private void DropAmount_Leave(object sender, EventArgs e)
        {
            if (DropAmount.Text == "#####") return;
            if (Selecting) return;
            ushort I;
            if (ushort.TryParse(DropAmount.Text, out I))
            {
                DropAmount.BackColor = Color.White;
                DropAmount.ForeColor = Color.Black;

                (DropList.SelectedItem as DropInfo).Amount = I;
                RefreshDropList();

            }
            else
            {
                DropAmount.BackColor = Color.RosyBrown;
                DropAmount.ForeColor = Color.White;
            }
        }

        private void DropEnabled_CheckedChanged(object sender, EventArgs e)
        {
            if (Selecting) return;
            (DropList.SelectedItem as DropInfo).Enabled = DropEnabled.Checked;
            RefreshDropList();
        }

        private void ItemCombo_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (Selecting) return;
            (DropList.SelectedItem as DropInfo).Item = ItemCombo.SelectedItem as ItemInfo;
            RefreshDropList();

        }

        private void AddDrop_Click(object sender, EventArgs e)
        {
            (MonsterList.SelectedItem as MonsterInfo).DropList.Add(new DropInfo());
            DropManager.Refresh();

            if (Selecting)
            {
                ClearDropInterface();
                FillDropInterface();
            }
            else
            {
                Selecting = true;
                ClearDropInterface();
                FillDropInterface();
                Selecting = false;
            }

            if (DropList.SelectedItem != null)
                panel1.Enabled = true;
            else
                panel1.Enabled = false;
        }

        private void DeleteDrop_Click(object sender, EventArgs e)
        {
            (MonsterList.SelectedItem as MonsterInfo).DropList.Remove(DropList.SelectedItem as DropInfo);
            DropManager.Refresh();

            if (Selecting)
            {
                ClearDropInterface();
                FillDropInterface();
            }
            else
            {
                Selecting = true;
                ClearDropInterface();
                FillDropInterface();
                Selecting = false;
            }

            if (DropList.SelectedItem != null)
                panel1.Enabled = true;
            else
                panel1.Enabled = false;
        }

        public void RefreshDropList()
        {
            int I = DropList.SelectedIndex;
            DropManager.Refresh();
            DropList.SelectedIndex = I;
        }
        public void ClearDropInterface()
        {
            DropChance.Text = "";
            DropAmount.Text = "";
            DropEnabled.Checked = false;
            ItemCombo.SelectedItem = null;
            ItemCombo.Text = "";
        }
        public void FillDropInterface()
        {
            DropInfo DI;
            if ((DI = DropList.SelectedItem as DropInfo) != null)
            {
                DropChance.Text = DI.Chance > 0 ? ((int)(1 / DI.Chance)).ToString() : "0";
                DropAmount.Text = DI.Amount.ToString();
                DropEnabled.Checked = DI.Enabled;
                ItemCombo.SelectedItem = DI.Item;
            }
        }

        private void DropList_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (Selecting)
            {
                ClearDropInterface();
                FillDropInterface();
            }
            else
            {
                Selecting = true;
                ClearDropInterface();
                FillDropInterface();
                Selecting = false;
            }
        }

        private void CopyMonster_Click(object sender, EventArgs e)
        {
            foreach (MonsterInfo MI in MonsterList.SelectedItems)
                Main.SData.MonsterList.Add(MI.DeepClone());

            RefreshLists();
        }
    }
}
